
		

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                    S y m b O S   -   C o n s t a n t s                     @
;@                                                                            @
;@             (c) 2000-2008 by Prodatron / SymbiosiS (Jörn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;P R O C E S S - I D S
.PRC_ID_KERNEL   equ 95   ;kernel proces
.PRC_ID_DESKTOP  equ 2   ;desktop manager process
.PRC_ID_SYSTEM   equ 3   ;system manager process
;M E S S A G E S
;General
.MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself
.MSC_GEN_FOCUS   equ 255 ;application is beeing asked, to focus its window

;Kernel Commands
.MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
.MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
.MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
.MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
.MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
.MSC_KRL_MTWAKP  equ 6   ;wake up process
.MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
.MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
.MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)

;Kernel Responses
.MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELP  equ 130 ;process has been deleted
.MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELT  equ 132 ;timer has been removed
.MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
.MSR_KRL_MTWAKP  equ 134 ;process has been waked up
.MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
.MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
.MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted

;System Commands
.MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
.MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
.MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
.MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
.MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
.MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
.MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
.MSC_SYS_SYSOFF  equ 23  ;shut down (-)
.MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
.MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
.MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSC_SYS_SYSHLP  equ 27  ;start help (-)
.MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
.MSC_SYS_SYSWRN  equ 29  ;open message/confirm window (P1/2=adresse, P3=ram bank, P4=number of buttons)
.MSC_SYS_PRGSRV  equ 30  ;shared service function (P4=type [0=search, 1=start, 2=release], P1/2=addresse 12char ID, P3=ram bank 12char ID or P3=program ID, if type=2)
.MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)

;System Responses
.MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading  [P8=filemanager error code], 4=memory full, P8=app ID, P9=process ID)
.MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSR_SYS_SYSWRN  equ 157 ;message/confirm window response (P1 -> 0=already in use, 1=opened [P2=number], 2=ok, 3=yes, 4=no, 5=cancel/close)
.MSR_SYS_PRGSRV  equ 158 ;shared service function response (P1=state [5=not found, other codes see MSR_SYS_PRGRUN], P8=app ID, P9=process ID)
.MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, modal window has been opened [P2=number])

;Desktop Commands
.MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
.MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
.MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
.MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
.MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
.MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
.MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
.MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
.MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
.MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
.MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
.MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/-Num/Objekt, P3=Object) [always]
.MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
.MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
.MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Ylen) [always]
.MSC_DSK_WINSIN  equ 51  ;redraw content of a super control (P1=window ID, P2=super control ID, P3=SubObject) [always]
.MSC_DSK_MENCTX  equ 52  ;opens context menu (P1=ram bank, P2/3=address data record, P4/5=Xbeg [-1=mouse position], P6/7=Ybeg) ##!!## doc+lib
.MSC_DSK_STIADD  equ 53  ;adds systray-icon (P1=ram bank, P2/3=address, P4=ID)
.MSC_DSK_STIREM  equ 54  ;removes systray-icon (P1=number)
.MSC_DSK_STIUPD  equ 55  ;updates systray-icon (P1=number)

;Desktop Responses
.MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
.MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
.MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
.MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
.MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])
.MSR_DSK_WRESIZ  equ 166 ;window has been resized (P1=window number)
.MSR_DSK_WSCROL  equ 167 ;window content has been scrolled (P1=window number)
.MSR_DSK_MENCTX  equ 168 ;menu has been clicked or canceld (P1=1 ok, P2/3=value, P4=type [0=normal, 1=check]) ##!!## doc+lib
.MSR_DSK_STIADD  equ 169 ;result of adding systray-icon (P1=1 ok, P2=number)
.MSR_DSK_STICLK  equ 170 ;systray-icon has been clicked (P1=ID)

.MSR_DSK_EXTDSK  equ 191 ;command for extended desktop (used internally; P1=command, P2-x=parameters)

.FNC_DXT_DSKBGR  equ 001 ;background has been updated
.FNC_DXT_FILRUN  equ 002 ;file has been opened via prgrun (P2/3=address, P4=bank)
.FNC_DXT_FILBRW  equ 003 ;file has been selected via file browser (P2/3=address, P4=bank)
.FNC_DXT_MENCLK  equ 004 ;startmenu has been clicked (P2/3=value)
.FNC_DXT_DSKCLK  equ 005 ;desktop window has been clicked (P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)

;Shell Commands
.MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
.MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
.MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
.MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
.MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)
.MSC_SHL_PTHADD  equ 69  ;add additional path to current one (P1=base path, P3=addition path, P5=final path, P7=ram bank)

;Shell Responses
.MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
.MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
.MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
.MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)
.MSR_SHL_PTHADD  equ 197 ;path has been combined (P1=total end address, P3=directory end address, P5=flags)

;Screensaver Messages
.MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
.MSC_SAV_START   equ 2   ;start screen saver
.MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
.MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])


;D E S K T O P - A C T I O N S
.DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
.DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
.DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
.DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
.DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)

.DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
.DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
.DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
.DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
.DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
.DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)


;D E S K T O P - S E R V I C E S
.DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode, P3=virtual desktop)
.DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode, P3=virtual desktop)
.DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
.DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
.DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
.DSK_SRV_DSKCNT  equ 6   ;continue desktop
.DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
.DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
.DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop
.DSK_SRV_DSKOPN  equ 11  ;open desktop background window


;C L I P B O A R D - T Y P E S
.CLPTYP_TEXT     equ 1   ;plain text
.CLPTYP_GRAPHIC  equ 2   ;graphic with extended header
.CLPTYP_ITEMS    equ 3   ;item list (*not defined yet*)
.CLPTYP_ICON     equ 4   ;desktop icon shortcut


;J U M P S
.jmp_memsum  equ #8100 ;MEMSUM
.jmp_sysinf  equ #8103 ;SYSINF
.jmp_clcnum  equ #8106 ;CLCNUM
.jmp_mtgcnt  equ #8109 ;MTGCNT
.jmp_timget  equ #810C ;TIMGET
.jmp_timset  equ #810F ;TIMSET
.jmp_memget  equ #8118 ;MEMGET
.jmp_memfre  equ #811B ;MEMFRE
.jmp_memsiz  equ #811E ;MEMSIZ
.jmp_meminf  equ #8121 ;MEMINF
.jmp_bnkrwd  equ #8124 ;BNKRWD
.jmp_bnkwwd  equ #8127 ;BNKWWD
.jmp_bnkrbt  equ #812A ;BNKRBT
.jmp_bnkwbt  equ #812D ;BNKWBT
.jmp_bnkcop  equ #8130 ;BNKCOP
.jmp_bnkget  equ #8133 ;BNKGET
                      ;**empty**
.jmp_scrget  equ #8139 ;SCRGET
.jmp_mosget  equ #813C ;MOSGET
.jmp_moskey  equ #813F ;MOSKEY
.jmp_bnk16c  equ #8142 ;BNK16C
.jmp_keytst  equ #8145 ;KEYTST
.jmp_keysta  equ #8148 ;KEYSTA
.jmp_keyput  equ #814B ;KEYPUT
.jmp_bufput  equ #814E ;BUFPUT
.jmp_bufget  equ #8151 ;BUFGET
.jmp_bufsta  equ #8154 ;BUFSTA
.jmp_iominp  equ #8157 ;IOMINP (cpc only)
.jmp_iomout  equ #815a ;IOMOUT (cpc only)

.jmp_bnkcll  equ #ff03 ;BNKCLL
.jmp_bnkret  equ #ff00 ;BNKRET


;Filemanager Functions (call via MSC_SYS_SYSFIL)
.FNC_FIL_STOINI  equ 000 ;Storage Init (Removes all mass storage devices)
.FNC_FIL_STONEW  equ 001 ;Storage New (Adds a new mass storage device)
.FNC_FIL_STORLD  equ 002 ;Storage Reload (Reloads a mass storage device, if its "removeable media" status is activated)
.FNC_FIL_STODEL  equ 003 ;Storage Delete (Removes an existing mass storage device)
.FNC_FIL_STOINP  equ 004 ;Storage ReadSector (Reads a sector from a mass storage device (no memory banking))
.FNC_FIL_STOOUT  equ 005 ;Storage WriteSector (Write a sector to a mass storage device (no memory banking))
.FNC_FIL_STOACT  equ 006 ;Storage Activate (Loads the format and the file system type of a mass storage device)
.FNC_FIL_STOINF  equ 007 ;Storage Information (Returns information about a mass storage device)
.FNC_FIL_STOTRN  equ 008 ;Storage DataTransfer (Reads or writes a number of sectors (512 bytes) from/to the mass storage device)

.FNC_FIL_DEVDIR  equ 013 ;
.FNC_FIL_DEVINI  equ 014 ;
.FNC_FIL_DEVSET  equ 015 ;

.FNC_FIL_FILINI  equ 016 ;File Init (Initialises the whole file manager)
.FNC_FIL_FILNEW  equ 017 ;File New (Creates a new file and opens it for read/write access)
.FNC_FIL_FILOPN  equ 018 ;File Open (Opens an existing file for read/write access)
.FNC_FIL_FILCLO  equ 019 ;File Close (Closes an opened file)
.FNC_FIL_FILINP  equ 020 ;File Input (Reads a specified amount of bytes out of an opened file)
.FNC_FIL_FILOUT  equ 021 ;File Output (Writes a specified amount of bytes into an opened file)
.FNC_FIL_FILPOI  equ 022 ;File Pointer (Moves the file pointer to another position)
.FNC_FIL_FILF2T  equ 023 ;File Decode Timestamp (Decodes the file timestamp, which is used for the file system)
.FNC_FIL_FILT2F  equ 024 ;File Encode Timestamp (Encodes the file timestamp, which is used for the file system)
.FNC_FIL_FILLIN  equ 025 ;File LineInput (Reads one text line out of an opened file)

.FNC_FIL_DIRDEV  equ 032 ;Directory Device (Selects the current drive)
.FNC_FIL_DIRPTH  equ 033 ;Directory Path (Selects the current path for the current or a different drive)
.FNC_FIL_DIRPRS  equ 034 ;Directory Property Set (Changes a property of a file or a directory)
.FNC_FIL_DIRPRR  equ 035 ;Directory Property Get (Reads a property of a file or a directory)
.FNC_FIL_DIRREN  equ 036 ;Directory Rename (Renames a file or a directory)
.FNC_FIL_DIRNEW  equ 037 ;Directory New (Creates a new directory)
.FNC_FIL_DIRINP  equ 038 ;Directory Input (Reads the content of a directory)
.FNC_FIL_DIRDEL  equ 039 ;Directory Delete (Deletes one or more files)
.FNC_FIL_DIRRMD  equ 040 ;Directory Delete Directory (Deletes a sub directory)
.FNC_FIL_DIRMOV  equ 041 ;Directory Move (Moves a file or sub directory into another directory of the same drive)
.FNC_FIL_DIRINF  equ 042 ;Directory Drive Information (Returns information about one drive)

;Network Daemon Functions
.FNC_NET_CFGGET  equ 001 ;config information
.FNC_NET_CFGSET  equ 002 ;config setting

.FNC_NET_TCPOPN  equ 016 ;TCP open
.FNC_NET_TCPCLO  equ 017 ;TCP close
.FNC_NET_TCPSTA  equ 018 ;TCP status
.FNC_NET_TCPRCV  equ 019 ;TCP receive
.FNC_NET_TCPSND  equ 020 ;TCP send
.FNC_NET_TCPSKP  equ 021 ;TCP skip received data
.FNC_NET_TCPFLS  equ 022 ;TCP flush send buffer
.FNC_NET_TCPDIS  equ 023 ;TCP disconnect
.MSR_NET_TCPEVT  equ 159 ;TCP event

.FNC_NET_UDPOPN  equ 032 ;UDP open
.FNC_NET_UDPCLO  equ 033 ;UDP close
.FNC_NET_UDPSTA  equ 034 ;UDP status
.FNC_NET_UDPRCV  equ 035 ;UDP receive
.FNC_NET_UDPSND  equ 036 ;UDP send
.FNC_NET_UDPSKP  equ 037 ;UDP skip received data
.MSR_NET_UDPEVT  equ 175 ;UDP event

.FNC_NET_DNSRSV  equ 112 ;DNS resolve
.FNC_NET_DNSVFY  equ 113 ;DNS verify

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 62  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatVer     equ 88  ;Version 3
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;


.ScanCode_E	equ 45

;----------------------------------------------------------------------------;
; V9990 register and port defines                                            ;
;----------------------------------------------------------------------------;

; Port defines
;.g9k_VRAM				equ	#60				; R/W
.CG9K_VRAM				equ	#ff60			; R/W
.g9k_PALETTE			equ	#61				; R/W
.CG9K_PALETTE			equ	#ff61				; R/W
.g9k_CMD_DATA			equ	#62				; R/W
.g9k_REG_DATA			equ	#63				; R/W
.CG9K_REG_DATA			equ	#ff63				; R/W
;.g9k_REG_SELECT			equ	#64				; W
.CG9K_REG_SELECT		equ	#ff64			; W
.CG9K_STATUS			equ	#ff65			; R
.g9k_INT_FLAG			equ	#66				; R/W
.g9k_SYS_CTRL			equ	#67				; W
.g9k_OUTPUT_CTRL		equ	#6F 		    ; R/W
.CG9K_OUTPUT_CTRL		equ	#ff6F 		    ; R/W

; Bit defines g9k_SYS_CTRL
.g9k_SYS_CTRL_SRS		equ	2				; Power on reset state
.g9k_SYS_CTRL_MCKIN		equ	1				; Select MCKIN terminal
.g9k_SYS_CTRL_XTAL		equ	0				; Select XTAL


G9K_INT_V_LINE_LO

; Register defines
.g9k_WRITE_ADDR			equ	0				; W
.g9k_READ_ADDR			equ	3				; W
.g9k_SCREEN_MODE0		equ	6				; R/W
.g9k_SCREEN_MODE1		equ 7				; R/W
.g9k_CTRL				equ	8				; R/W
.g9k_INT_ENABLE         equ 9       		; R/W
.g9k_INT_V_LINE_LO		equ	10				; R/W	
.g9k_INT_V_LINE_HI		equ	11				; R/W
.g9k_INT_H_LINE			equ	12				; R/W	
.g9k_PALETTE_CTRL		equ	13				; W
.g9k_PALETTE_PTR		equ	14				; W
.g9k_BACK_DROP_COLOR 	equ 15		      	; R/W
.CG9K_BACK_DROP_COLOR 	equ 15		      	; R/W
.g9k_DISPLAY_ADJUST		equ	16				; R/W
.g9k_SCROLL_LOW_Y		equ 17 			    ; R/W
.g9k_SCROLL_HIGH_Y		equ 18      		; R/W
.g9k_SCROLL_LOW_X		equ 19      		; R/W
.g9k_SCROLL_HIGH_X		equ 20      		; R/W
.g9k_SCROLL_LOW_Y_B		equ 21 				; R/W
.g9k_SCROLL_HIGH_Y_B	equ 22      		; R/W
.g9k_SCROLL_LOW_X_B		equ 23      		; R/W
.g9k_SCROLL_HIGH_X_B	equ 24      		; R/W
.g9k_PAT_GEN_TABLE   	equ 25      		; R/W
.g9k_LCD_CTRL        	equ 26      		; R/W
.g9k_PRIORITY_CTRL  	equ 27      		; R/W
.g9k_SPR_PAL_CTRL		equ	28				; W
.g9k_SC_X				equ	32				; W
.g9k_SC_Y				equ	34				; W
.g9k_DS_X				equ	36				; W
.g9k_DS_Y				equ	38				; W
.g9k_NX					equ	40				; W
.g9k_NY					equ	42				; W
.g9k_ARG				equ	44				; W
.g9k_LOP				equ	45				; W
.g9k_WRITE_MASK			equ	46				; W
.g9k_FC					equ	48				; W
.g9k_BC					equ	50				; W
.g9k_OPCODE				equ	52				; W

; Register Select options
.g9k_DIS_INC_READ		equ	64
.g9k_DIS_INC_WRITE		equ	128

; Bit defines g9k_SCREEN_MODE0 (register 6)
.g9k_SCR0_STANDBY		equ	192				; Stand by mode
.g9k_SCR0_BITMAP		equ	128				; Select Bit map mode
.g9k_SCR0_P2			equ	64				; Select P1 mode
.g9k_SCR0_P1			equ	0				; Select P1 mode
.g9k_SCR0_DTCLK			equ	32				; Master Dot clock not divided
.g9k_SCR0_DTCLK2		equ	16				; Master Dot clock divided by 2
.g9k_SCR0_DTCLK4		equ	0				; Master Dot clock divided by 4
.g9k_SCR0_XIM2048		equ	12				; Image size = 2048
.g9k_SCR0_XIM1024		equ	8				; Image size = 1024
.g9k_SCR0_XIM512		equ	4				; Image size = 512
.g9k_SCR0_XIM256		equ	0				; Image size = 256
.g9k_SCR0_16BIT			equ	3				; 16 bits/dot
.g9k_SCR0_8BIT			equ	2				; 8 bits/dot
.g9k_SCR0_4BIT			equ	1				; 4 bits/dot
.g9k_SCR0_2BIT			equ 0				; 2 bits/dot

; Bit defines g9k_SCREEN_MODE1 (register 7)
.g9k_SCR1_C25M			equ	64				; Select 640*480 mode
.g9k_SCR1_SM1			equ	32				; Selection of 263 lines during non interlace , else 262
.g9k_SCR1_SM			equ	16				; Selection of horizontal frequency 1H=fsc/227.5
.g9k_SCR1_PAL			equ	8				; Select PAL, else NTSC
.g9k_SCR1_EO			equ	4				; Select of vertical resoltion of twice the non-interlace resolution
.g9k_SCR1_IL			equ	2				; Select Interlace
.g9k_SCR1_HSCN			equ	1				; Select High scan mode

; Bit defines g9k_CTRL    (Register 8)
.g9k_CTRL_DISP			equ	128				; Display VRAM
.g9k_CTRL_DIS_SPD		equ	64				; Disable display sprite (cursor)
.g9k_CTRL_YSE			equ	32				; /YS Enable
.g9k_CTRL_VWTE			equ	16				; VRAM Serial data bus control during digitization
.g9k_CTRL_VWM			equ	8				; VRAM write control during digitization
.g9k_CTRL_DMAE			equ	4				; Enable DMAQ output
.g9k_CTRL_VRAM512		equ	2				; VRAM=512KB
.g9k_CTRL_VRAM256		equ	1				; VRAM=256KB
.g9k_CTRL_VRAM128		equ	0				; VRAM=128KB

; Bit defines g9k_INT_ENABLE (register 9)
.g9k_INT_IECE	        equ 4       		; Command end interrupt enable control
.g9k_INT_IEH	        equ 2       		; Display position interrupt enable
.g9k_INT_IEV	        equ 1       		; Int. enable during vertical retrace line interval

; Bit Defines g9k_PALETTE_CTRL  (Register 13)
.g9k_PAL_CTRL_YUV		equ	192				; YUV mode
.g9k_PAL_CTRL_YJK		equ	128				; YJK mode
.g9k_PAL_CTRL_256		equ	64				; 256 color mode
.g9k_PAL_CTRL_PAL		equ	0				; Pallete mode
.g9k_PAL_CTRL_YAE		equ	32				; Enable YUV/YJK RGB mixing mode

; Bit defines g9k_LOP           (Register 45)
.g9k_LOP_TP				equ	16
.g9k_LOP_WCSC			equ	12
.g9k_LOP_WCNOTSC		equ	3
.g9k_LOP_WCANDSC		equ	8
.g9k_LOP_WCORSC			equ	14
.g9k_LOP_WCEORSC		equ	6

; Bit defines g9k_ARG
.g9k_ARG_MAJ			equ	1
.g9k_ARG_NEG			equ	2
.g9k_ARG_DIX			equ	4
.g9k_ARG_DIY			equ	8

; Blitter Commands g9k_OPCODE    (Register 52)
.g9k_OPCODE_STOP		equ	#00				; Command being excuted is stopped 
.g9k_OPCODE_LMMC		equ	#10     		; Data is transferred from CPU to VRAM rectangle area
.g9k_OPCODE_LMMV		equ	#20     		; VRAM rectangle area is painted out
.g9k_OPCODE_LMCM		equ	#30				; VRAM rectangle area is transferred to CPU
.g9k_OPCODE_LMMM		equ	#40				; Rectangle area os transferred from VRAM to VRAM
.g9k_OPCODE_CMMC		equ	#050			; CPU character data is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMK		equ	#060			; Kanji ROM data is is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMM		equ	#070			; VRAM character data is color-developed and transferred to VRAM rectangle area 
.g9k_OPCODE_BMXL		equ	#080			; Data on VRAM linear address is transferred to VRAM rectangle area
.g9k_OPCODE_BMLX		equ	#090			; VRAM rectangle area is transferred to VRAM linear address 
.g9k_OPCODE_BMLL		equ	#0A0			; Data on VRAM linear address is transferred to VRAM linear address 
.g9k_OPCODE_LINE		equ	#0B0			; Straight line is drawer on X-Y co-ordinates
.g9k_OPCODE_SRCH		equ	#0C0			; Border color co-ordinates on X-Y are detected
.g9k_OPCODE_POINT		equ	#0D0			; Color code on specified point on X-Y is read out
.g9k_OPCODE_PSET		equ	#0E0			; Drawing is executed at drawing point on X-Y co-ordinates
.g9k_OPCODE_ADVN		equ	#0F0			; Drawing point on X-Y co-ordinates is shifted

; Bit defines g9k_STATUS
.g9k_STATUS_TR          equ 128
.g9k_STATUS_VR          equ 64
.g9k_STATUS_HR          equ 32
.g9k_STATUS_BD          equ 16
.g9k_STATUS_MSC         equ 4
.g9k_STATUS_EO          equ 2
.g9k_STATUS_CE          equ 1

; Mode select defines for SetScreenMode
.g9k_MODE_P1			equ	0				; Pattern mode 0 256 212
.g9k_MODE_P2			equ	1				; Pattern mode 1 512 212
.g9k_MODE_B1			equ	2				; Bitmap mode 1 256 212
.g9k_MODE_B2			equ	3				; Bitmap mode 2 384 240
.g9k_MODE_B3			equ	4				; Bitmap mode 3 512 212
.g9k_MODE_B4			equ	5				; Bitmap mode 4 768 240
.g9k_MODE_B5			equ	6				; Bitmap mode 5 640 400 (VGA)
.g9k_MODE_B6			equ	7				; Bitmap mode 6 640 480 (VGA)
.g9k_MODE_B7			equ	8				; Bitmap mode 7 1024 212 (Undocumented v9990 mode)

; Fixed VRAM addresses
;g9k_SCRA_PAT_NAME_TABLE EQU     07C000h
;g9k_SCRB_PAT_NAME_TABLE EQU     07E000h
;g9k_P1_SPR_ATTRIB_TABLE EQU     03FE00h
;g9k_P2_SPR_ATTRIB_TABLE EQU     07BE00h

;g9k_CURSOR0_ATTRIB      EQU     07FE00h
;g9k_CURSOR1_ATTRIB      EQU     07FE08h

;g9k_CURSOR0_PAT_DATA    EQU     07FF00h
;g9k_CURSOR1_PAT_DATA    EQU     07FF80h

.g9k_RED                 equ 32
.g9k_GREEN               equ 1024
.g9k_BLUE                equ 1


;g9k_WRITE_MASK_LAYER_A	EQU	000FFh
;g9k_WRITE_MASK_LAYER_B	EQU	0FF00h
SYMBOS_ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
.AppDataSize   dw  AppTrnBeg-AppDatBeg      ;Length of Dat
.AppTrnSize    dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
               dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "G9K Flappy              ",0
.AppIcon16     db  1
.AppIconOff    dw  Icon24_Data-AppCodBeg
.Appxxxx       db  0,0,0,0,0
.AppMemTab     db  "SymExe10"             ;File Check
.AppDataLen    equ  AppTrnBeg-AppDatBeg      ;Length of Data
.AppTrnLen     equ  AppTrnEnd-AppTrnBeg      ;Length of Transfer
.AppTrnLen2    equ  16100-AppTrnLen
.AppDataLen2    equ  16100-AppDataLen
.AppExtCode    dw  0
.AppExtData    dw  AppDataLen2
.AppExtTrans   dw  AppTrnLen2
               ds  28
.AppIcnSml    
.AppStartForm  equ 0
        db 2,8,8
      db     15,15,14,3,13,13,73,73,73,73,75,75,60,135,15,15
.AppIcnBig    
.AppIcnLrg       db 6,24,24
             db 0,0,0,0,33,236
             db 0,0,0,0,33,236
             db 0,0,0,0,97,254
             db 0,0,0,0,97,254
             db 0,0,0,0,0,0
             db 0,0,0,0,0,0
             db 0,0,0,0,0,0
             db 0,0,0,0,97,254
             db 0,0,0,0,97,254
             db 240,240,240,240,225,252
             db 240,240,240,240,225,252
             db 240,225,44,112,225,252
             db 240,135,72,176,225,252
             db 240,15,104,144,225,252
             db 225,15,60,16,225,252
             db 240,240,30,240,225,252
             db 192,16,61,255,233,252
             db 224,48,122,240,225,252
             db 240,225,61,255,225,252
             db 240,15,30,240,225,252
             db 240,240,240,240,225,252
             db 240,240,240,240,225,252
             db 15,15,15,15,45,237
             db 15,15,15,15,45,237

;*******************
;**** Code G9K *****
;*******************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****

		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer

	
		;**** Set to Full Screen
		INCLIB 	SYDESKTOP.SERVICE
		ld 		a,DSK_SRV_MODGET
        call	SyDesktop_Service
		ld		(Quig_ModeUsed),de
		ld 		a,DSK_SRV_DSKSTP
		ld 		e,1
		call 	SyDesktop_Service
;		;**** Set to G9K Mode
		INCLIB 	QUIG.G9K.SETMODE.50
		call	Quig_G9K_SETMODE_50
		
		;ld		hl,G9kInterrupt
		;ld		(#39),hl
		
		;G9KWriteReg
		ld		a,g9k_PALETTE_PTR
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		xor		a
		ld		bc,CG9K_REG_DATA
		out		(c),a
;		ld		b,196
;		.quig_fullscreenon_loop
;		out		(g9k_palette),a
;		djnz	quig_fullscreenon_loop

		ld		bc,CG9K_OUTPUT_CTRL
        out  	(c),A    	   	; Set output GFX9000	
		
		
		;Set Back/Fore Palettes
		INCLIB 	QUIG.G9K.FORE.PALETTE.SET
		call	Quig_g9k_ForeBack_Palette_Set
		
;		;**** Call Init Function
		call	qfunc_initialize
		;
;****************************************
;**** Main Application Control Loop *****
;****************************************

.Quig_Control_Loop:
		call	Quig_G9K_Top_Screen
		;INCLIB 	QUIG.G9K.VWAIT
		;call	Quig_G9K_VWait

;		ld		a,(V_App_In_Use)
;		And		a
;		jr		nz,Quig_Control_Loop_1
;		rst		#30								;Wait for message
;		ld		a,(AppPrzN)		
;      	db		#dd:ld l,a
;		db		#dd:ld h,-1
;		ld		iy,AppMsgB
;		rst		#18
;		db		#dd:dec l						;AppMsgB should be populated
;		jr		nz,Quig_Control_Loop_2			;No Message so just run Main()code.	
;#IF USENET
;		ld		a,(Quig_Net_Process)			;Get Process number (Default 255 until set)
;		cp		255							
;		jr		z,Quig_Control_Loop_99			;=255 Net not initialized so skip
;		db 		#dd:cp h
;		jp		z,Quig_Net_Event				;IXH = Process number so must be Net Event
;.Quig_Control_Loop_99:		
;#ENDIF

.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
;		Xor		a
;		ld		(V_App_In_Use),a	
		jp		Quig_Control_Loop
		
.Quig_ModeUsed:	dw	0
		


.Quig_G9K_Top_Screen:
		INCLIB 	QUIG.G9K.VWAIT
		call	Quig_G9K_VWait
		di
		INCLIB QUIG.G9K.SCROLL.A
		call	Quig_G9K_SCROLL_A
		INCLIB	QUIG.G9K.SCROLL.B
		call	Quig_G9K_SCROLL_B
		ei
		ld		a,(Quig_G9K_Map_Engine)
		and		a
		ret		z
		
		ld		a,(Quig_G9K_IntCount)
		cp		0
		jp		z,Quig_Fore_SideScroll
		cp		1
		jp		z,Quig_Back_SideScroll
		cp		2
		jp		z,Quig_Fore_VertScroll
		cp		3
		jp		z,Quig_Back_VertScroll
		
.Quig_G9K_Top_Screen_9:
		ld		a,(Quig_G9K_IntCount)
		inc		a
		and		%11
		ld		(Quig_G9K_IntCount),a
		ret

.Quig_G9K_Map_Engine:		db	0
.Quig_G9k_Meta_Count:		dw 	0
.Quig_G9k_Meta_Size:		dw	0

.Quig_MetaLoad_Handle:		db	0
.Quig_MetaLoad_VAddr:		dw	0
.Quig_LoadSize:				dw	0
.Quig_LoadMeta_Buffer:		dw	0

.Quig_G9k_MapA_Width:		dw 	0
.Quig_G9k_MapA_Height:		dw	0
.Quig_G9k_MapA_MetaWidth:	dw	0
.Quig_G9k_MapA_MetaHeight:	dw	0
.Quig_G9k_MapA_Size:		dw	0
.Quig_G9k_MapB_Width:		dw 	0
.Quig_G9k_MapB_Height:		dw	0
.Quig_G9k_MapB_MetaWidth:	dw	0
.Quig_G9k_MapB_MetaHeight:	dw	0
.Quig_G9k_MapB_Size:		dw	0
		
.Quig_G9K_IntCount:			db	0		
.Quig_G9K_ScrollA_XPos:		dw	0
.Quig_G9K_ScrollA_YPos:		dw	0
.Quig_G9K_ScrollB_XPos:		dw	0
.Quig_G9K_ScrollB_YPos:		dw	0
.Quig_G9K_ScrollA_XPosOld:	dw	0
.Quig_G9K_ScrollA_YPosOld:	dw	0
.Quig_G9K_ScrollB_XPosOld:	dw	0
.Quig_G9K_ScrollB_YPosOld:	dw	0


.Quig_G9K_Sprite_NextXPos:		dw	0
.Quig_G9K_Sprite_NextYPos:		dw	0		
.Quig_G9K_Sprite_NextPattern:	dw	0
.Quig_G9K_Sprite_NextAddr:		dw	0

.Quig_G9K_a:				dw	0
.Quig_G9K_y:				dw	0
.Quig_G9K_x:				dw	0

.Quig_G9K_GameObjDataAddr:	dw	0
.Quig_G9k_GameObjList:		ds	2048

.Quig_Fore_SideScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollA_XPosOld)					;Get Old XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old XPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_XPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Fore_SideScroll_a
		ld		de,-1
.Quig_Fore_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollA_XPos)
		ld		(Quig_G9K_ScrollA_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_F_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl
		ld		hl,(Quig_G9K_ScrollA_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32				
		dec		hl
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapA_MetaWidth)
		ld		(Quig_F_SideScroll_av+1),hl
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		
		ld		b,9
.Quig_F_SideScroll_a1:		
		push 	bc
.Quig_F_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapA_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapA_Meta	
		ld		hl,(Quig_G9K_a)
.Quig_F_SideScroll_av:		
		ld		de,0
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_F_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit		
;***********************************
.Quig_Fore_VertScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollA_YPosOld)					;Get Old YPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Fore_VertScroll_a
		ld		de,-1
.Quig_Fore_VertScroll_a:
;***************		
		ld		hl,(Quig_G9K_ScrollA_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollA_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Fore_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapA_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		;****** Get The X and convert down into across
		ld		hl,(Quig_G9K_ScrollA_XPos)			;Get the XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;Div 128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		;*****************
		ld		b,11
.Quig_Fore_VertScroll_a1:		
		push 	bc
		;***** X Increase
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		;*****
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapA_Get			;Get Metatile Number
		;***** 
.Quig_Fore_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapA_Meta			;X,Y,Address	
		;*******
		pop		bc							;Retrieve Counter
		djnz	Quig_Fore_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
;****************************		
		
.Quig_Back_SideScroll:
		INCLIB 	QUIG.G9K.MAPB.META
		INCLIB	QUIG.G9K.MAPB.GET	
		INCLIB 	QUIG.MUL16
		ld		hl,(Quig_G9K_ScrollB_XPosOld)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl
		ld		hl,(Quig_G9K_ScrollB_XPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Back_SideScroll_a
		ld		de,-2
.Quig_Back_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollB_XPos)
		ld		(Quig_G9K_ScrollB_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_Back_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl

		ld		hl,(Quig_G9K_ScrollB_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapB_MetaWidth)		
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		
		ld		b,8
.Quig_Back_SideScroll_a1:		
		push 	bc
.Quig_Back_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapB_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapB_Meta	
		ld		hl,(Quig_G9K_a)
		ld		de,(Quig_G9k_MapB_MetaWidth)
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit				
		
;***********************************
.Quig_Back_VertScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollB_YPosOld)					;Get Old YPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollB_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Back_VertScroll_a
		ld		de,-1
.Quig_Back_VertScroll_a:
;***************		
		ld		hl,(Quig_G9K_ScrollB_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollB_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Back_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapB_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		;****** Get The X and convert down into across
		ld		hl,(Quig_G9K_ScrollB_XPos)			;Get the XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;Div 128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		;*****************
		ld		b,11
.Quig_Back_VertScroll_a1:		
		push 	bc
		;***** X Increase
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		;*****
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapB_Get			;Get Metatile Number
		;***** 
.Quig_Back_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapB_Meta			;X,Y,Address	
		;*******
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
;****************************			
		
.G9kInterrupt:
		di
		
		ei
		reti
		
;**** Redirect a Clicked on Control Event		
;.Quig_Control_Event:
;		ld		a,1
;		ld		(V_App_In_Use),a
;		ld		a,(Event_Type)	 		
;	
;		cp		DSK_ACT_CLOSE
;		jp		z,Quig_End
;
;		cp		DSK_ACT_KEY
;		jp		z,Quig_Key		
;		jp		Quig_Control_Loop_1
;		
		
;*********************
;**** Key Control ****
;*********************
;.Quig_Key:
;		ld		a,(AppMsgB+4)
;		and		%10000000
;		jp		z,Quig_Content
;		jp		Quig_Control_Loop_1
;

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.Quig_End:
		INCLIB 	SYDESKTOP.SERVICE
		ld		de,(Quig_ModeUsed)
		ld		a,e
		or		%10000000
		ld		e,a
		ld 		a,DSK_SRV_MODSET
        call 	SyDesktop_Service
		
		ld 		a,DSK_SRV_DSKCNT
		call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKPLT
		call	SyDesktop_Service

		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1

;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
		
;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret
		
.Quig_Sprite_Attributes		
		ds		512		

.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255

.Quig_Directory_Error_Byte:		db	0
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_Top			equ AppTrnEnd+260+AppTrnLen2
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4

		
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0


QUIGLINE 1
// Quigs Symbos G9K Application
QUIGLINE 2
// Flappy Example simple game by Edoz IN OKTOBER 2021 with a log of help from Quigs GOD Trebmint (AKA ROB)
QUIGLINE 3
// Please don't look at the horrible code i did generate
QUIGLINE 4

QUIGLINE 5

QUIGLINE 6
Var GameOn:Int=0				//status in the game or menu's
QUIGLINE 7
Var PattsLoaded:Int=0
QUIGLINE 8
Var SkipFrame:Int=0				//When slow skipe a frame
QUIGLINE 9

QUIGLINE 10
// general counters or vars for loops
QUIGLINE 11

QUIGLINE 12
Var f:Int=0
QUIGLINE 13
Var k:Int=0
QUIGLINE 14
Var i:Int=0
QUIGLINE 15
Var g:Int=0
QUIGLINE 16
Var h:Int=0
QUIGLINE 17
Var g1:Int = 0
QUIGLINE 18
Var h1:Int=0
QUIGLINE 19

QUIGLINE 20
// Exit menu vars and X Y for mouse and Menu's
QUIGLINE 21

QUIGLINE 22
Var menuOn:Int=0
QUIGLINE 23
Var menuX:Int=64
QUIGLINE 24
Var menuY:Int=64
QUIGLINE 25
Var MouseKey:Int=0
QUIGLINE 26
Var mouseX:Int=100
QUIGLINE 27
Var mouseY:Int=100
QUIGLINE 28
Var Pauze:Int=0
QUIGLINE 29
Var PlayButtonAnimation:Int=0
QUIGLINE 30
Var getReadyAnimation:Int=0
QUIGLINE 31
Var waittostart:Int=0
QUIGLINE 32

QUIGLINE 33
// Bird vars
QUIGLINE 34

QUIGLINE 35
Var BirdX1:Int=114
QUIGLINE 36
Var BirdY1:Int=60
QUIGLINE 37
Var JumpIncrement:Int = 0
QUIGLINE 38
Var Jumping:Int=0
QUIGLINE 39
Var DoBirdAnimation:Int=0
QUIGLINE 40

QUIGLINE 41
// Pipes different vars used
QUIGLINE 42

QUIGLINE 43
Var pipe1X:Int=1
QUIGLINE 44
Var pipe1y:Int=143
QUIGLINE 45
Var Pipe1SizeGab:Int=5
QUIGLINE 46
Var Pipe1GabStart:Int=3
QUIGLINE 47
Var Top1:Int=0
QUIGLINE 48
Var Bot1:Int=0
QUIGLINE 49
Var pipe2X:Int=100
QUIGLINE 50
Var pipe2y:Int=143
QUIGLINE 51
Var Pipe2SizeGab:Int=5
QUIGLINE 52
Var Pipe2GabStart:Int=3
QUIGLINE 53
Var hasCollide:Int
QUIGLINE 54
Var Top2:Int=0
QUIGLINE 55
Var Bot2:Int=0
QUIGLINE 56
Var pipe3X:Int=200
QUIGLINE 57
Var pipe3y:Int=143
QUIGLINE 58
Var Pipe3SizeGab:Int=5
QUIGLINE 59
Var Pipe3GabStart:Int=3
QUIGLINE 60
Var Top3:Int=0
QUIGLINE 61
Var Bot3:Int=0
QUIGLINE 62
Var pipespeed:Int=1
QUIGLINE 63
Var DrawFirstLine:Int=0
QUIGLINE 64

QUIGLINE 65
// Vars for the coldide routines
QUIGLINE 66

QUIGLINE 67
Var cx1:Int=0
QUIGLINE 68
Var cy1:Int=0
QUIGLINE 69
Var cw1:Int=0
QUIGLINE 70
Var ch1:Int=0
QUIGLINE 71
Var cx2:Int=0
QUIGLINE 72
Var cy2:Int=0
QUIGLINE 73
Var cw2:Int=0
QUIGLINE 74
Var ch2:Int=0
QUIGLINE 75

QUIGLINE 76
//Score variables
QUIGLINE 77

QUIGLINE 78
Var Digit0:Int
QUIGLINE 79
Var Digit1:Int
QUIGLINE 80
Var Digit2:Int
QUIGLINE 81
Var Digit0High:Int
QUIGLINE 82
Var Digit1High:Int
QUIGLINE 83
Var Digit2High:Int
QUIGLINE 84
Var Digit0Low:Int
QUIGLINE 85
Var Digit1Low:Int
QUIGLINE 86
Var Digit2Low:Int
QUIGLINE 87
Var TopScore:Int=0
QUIGLINE 88
Var Score:Int=0
QUIGLINE 89

QUIGLINE 90
//General timers
QUIGLINE 91

QUIGLINE 92
Var waittimer:Int=0
QUIGLINE 93
Var falldown:Int=0
QUIGLINE 94
Var loading:Int=0
QUIGLINE 95

QUIGLINE 96
// Used to fade- in / out the logo during loading
QUIGLINE 97

QUIGLINE 98
Var Pal1:Int
QUIGLINE 99
Var Pal2:Int
QUIGLINE 100
Var Pal3:Int
QUIGLINE 101
Var Lev:Int
QUIGLINE 102
Var Loop:Int
QUIGLINE 103

QUIGLINE 104
//THIS is the STARTUP routine when the SymbOS app is executed
QUIGLINE 105
//After this routine the MAIN routine will be the core of the app
QUIGLINE 106
Function Initialize:Void()
QUIGLINE 107
	// Initialize G9K App
QUIGLINE 108
	// border color 0-63
QUIGLINE 109
	// clear screen and set palletes
QUIGLINE 110
	
QUIGLINE 111
	For f=240 To 255
QUIGLINE 112
		Ink.Set f,0,0,0
QUIGLINE 113
	Next
QUIGLINE 114
	
QUIGLINE 115
	Ink.Palette.Set 0,240
QUIGLINE 116
	Ink.Palette.Set 1,240
QUIGLINE 117
	Ink.Palette.Set 2,240
QUIGLINE 118
	Ink.Palette.Set 3,240
QUIGLINE 119
	
QUIGLINE 120
	BackColour.Set 5
QUIGLINE 121
	Back.Palette.Set 2
QUIGLINE 122
	Fore.Palette.Set 1
QUIGLINE 123
	
QUIGLINE 124
	//clear all sprites and set them
QUIGLINE 125
	
QUIGLINE 126
	For f=0 To 124
QUIGLINE 127
		Sprite.Palette.Set f,0
QUIGLINE 128
		Sprite.Position.Set f,200,0
QUIGLINE 129
		Sprite.Display.Set	 f,0
QUIGLINE 130
	Next
QUIGLINE 131
	
QUIGLINE 132
	Sprite.Refresh
QUIGLINE 133
	
QUIGLINE 134
	//Load splash screen
QUIGLINE 135
	PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy4.qpt",4928,32)
QUIGLINE 136
	//First fill entire map with single blank tile
QUIGLINE 137
	For f=0 To 31
QUIGLINE 138
		For g=0 To 63
QUIGLINE 139
			Fore.ScreenMap.Set 4928,g,f
QUIGLINE 140
		Next
QUIGLINE 141
	Next
QUIGLINE 142
	i=4928
QUIGLINE 143
	// First rectangle with image
QUIGLINE 144
	For f=4 To 15
QUIGLINE 145
		For g=6 To 27
QUIGLINE 146
			Fore.ScreenMap.Set i,g,f
QUIGLINE 147
			i=i+1
QUIGLINE 148
		Next
QUIGLINE 149
	Next
QUIGLINE 150
	
QUIGLINE 151
	//Fade the logo in
QUIGLINE 152
	For f=0 To 127 Step 8
QUIGLINE 153
		PalFade(32,240,128,f)
QUIGLINE 154
		Ink.Palette.Set 1,128
QUIGLINE 155
		VWait
QUIGLINE 156
	Next
QUIGLINE 157
	
QUIGLINE 158
	// set pallete for the logo
QUIGLINE 159
	
QUIGLINE 160
	Ink.Palette.Set 3,32
QUIGLINE 161
	Fore.Palette.Set 3
QUIGLINE 162
	
QUIGLINE 163
	//Startup complete (When loading is 0 it will start loading the game data in)
QUIGLINE 164
	//GameOn=0 means still loading and not ready
QUIGLINE 165
	
QUIGLINE 166
	loading=0
QUIGLINE 167
	GameOn=0
QUIGLINE 168
	
QUIGLINE 169
EndF
QUIGLINE 170

QUIGLINE 171
// Colide routine used in the game to check game- over
QUIGLINE 172
Function Collide:Int(cx1,cy1,cw1,ch1,cx2,cy2,cw2,ch2)
QUIGLINE 173
	If cx1<cx2+cw2  Then
QUIGLINE 174
		If cx1+cw1>=cx2 Then
QUIGLINE 175
			If cy1<cy2+ch2 Then
QUIGLINE 176
				If cy1+ch1>=cy2 Then
QUIGLINE 177
					Return 1
QUIGLINE 178
				EndIf
QUIGLINE 179
			EndIf
QUIGLINE 180
		EndIf
QUIGLINE 181
	EndIf
QUIGLINE 182
	Return 0
QUIGLINE 183
EndF
QUIGLINE 184

QUIGLINE 185

QUIGLINE 186
// Pal Fade routine for startup logo
QUIGLINE 187
Function PalFade:Void(Pal1,Pal2,Pal3,Lev)
QUIGLINE 188
	
QUIGLINE 189
	For Loop=0 To 15
QUIGLINE 190
		Ink.Set Pal3,Ink.Fade(Ink.Red.Get(Pal1),Ink.Red.Get(Pal2),Lev),Ink.Fade(Ink.Green.Get(Pal1),Ink.Green.Get(Pal2),Lev),Ink.Fade(Ink.Blue.Get(Pal1),Ink.Blue.Get(Pal2),Lev)
QUIGLINE 191
		Pal1=Pal1+1
QUIGLINE 192
		Pal2=Pal2+1
QUIGLINE 193
		Pal3=Pal3+1
QUIGLINE 194
	Next
QUIGLINE 195
EndF
QUIGLINE 196

QUIGLINE 197

QUIGLINE 198
// Score up routine is triggered when a pipe is passed. It will refresh the score board
QUIGLINE 199
Function ScoreUP:Void
QUIGLINE 200
	Score=Score+1
QUIGLINE 201
	If Score => TopScore	Then
QUIGLINE 202
		TopScore=Score
QUIGLINE 203
	EndIf
QUIGLINE 204
	
QUIGLINE 205
	Digit0=Digit0+1
QUIGLINE 206
	If Digit0>9 Then
QUIGLINE 207
		Digit0=0
QUIGLINE 208
		Digit1=Digit1+1
QUIGLINE 209
		If Digit1>9 Then
QUIGLINE 210
			Digit1=0
QUIGLINE 211
			Digit2=Digit2+1
QUIGLINE 212
			If Digit2>9 Then
QUIGLINE 213
				Digit2=0
QUIGLINE 214
			EndIf
QUIGLINE 215
			Sprite.Pattern.Set 52, 124+(Digit2*2)
QUIGLINE 216
			Sprite.Pattern.Set 53, 125+(Digit2*2)
QUIGLINE 217
		EndIf
QUIGLINE 218
		Sprite.Pattern.Set 50, 124+(Digit1*2)
QUIGLINE 219
		Sprite.Pattern.Set 51, 125+(Digit1*2)
QUIGLINE 220
	EndIf
QUIGLINE 221
	Sprite.Pattern.Set 48, 124+(Digit0*2)
QUIGLINE 222
	Sprite.Pattern.Set 49, 125+(Digit0*2)
QUIGLINE 223
	
QUIGLINE 224
EndF
QUIGLINE 225

QUIGLINE 226
// Reset the scoreboard to 0 and display it
QUIGLINE 227
Function DisplayAndResetScore:Void
QUIGLINE 228
	
QUIGLINE 229
	Digit0=0
QUIGLINE 230
	Digit1=0
QUIGLINE 231
	Digit2=0
QUIGLINE 232
	
QUIGLINE 233
	Sprite.Pattern.Set 48, 124+(Digit0*2)
QUIGLINE 234
	Sprite.Pattern.Set 49, 125+(Digit0*2)
QUIGLINE 235
	Sprite.Pattern.Set 50, 124+(Digit1*2)
QUIGLINE 236
	Sprite.Pattern.Set 51, 125+(Digit1*2)
QUIGLINE 237
	Sprite.Pattern.Set 52, 124+(Digit2*2)
QUIGLINE 238
	Sprite.Pattern.Set 53, 125+(Digit2*2)
QUIGLINE 239
	
QUIGLINE 240
	Sprite.Position.Set 52,104,180
QUIGLINE 241
	Sprite.Position.Set 53,104,196
QUIGLINE 242
	Sprite.Position.Set 50,120,180
QUIGLINE 243
	Sprite.Position.Set 51,120,196
QUIGLINE 244
	Sprite.Position.Set 48,136,180
QUIGLINE 245
	Sprite.Position.Set 49,136,196
QUIGLINE 246
	
QUIGLINE 247
EndF
QUIGLINE 248

QUIGLINE 249

QUIGLINE 250
// Game over, when restarting the game all defaults will be set to begin state
QUIGLINE 251
Function Restart:Void()
QUIGLINE 252
	
QUIGLINE 253
	Score=0
QUIGLINE 254
	GameOn=1
QUIGLINE 255
	waittostart=0
QUIGLINE 256
	Pauze=0
QUIGLINE 257
	BirdX1=114
QUIGLINE 258
	BirdY1=60
QUIGLINE 259
	
QUIGLINE 260
	Sprite.Pattern.Set 36,191
QUIGLINE 261
	Sprite.Pattern.Set 37,191
QUIGLINE 262
	Sprite.Pattern.Set	 110,191
QUIGLINE 263
	
QUIGLINE 264
	pipespeed=1
QUIGLINE 265
	pipe1X=1
QUIGLINE 266
	pipe1y=143
QUIGLINE 267
	pipe2X=100
QUIGLINE 268
	pipe2y=143
QUIGLINE 269
	pipe3X=200
QUIGLINE 270
	pipe3y=143
QUIGLINE 271
	Pipe1SizeGab=5
QUIGLINE 272
	Pipe1GabStart=3
QUIGLINE 273
	Pipe2SizeGab=5
QUIGLINE 274
	Pipe2GabStart=3
QUIGLINE 275
	Pipe3SizeGab=5
QUIGLINE 276
	Pipe3GabStart=3
QUIGLINE 277
	RemoveScoreBoard
QUIGLINE 278
	
QUIGLINE 279
	SetPipe1
QUIGLINE 280
	SetPipe2
QUIGLINE 281
	SetPipe3
QUIGLINE 282
	//MovePipe1
QUIGLINE 283
	Sprite.Position.Group0.Set 68,pipe1X,143,2,10
QUIGLINE 284
	//MovePipe2
QUIGLINE 285
	Sprite.Position.Group0.Set 88,pipe2X,143,2,10
QUIGLINE 286
	//MovePipe3
QUIGLINE 287
	If menuOn=0 Then
QUIGLINE 288
		If GameOn>1  Then
QUIGLINE 289
			Sprite.Position.Group0.Set 10,pipe3X,143,2,10
QUIGLINE 290
		EndIf
QUIGLINE 291
	EndIf
QUIGLINE 292
	falldown=0
QUIGLINE 293
	
QUIGLINE 294
	ShowLogo
QUIGLINE 295
	ShowTab
QUIGLINE 296
	
QUIGLINE 297
EndF
QUIGLINE 298

QUIGLINE 299

QUIGLINE 300
// Routine to load the gamedata IN
QUIGLINE 301
Function LoadGame:Void:()
QUIGLINE 302
	
QUIGLINE 303
	// Load sprites (patterns 8x8) into memory
QUIGLINE 304
	// Total of sprites are 192 (16x16) = 4x192 = 768 = now 832 patterns (starts at 0)
QUIGLINE 305
	PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy1.qpt",0,0)
QUIGLINE 306
	//Palette 0 = 0, Palette 1 =16, Palette 2=32,Palette 3=48 in g9k
QUIGLINE 307
	//Lets Set Palette 1 back to the Black Palette
QUIGLINE 308
	Ink.Palette.Set 1,240
QUIGLINE 309
	
QUIGLINE 310
	For f=0 To 124
QUIGLINE 311
		Sprite.Palette.Set f,0
QUIGLINE 312
		Sprite.Position.Set f,f,166
QUIGLINE 313
		Sprite.Pattern.Set f,191
QUIGLINE 314
	Next
QUIGLINE 315
	
QUIGLINE 316
	//Mouse and exit and pause button sprite set
QUIGLINE 317
	Sprite.Pattern.Set 0,2
QUIGLINE 318
	Sprite.Pattern.Set 1,22
QUIGLINE 319
	Sprite.Pattern.Set 2,0
QUIGLINE 320
	
QUIGLINE 321
	Sprite.Position.Set 1,2,2
QUIGLINE 322
	Sprite.Position.Set 2,238,2
QUIGLINE 323
	
QUIGLINE 324
	
QUIGLINE 325
	//Load the foreground image after the sprites. sheetsize = 512x256 that is 32x64 patterns = 2048 = (+ start pos. 768 = 2816)
QUIGLINE 326
	PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy3.qpt",832,16)
QUIGLINE 327
	//Load the background image starting at 2816
QUIGLINE 328
	PattsLoaded = Back.Pattern.Load(App.Path+ "flappy2.qpt",2880,48)
QUIGLINE 329
	
QUIGLINE 330
	
QUIGLINE 331
	//Fade out the logo as the game data was loaded
QUIGLINE 332
	For  f=127 To 0 Step -8
QUIGLINE 333
		PalFade(32,240,128,f)
QUIGLINE 334
		Ink.Palette.Set 3,128
QUIGLINE 335
		VWait
QUIGLINE 336
	Next
QUIGLINE 337
	
QUIGLINE 338
	//Copy everyting to the layer as the game data is loaded (Fore and Back layer)
QUIGLINE 339
	
QUIGLINE 340
	i=832
QUIGLINE 341
	For f=0 To 31
QUIGLINE 342
		For g=0 To 63
QUIGLINE 343
			Fore.ScreenMap.Set i,g,f
QUIGLINE 344
			i=i+1
QUIGLINE 345
		Next
QUIGLINE 346
	Next
QUIGLINE 347
	
QUIGLINE 348
	i=2880
QUIGLINE 349
	For f=0 To 31
QUIGLINE 350
		For g=0 To 63
QUIGLINE 351
			Back.ScreenMap.Set i,g,f
QUIGLINE 352
			i=i+1
QUIGLINE 353
		Next
QUIGLINE 354
	Next
QUIGLINE 355
	
QUIGLINE 356
	//Set the palletes for the layers
QUIGLINE 357
	
QUIGLINE 358
	Ink.Palette.Set 0,0
QUIGLINE 359
	Ink.Palette.Set 1,16
QUIGLINE 360
	Ink.Palette.Set 2,48
QUIGLINE 361
	
QUIGLINE 362
	Back.Palette.Set 2
QUIGLINE 363
	Fore.Palette.Set 1
QUIGLINE 364
	
QUIGLINE 365
	//Set the pipes for the first time
QUIGLINE 366
	
QUIGLINE 367
	SetPipe1
QUIGLINE 368
	MovePipe1
QUIGLINE 369
	
QUIGLINE 370
	SetPipe2
QUIGLINE 371
	MovePipe2
QUIGLINE 372
	
QUIGLINE 373
	SetPipe3
QUIGLINE 374
	MovePipe3
QUIGLINE 375
	
QUIGLINE 376
	
QUIGLINE 377
	// build up standard screen ITEMS for game start
QUIGLINE 378
	
QUIGLINE 379
	ShowTab
QUIGLINE 380
	ShowLogo
QUIGLINE 381
	
QUIGLINE 382
	// Game is loaded and ready to use
QUIGLINE 383
	loading=1
QUIGLINE 384
	GameOn=1
QUIGLINE 385
	
QUIGLINE 386
EndF
QUIGLINE 387

QUIGLINE 388
// The MAIN routine is the routine which is getting CPU time from SymbOS when the application gets CPU time from the OS
QUIGLINE 389
// It always runs in a loop. In fact it is the core routine of the application
QUIGLINE 390
Function Main:Void()
QUIGLINE 391
	
QUIGLINE 392
	// Checking game loading and status and start actions on triggers
QUIGLINE 393
	
QUIGLINE 394
	If loading=0 Then
QUIGLINE 395
		loading=3
QUIGLINE 396
		LoadGame
QUIGLINE 397
	EndIf
QUIGLINE 398
	
QUIGLINE 399
	If loading=1 Then
QUIGLINE 400
		
QUIGLINE 401
		// Animation for the Play Button routine
QUIGLINE 402
		If GameOn=1 And menuOn=0 Then
QUIGLINE 403
			
QUIGLINE 404
			PlayButtonAnimation=PlayButtonAnimation+1
QUIGLINE 405
			If PlayButtonAnimation=20 Then
QUIGLINE 406
				RemovePlay
QUIGLINE 407
			Else
QUIGLINE 408
				If PlayButtonAnimation = 40 Then
QUIGLINE 409
					ShowPlay
QUIGLINE 410
					PlayButtonAnimation=0
QUIGLINE 411
				EndIf
QUIGLINE 412
			EndIf
QUIGLINE 413
		EndIf
QUIGLINE 414
		
QUIGLINE 415
		// Animation for the get ready logo
QUIGLINE 416
		If GameOn=4 Then
QUIGLINE 417
			getReadyAnimation=getReadyAnimation+1
QUIGLINE 418
			If getReadyAnimation=10 Then
QUIGLINE 419
				RemoveGetReady
QUIGLINE 420
			Else
QUIGLINE 421
				If getReadyAnimation = 20 Then
QUIGLINE 422
					ShowGetReady
QUIGLINE 423
					getReadyAnimation=0
QUIGLINE 424
				EndIf
QUIGLINE 425
			EndIf
QUIGLINE 426
			
QUIGLINE 427
		EndIf
QUIGLINE 428
		
QUIGLINE 429
		
QUIGLINE 430
		// Read the mouse status from the OS (Does it once per routine to save time)
QUIGLINE 431
		
QUIGLINE 432
		mouseX = Mouse.X
QUIGLINE 433
		mouseY = Mouse.Y
QUIGLINE 434
		MouseKey = Mouse.Key
QUIGLINE 435
		
QUIGLINE 436
		// mouse should not go out of the window
QUIGLINE 437
		
QUIGLINE 438
		mouseX = Max(3,Min(mouseX,250))
QUIGLINE 439
		mouseY = Max(3,Min(mouseY,203))
QUIGLINE 440
		Sprite.Position.Set 0,mouseX,mouseY
QUIGLINE 441
		
QUIGLINE 442
		// Show Exit menu
QUIGLINE 443
		If GameOn=1 And menuOn=0 Then
QUIGLINE 444
			// Mouse Click will start the game
QUIGLINE 445
			If MouseKey = 1 Then
QUIGLINE 446
				If Collide(mouseX,mouseY,10,10,97,120,64,32)=1  Then
QUIGLINE 447
					RemovePlay
QUIGLINE 448
					//RemoveTab as the game starts
QUIGLINE 449
					Sprite.Pattern.Set 36,174
QUIGLINE 450
					Sprite.Pattern.Set 37,175
QUIGLINE 451
					Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
QUIGLINE 452
					ShowGetReady
QUIGLINE 453
					DisplayAndResetScore
QUIGLINE 454
					pipespeed=4
QUIGLINE 455
					GameOn=2
QUIGLINE 456
				EndIf
QUIGLINE 457
			EndIf
QUIGLINE 458
		EndIf
QUIGLINE 459
		
QUIGLINE 460
		If menuOn=0 Then
QUIGLINE 461
			//Right click will show the exit menu
QUIGLINE 462
			If MouseKey = 1 And menuOn=0 And Collide(mouseX,mouseY,10,10,238,2,20,20)=1 Then
QUIGLINE 463
				menuOn=1
QUIGLINE 464
			EndIf
QUIGLINE 465
			
QUIGLINE 466
			// Pauze the game used the button
QUIGLINE 467
			If MouseKey = 1 And menuOn=0 And Collide(mouseX,mouseY,10,10,2,2,20,20)=1 Then
QUIGLINE 468
				If Pauze=1 Then
QUIGLINE 469
					Pauze=0
QUIGLINE 470
					Sprite.Pattern.Set 1,22
QUIGLINE 471
				Else
QUIGLINE 472
					Pauze=1
QUIGLINE 473
					Sprite.Pattern.Set 1,24
QUIGLINE 474
				EndIf
QUIGLINE 475
				MouseKey=0
QUIGLINE 476
			EndIf
QUIGLINE 477
		Else
QUIGLINE 478
			If menuOn=2 Then
QUIGLINE 479
				//Exit the game as the user ends the game
QUIGLINE 480
				If MouseKey=1 And  menuOn=2 And Collide(mouseX,mouseY,10,10,menuX+96,menuY+48,32,10)=1 Then
QUIGLINE 481
					App.Exit
QUIGLINE 482
				EndIf
QUIGLINE 483
				//Cancel Exit the game by closing the exit menu with the cross
QUIGLINE 484
				If MouseKey=1 And  menuOn=2 And Collide(mouseX,mouseY,10,10,menuX+110,menuY,20,20)=1 Then
QUIGLINE 485
					RemoveMenu
QUIGLINE 486
					menuX=64
QUIGLINE 487
					menuY=64
QUIGLINE 488
					If GameOn= 6 Then
QUIGLINE 489
						ShowScoreBoard
QUIGLINE 490
					EndIf
QUIGLINE 491
					menuOn=0
QUIGLINE 492
				EndIf
QUIGLINE 493
				
QUIGLINE 494
				//Moving the menu on the screen when pickedup with the mouse by the user
QUIGLINE 495
				
QUIGLINE 496
				If MouseKey=1  And Collide(menuX,menuY,104,10,mouseX,mouseY,104,10)=1 Then
QUIGLINE 497
					menuX=mouseX-50
QUIGLINE 498
					menuY=mouseY-4
QUIGLINE 499
					Sprite.Position.Group.Set 3,menuX,menuY,8,4
QUIGLINE 500
					
QUIGLINE 501
				EndIf
QUIGLINE 502
				
QUIGLINE 503
			EndIf
QUIGLINE 504
			
QUIGLINE 505
			If menuOn=1 Then
QUIGLINE 506
				menuOn=2
QUIGLINE 507
				ShowMenu
QUIGLINE 508
			EndIf
QUIGLINE 509
			
QUIGLINE 510
		EndIf
QUIGLINE 511
		// scroll the layers in the screen
QUIGLINE 512
		//		Fore.Scroll	 g,40
QUIGLINE 513
		//		Back.Scroll 	Shr1(h),60+Shr4(BirdY1)
QUIGLINE 514
		//		Sprite.Refresh
QUIGLINE 515
		
QUIGLINE 516
		
QUIGLINE 517
		Fore.Scroll	 Shl2(g),160
QUIGLINE 518
		Back.Scroll 	Shl2(Shr1(h)),Shl2(60+Shr4(BirdY1))
QUIGLINE 519
		Sprite.Refresh
QUIGLINE 520
		
QUIGLINE 521
		g=(g+3)  And 511				;Layer 1 scroll moves left but wraps 512
QUIGLINE 522
		h=(h+1)  And  1023				;Layer B scroll moves left but wraps 1024 as /2 for half speed
QUIGLINE 523
		
QUIGLINE 524
		// This game is initiate to start (state 4) remove the game menu items with delay and set the pipe speed
QUIGLINE 525
		
QUIGLINE 526
		If GameOn=4 Then
QUIGLINE 527
			waittostart=waittostart+1
QUIGLINE 528
			
QUIGLINE 529
			If waittostart=>150 Then
QUIGLINE 530
				waittostart=0
QUIGLINE 531
				GameOn=5
QUIGLINE 532
				RemoveGetReady
QUIGLINE 533
				RemoveTab
QUIGLINE 534
				pipespeed=2
QUIGLINE 535
				
QUIGLINE 536
			EndIf
QUIGLINE 537
		EndIf
QUIGLINE 538
		
QUIGLINE 539
		If GameOn=3 Then
QUIGLINE 540
			If MouseKey=1 Then
QUIGLINE 541
				GameOn=4
QUIGLINE 542
			EndIf
QUIGLINE 543
		EndIf
QUIGLINE 544
		
QUIGLINE 545
		If GameOn=6 And menuOn=0  Then
QUIGLINE 546
			If  MouseKey=2 Then
QUIGLINE 547
				Restart
QUIGLINE 548
			EndIf
QUIGLINE 549
			
QUIGLINE 550
			If falldown=1 Then
QUIGLINE 551
				BirdY1=BirdY1+2
QUIGLINE 552
				Sprite.Pattern.Set 36,204
QUIGLINE 553
				Sprite.Pattern.Set 37,191
QUIGLINE 554
				Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
QUIGLINE 555
				If BirdY1=>145 Then
QUIGLINE 556
					falldown=3
QUIGLINE 557
					Sprite.Pattern.Set	 110,204
QUIGLINE 558
					Sprite.Position.Set  110,BirdX1,BirdY1
QUIGLINE 559
					RemovePipe
QUIGLINE 560
					ShowScoreBoard
QUIGLINE 561
				EndIf
QUIGLINE 562
				
QUIGLINE 563
			EndIf
QUIGLINE 564
			
QUIGLINE 565
			If  falldown=3 Then
QUIGLINE 566
				waittostart=waittostart+1
QUIGLINE 567
				If waittostart=>500 Then
QUIGLINE 568
					waittostart=0
QUIGLINE 569
					Restart
QUIGLINE 570
				EndIf
QUIGLINE 571
			EndIf
QUIGLINE 572
			
QUIGLINE 573
		EndIf
QUIGLINE 574
		
QUIGLINE 575
		
QUIGLINE 576
		If GameOn=5  Then
QUIGLINE 577
			
QUIGLINE 578
			If MouseKey =1 And menuOn=0  Then
QUIGLINE 579
				// Jump the Bird when pressing the mouse key (if no exit menu is activated)
QUIGLINE 580
				
QUIGLINE 581
				If BirdX1<mouseX Then
QUIGLINE 582
					BirdX1=BirdX1+1
QUIGLINE 583
				Else
QUIGLINE 584
					BirdX1=BirdX1-1
QUIGLINE 585
				EndIf
QUIGLINE 586
				
QUIGLINE 587
			EndIf
QUIGLINE 588
			
QUIGLINE 589
			If MouseKey = 1 And Jumping=0 Then
QUIGLINE 590
				JumpIncrement = -9
QUIGLINE 591
				Jumping=1
QUIGLINE 592
			EndIf
QUIGLINE 593
			If JumpIncrement<1 Then
QUIGLINE 594
				JumpIncrement=JumpIncrement+1
QUIGLINE 595
			EndIf
QUIGLINE 596
			If Jumping = 1 And JumpIncrement>0 Then
QUIGLINE 597
				Jumping =0
QUIGLINE 598
			EndIf
QUIGLINE 599
			BirdY1=BirdY1+JumpIncrement
QUIGLINE 600
			
QUIGLINE 601
			If menuOn=0 Then
QUIGLINE 602
				Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
QUIGLINE 603
			EndIf
QUIGLINE 604
			
QUIGLINE 605
			// Animation of the bird during the gameplay
QUIGLINE 606
			
QUIGLINE 607
			BirdY1=BirdY1+1
QUIGLINE 608
			Sprite.Pattern.Set 36,174+k
QUIGLINE 609
			Sprite.Pattern.Set 37,175+k
QUIGLINE 610
			
QUIGLINE 611
			If  DoBirdAnimation=0 Then
QUIGLINE 612
				k=k+2
QUIGLINE 613
				If k=6 Then
QUIGLINE 614
					k=0
QUIGLINE 615
				EndIf
QUIGLINE 616
			EndIf
QUIGLINE 617
			
QUIGLINE 618
			DoBirdAnimation=DoBirdAnimation	+1
QUIGLINE 619
			
QUIGLINE 620
			If DoBirdAnimation= 10 Then
QUIGLINE 621
				DoBirdAnimation=0
QUIGLINE 622
			EndIf
QUIGLINE 623
			
QUIGLINE 624
			// Check bird position in the play field
QUIGLINE 625
			// Bouderies of the play area and when hasColiide initate the gameover
QUIGLINE 626
			
QUIGLINE 627
			hasCollide=0
QUIGLINE 628
			
QUIGLINE 629
			If BirdY1 => 150 Then
QUIGLINE 630
				BirdY1= 150
QUIGLINE 631
				hasCollide=1
QUIGLINE 632
			EndIf
QUIGLINE 633
			
QUIGLINE 634
			If BirdY1 =< 1 Then
QUIGLINE 635
				BirdY1=1
QUIGLINE 636
			EndIf
QUIGLINE 637
			
QUIGLINE 638
			
QUIGLINE 639
			//check collisions against the pipes
QUIGLINE 640
			
QUIGLINE 641
			
QUIGLINE 642
			If Collide(BirdX1,BirdY1,5,5,pipe1X,8,16,Top1-2)=1 Then
QUIGLINE 643
				hasCollide=1
QUIGLINE 644
			EndIf
QUIGLINE 645
			If Collide(BirdX1,BirdY1,5,5,pipe2X,8,16,Top2-2)=1 Then
QUIGLINE 646
				hasCollide=1
QUIGLINE 647
			EndIf
QUIGLINE 648
			If Collide(BirdX1,BirdY1,5,5,pipe3X,8,16,Top3-2)=1 Then
QUIGLINE 649
				hasCollide=1
QUIGLINE 650
			EndIf
QUIGLINE 651
			If Collide(BirdX1,BirdY1,5,5,pipe1X,Bot1,16,140)=1 Then
QUIGLINE 652
				hasCollide=1
QUIGLINE 653
			EndIf
QUIGLINE 654
			If Collide(BirdX1,BirdY1,5,5,pipe2X,Bot2,16,140)=1 Then
QUIGLINE 655
				hasCollide=1
QUIGLINE 656
			EndIf
QUIGLINE 657
			If Collide(BirdX1,BirdY1,5,5,pipe3X,Bot3,16,140)=1 Then
QUIGLINE 658
				hasCollide=1
QUIGLINE 659
			EndIf
QUIGLINE 660
			
QUIGLINE 661
			// There was a game over as there was a collide
QUIGLINE 662
			
QUIGLINE 663
			If hasCollide = 1  Then
QUIGLINE 664
				Sprite.Pattern.Set 36,180
QUIGLINE 665
				Sprite.Pattern.Set 37,181
QUIGLINE 666
				ShowGameOver
QUIGLINE 667
				falldown=1
QUIGLINE 668
				GameOn=6
QUIGLINE 669
				Pauze=1
QUIGLINE 670
				
QUIGLINE 671
			EndIf
QUIGLINE 672
		EndIf
QUIGLINE 673
		
QUIGLINE 674
		If menuOn=0 And Pauze=0  Then
QUIGLINE 675
			
QUIGLINE 676
			// Random pipe opening per pipe when exit the screen during scrolling
QUIGLINE 677
			// There was no level implemented, this could be by making the pipe openings smaller during the game time.
QUIGLINE 678
			// if the game is not starten (GameOn=2) then the pipes are all open the same
QUIGLINE 679
			If GameOn=2 Then
QUIGLINE 680
				GameOn=3
QUIGLINE 681
				Pipe1GabStart = 2
QUIGLINE 682
				Pipe1SizeGab =  6
QUIGLINE 683
				SetPipe1
QUIGLINE 684
				
QUIGLINE 685
				Pipe2GabStart = 2
QUIGLINE 686
				Pipe2SizeGab =  6
QUIGLINE 687
				SetPipe2
QUIGLINE 688
				
QUIGLINE 689
				Pipe3GabStart = 2
QUIGLINE 690
				Pipe3SizeGab =  6
QUIGLINE 691
				SetPipe3
QUIGLINE 692
				
QUIGLINE 693
				getReadyAnimation=0
QUIGLINE 694
			Else
QUIGLINE 695
				// The game is started it will take a RND for every pipe opening (when out of the screen = -32)
QUIGLINE 696
				
QUIGLINE 697
				If GameOn=5 Then
QUIGLINE 698
					If pipe1X=< -32 Then
QUIGLINE 699
						
QUIGLINE 700
						i=Rnd(5)
QUIGLINE 701
						If i <1 Then
QUIGLINE 702
							i=1
QUIGLINE 703
						EndIf
QUIGLINE 704
						Pipe1GabStart = i
QUIGLINE 705
						Pipe1SizeGab = 5
QUIGLINE 706
						SetPipe1
QUIGLINE 707
						ScoreUP
QUIGLINE 708
						pipe1X = 256
QUIGLINE 709
					EndIf
QUIGLINE 710
					
QUIGLINE 711
					
QUIGLINE 712
					If pipe2X=< -32 Then
QUIGLINE 713
						
QUIGLINE 714
						i=Rnd(5)
QUIGLINE 715
						If i <1 Then
QUIGLINE 716
							i=1
QUIGLINE 717
						EndIf
QUIGLINE 718
						Pipe2GabStart = i
QUIGLINE 719
						Pipe2SizeGab = 4
QUIGLINE 720
						SetPipe2
QUIGLINE 721
						ScoreUP
QUIGLINE 722
						pipe2X = 256
QUIGLINE 723
					EndIf
QUIGLINE 724
					
QUIGLINE 725
					If pipe3X=< -32 Then
QUIGLINE 726
						
QUIGLINE 727
						i=Rnd(5)
QUIGLINE 728
						If i <1 Then
QUIGLINE 729
							i=1
QUIGLINE 730
						EndIf
QUIGLINE 731
						Pipe3GabStart = i
QUIGLINE 732
						Pipe3SizeGab = 4
QUIGLINE 733
						SetPipe3
QUIGLINE 734
						ScoreUP
QUIGLINE 735
						pipe3X = 256
QUIGLINE 736
					EndIf
QUIGLINE 737
				EndIf
QUIGLINE 738
			EndIf
QUIGLINE 739
			
QUIGLINE 740
			//Move the pipes as they are sprites untill -32 then set them back to the beginning of the screen
QUIGLINE 741
			
QUIGLINE 742
			If pipe1X=< -32 Then
QUIGLINE 743
				pipe1X = 256
QUIGLINE 744
			EndIf
QUIGLINE 745
			If pipe2X=< -32 Then
QUIGLINE 746
				pipe2X = 256
QUIGLINE 747
			EndIf
QUIGLINE 748
			If pipe3X=< -32 Then
QUIGLINE 749
				pipe3X = 256
QUIGLINE 750
			EndIf
QUIGLINE 751
			
QUIGLINE 752
			
QUIGLINE 753
			// derminate the speed of the moving sprites
QUIGLINE 754
			
QUIGLINE 755
			pipe1X=pipe1X-pipespeed
QUIGLINE 756
			pipe2X=pipe2X-pipespeed
QUIGLINE 757
			pipe3X=pipe3X-pipespeed
QUIGLINE 758
			
QUIGLINE 759
			MovePipe1
QUIGLINE 760
			MovePipe2
QUIGLINE 761
			MovePipe3
QUIGLINE 762
			
QUIGLINE 763
		EndIf
QUIGLINE 764
		
QUIGLINE 765
	EndIf
QUIGLINE 766
	
QUIGLINE 767
EndF
QUIGLINE 768

QUIGLINE 769

QUIGLINE 770
// set Pipe1 before displaying it
QUIGLINE 771
Function SetPipe1:Void()
QUIGLINE 772
	
QUIGLINE 773
	Pipe1GabStart = Pipe1GabStart *2
QUIGLINE 774
	Pipe1SizeGab = Pipe1SizeGab *2
QUIGLINE 775
	
QUIGLINE 776
	
QUIGLINE 777
	For i=68 To 86 Step 2
QUIGLINE 778
		Sprite.Pattern.Set i,12
QUIGLINE 779
		Sprite.Pattern.Set i+1,13
QUIGLINE 780
	Next
QUIGLINE 781
	
QUIGLINE 782
	// Top up
QUIGLINE 783
	Sprite.Pattern.Set 68+Pipe1GabStart,10
QUIGLINE 784
	Sprite.Pattern.Set 68+Pipe1GabStart+1,11
QUIGLINE 785
	
QUIGLINE 786
	//Top Down
QUIGLINE 787
	Sprite.Pattern.Set 68+Pipe1GabStart+Pipe1SizeGab,112
QUIGLINE 788
	Sprite.Pattern.Set 68+Pipe1GabStart+Pipe1SizeGab+1,113
QUIGLINE 789
	
QUIGLINE 790
	// Clear open part
QUIGLINE 791
	For i=Pipe1GabStart  +2 To Pipe1SizeGab+Pipe1GabStart-1
QUIGLINE 792
		Sprite.Pattern.Set	 68+i,219
QUIGLINE 793
	Next
QUIGLINE 794
	Top1=155-((Pipe1SizeGab+Pipe1GabStart)*8)
QUIGLINE 795
	Bot1=143 -((Pipe1GabStart)*8)
QUIGLINE 796
	
QUIGLINE 797
	
QUIGLINE 798
EndF
QUIGLINE 799

QUIGLINE 800
// Move the pipe as a group of sprites
QUIGLINE 801
Function MovePipe1:Void()
QUIGLINE 802
	
QUIGLINE 803
	Sprite.Position.Group0.Set 68,pipe1X,143,2,10
QUIGLINE 804
	
QUIGLINE 805
EndF
QUIGLINE 806

QUIGLINE 807

QUIGLINE 808
// set Pipe2 before displaying it
QUIGLINE 809
Function SetPipe2:Void()
QUIGLINE 810
	
QUIGLINE 811
	Pipe2GabStart = Pipe2GabStart *2
QUIGLINE 812
	Pipe2SizeGab = Pipe2SizeGab *2
QUIGLINE 813
	
QUIGLINE 814
	For i=88 To 106 Step 2
QUIGLINE 815
		Sprite.Pattern.Set i,12
QUIGLINE 816
		Sprite.Pattern.Set i+1,13
QUIGLINE 817
	Next
QUIGLINE 818
	
QUIGLINE 819
	// Top up
QUIGLINE 820
	Sprite.Pattern.Set 88+Pipe2GabStart,10
QUIGLINE 821
	Sprite.Pattern.Set 88+Pipe2GabStart+1,11
QUIGLINE 822
	
QUIGLINE 823
	//Top Down
QUIGLINE 824
	Sprite.Pattern.Set 88+Pipe2GabStart+Pipe2SizeGab,112
QUIGLINE 825
	Sprite.Pattern.Set 88+Pipe2GabStart+Pipe2SizeGab+1,113
QUIGLINE 826
	
QUIGLINE 827
	// clear open part
QUIGLINE 828
	
QUIGLINE 829
	For i=Pipe2GabStart +2 To Pipe2SizeGab+Pipe2GabStart-1
QUIGLINE 830
		Sprite.Pattern.Set	 88+i,219
QUIGLINE 831
	Next
QUIGLINE 832
	Top2=155-((Pipe2SizeGab+Pipe2GabStart)*8)
QUIGLINE 833
	Bot2=143 -((Pipe2GabStart)*8)
QUIGLINE 834
	
QUIGLINE 835
EndF
QUIGLINE 836

QUIGLINE 837
// Move pipe 2 as a group of sprites
QUIGLINE 838
Function MovePipe2:Void()
QUIGLINE 839
	
QUIGLINE 840
	Sprite.Position.Group0.Set 88,pipe2X,143,2,10
QUIGLINE 841
	
QUIGLINE 842
EndF
QUIGLINE 843

QUIGLINE 844

QUIGLINE 845
// set Pipe3 before displaying it
QUIGLINE 846
// Pipe 3 is special, as it will only be shown during the game if the game is not
QUIGLINE 847
// running the sprites for pipe3 are used for the menu's in the game as we have only limited amount of sprites
QUIGLINE 848
// i desided to use the sprites for pipe3 as well for the menus
QUIGLINE 849
Function SetPipe3:Void()
QUIGLINE 850
	
QUIGLINE 851
	If menuOn=0 And GameOn>1  Then
QUIGLINE 852
		
QUIGLINE 853
		Pipe3GabStart = Pipe3GabStart *2
QUIGLINE 854
		Pipe3SizeGab = Pipe3SizeGab *2
QUIGLINE 855
		
QUIGLINE 856
		For i=10 To 28 Step 2
QUIGLINE 857
			Sprite.Pattern.Set i,12
QUIGLINE 858
			Sprite.Pattern.Set i+1,13
QUIGLINE 859
			Sprite.Display.Set i,0
QUIGLINE 860
			Sprite.Display.Set i+1,0
QUIGLINE 861
		Next
QUIGLINE 862
		
QUIGLINE 863
		// Top up
QUIGLINE 864
		Sprite.Pattern.Set 10+Pipe3GabStart,10
QUIGLINE 865
		Sprite.Pattern.Set 10+Pipe3GabStart+1,11
QUIGLINE 866
		
QUIGLINE 867
		//Top Down
QUIGLINE 868
		Sprite.Pattern.Set 10+Pipe3GabStart+Pipe3SizeGab,112
QUIGLINE 869
		Sprite.Pattern.Set 10+Pipe3GabStart+Pipe3SizeGab+1,113
QUIGLINE 870
		
QUIGLINE 871
		// clear open part
QUIGLINE 872
		
QUIGLINE 873
		For i=Pipe3GabStart +2 To Pipe3SizeGab+Pipe3GabStart-1
QUIGLINE 874
			Sprite.Pattern.Set	 10+i,219
QUIGLINE 875
		Next
QUIGLINE 876
		Top3=155-((Pipe3SizeGab+Pipe3GabStart)*8)
QUIGLINE 877
		Bot3=143 -((Pipe3GabStart)*8)
QUIGLINE 878
		
QUIGLINE 879
		
QUIGLINE 880
	EndIf
QUIGLINE 881
	
QUIGLINE 882
	
QUIGLINE 883
EndF
QUIGLINE 884

QUIGLINE 885
// Move pipe 3 as a group of sprites
QUIGLINE 886
Function MovePipe3:Void()
QUIGLINE 887
	If menuOn=0 And GameOn>1  Then
QUIGLINE 888
		Sprite.Position.Group0.Set 10,pipe3X,143,2,10
QUIGLINE 889
	EndIf
QUIGLINE 890
	
QUIGLINE 891
EndF
QUIGLINE 892

QUIGLINE 893
// Menu item Show
QUIGLINE 894
Function ShowGetReady:Void
QUIGLINE 895
	f=56
QUIGLINE 896
	For i=98 To 109
QUIGLINE 897
		Sprite.Pattern.Set	 f,i
QUIGLINE 898
		f=f+1
QUIGLINE 899
	Next
QUIGLINE 900
	
QUIGLINE 901
	Sprite.Position.Group.Set 56,81,30,6,2
QUIGLINE 902
EndF
QUIGLINE 903

QUIGLINE 904
// Menu item Show
QUIGLINE 905
Function ShowGameOver:Void
QUIGLINE 906
	
QUIGLINE 907
	f=56
QUIGLINE 908
	For i=144 To 155
QUIGLINE 909
		Sprite.Pattern.Set	 f,i
QUIGLINE 910
		f=f+1
QUIGLINE 911
	Next
QUIGLINE 912
	
QUIGLINE 913
	Sprite.Position.Group.Set 56,81,30,6,2
QUIGLINE 914
	
QUIGLINE 915
EndF
QUIGLINE 916

QUIGLINE 917
// Menu item Show
QUIGLINE 918
Function ShowPlay:Void
QUIGLINE 919
	
QUIGLINE 920
	f=48
QUIGLINE 921
	For i=164 To 171
QUIGLINE 922
		Sprite.Pattern.Set	 f,i
QUIGLINE 923
		f=f+1
QUIGLINE 924
	Next
QUIGLINE 925
	
QUIGLINE 926
	Sprite.Position.Group.Set 48,97,120,4,2
QUIGLINE 927
	
QUIGLINE 928
EndF
QUIGLINE 929

QUIGLINE 930
// Menu item Show
QUIGLINE 931
Function RemovePlay:Void
QUIGLINE 932
	
QUIGLINE 933
	For i=48 To 55
QUIGLINE 934
		Sprite.Pattern.Set	 i,191
QUIGLINE 935
		Sprite.Position.Set i,1,166
QUIGLINE 936
	Next
QUIGLINE 937
	
QUIGLINE 938
EndF
QUIGLINE 939

QUIGLINE 940
// Menu item Show
QUIGLINE 941
Function RemoveGetReady:Void
QUIGLINE 942
	
QUIGLINE 943
	For i=56 To 67
QUIGLINE 944
		Sprite.Pattern.Set	 i,191
QUIGLINE 945
		Sprite.Position.Set i,1,166
QUIGLINE 946
	Next
QUIGLINE 947
	
QUIGLINE 948
EndF
QUIGLINE 949

QUIGLINE 950
// Menu item Show
QUIGLINE 951
Function ShowTab:Void
QUIGLINE 952
	
QUIGLINE 953
	Sprite.Pattern.Set	 40,3
QUIGLINE 954
	Sprite.Pattern.Set 41,4
QUIGLINE 955
	Sprite.Pattern.Set	 42,7
QUIGLINE 956
	Sprite.Pattern.Set 43,8
QUIGLINE 957
	Sprite.Pattern.Set	 44,6
QUIGLINE 958
	Sprite.Pattern.Set 45,5
QUIGLINE 959
	Sprite.Pattern.Set 46,173
QUIGLINE 960
	Sprite.Pattern.Set 47,172
QUIGLINE 961
	
QUIGLINE 962
	Sprite.Position.Set 40,95,100
QUIGLINE 963
	Sprite.Position.Set 41,111,100
QUIGLINE 964
	Sprite.Position.Set 42,133,100
QUIGLINE 965
	Sprite.Position.Set 43,149,100
QUIGLINE 966
	Sprite.Position.Set 44,122,100
QUIGLINE 967
	Sprite.Position.Set 45,122,84
QUIGLINE 968
	Sprite.Position.Set 46,130,60
QUIGLINE 969
	Sprite.Position.Set 47,114,60
QUIGLINE 970
	
QUIGLINE 971
EndF
QUIGLINE 972

QUIGLINE 973
// Menu item Show
QUIGLINE 974
Function RemoveTab:Void
QUIGLINE 975
	
QUIGLINE 976
	For i=40 To 47
QUIGLINE 977
		Sprite.Pattern.Set	 i,191
QUIGLINE 978
		Sprite.Position.Set i,1,166
QUIGLINE 979
	Next
QUIGLINE 980
	
QUIGLINE 981
EndF
QUIGLINE 982

QUIGLINE 983
// Menu item Show
QUIGLINE 984
Function ShowMenu:Void
QUIGLINE 985
	f=34
QUIGLINE 986
	For i=3 To 34
QUIGLINE 987
		Sprite.Pattern.Set i,f
QUIGLINE 988
		f=f+1
QUIGLINE 989
	Next
QUIGLINE 990
	
QUIGLINE 991
	Sprite.Position.Group.Set 3,64,64,8,4
QUIGLINE 992
EndF
QUIGLINE 993

QUIGLINE 994
// Menu item Show
QUIGLINE 995
Function RemoveMenu:Void
QUIGLINE 996
	For i=3 To 34
QUIGLINE 997
		Sprite.Pattern.Set i,191
QUIGLINE 998
		Sprite.Position.Set i,1,166
QUIGLINE 999
	Next
QUIGLINE 1000
EndF
QUIGLINE 1001

QUIGLINE 1002
// Menu item Show
QUIGLINE 1003
Function RemovePipe:Void
QUIGLINE 1004
	For i=68 To 86 Step 2
QUIGLINE 1005
		Sprite.Pattern.Set i,191
QUIGLINE 1006
		Sprite.Pattern.Set i+1,191
QUIGLINE 1007
	Next
QUIGLINE 1008
	
QUIGLINE 1009
	For i=88 To 106 Step 2
QUIGLINE 1010
		Sprite.Pattern.Set i,191
QUIGLINE 1011
		Sprite.Pattern.Set i+1,191
QUIGLINE 1012
	Next
QUIGLINE 1013
	
QUIGLINE 1014
	For i=10 To 28 Step 2
QUIGLINE 1015
		Sprite.Pattern.Set i,191
QUIGLINE 1016
		Sprite.Pattern.Set i+1,191
QUIGLINE 1017
	Next
QUIGLINE 1018
EndF
QUIGLINE 1019

QUIGLINE 1020
// Menu item Show
QUIGLINE 1021
Function ShowLogo:Void
QUIGLINE 1022
	f=56
QUIGLINE 1023
	For i=192 To 203
QUIGLINE 1024
		Sprite.Pattern.Set	 f,i
QUIGLINE 1025
		f=f+1
QUIGLINE 1026
	Next
QUIGLINE 1027
	Sprite.Position.Group.Set 56,81,30,6,2
QUIGLINE 1028
EndF
QUIGLINE 1029

QUIGLINE 1030
// Menu item Show
QUIGLINE 1031
Function ShowScoreBoard:Void
QUIGLINE 1032
	f=66
QUIGLINE 1033
	For i=13 To 44
QUIGLINE 1034
		Sprite.Pattern.Set i,f
QUIGLINE 1035
		f=f+1
QUIGLINE 1036
	Next
QUIGLINE 1037
	
QUIGLINE 1038
	Sprite.Position.Group.Set 13,64,64,8,4
QUIGLINE 1039
	
QUIGLINE 1040
	If Score =>0 And Score<=10 Then
QUIGLINE 1041
		f=18
QUIGLINE 1042
		For i=3 To 6
QUIGLINE 1043
			Sprite.Pattern.Set i,f
QUIGLINE 1044
			f=f+1
QUIGLINE 1045
		Next
QUIGLINE 1046
		Sprite.Position.Group.Set 3,82,80,2,2
QUIGLINE 1047
	EndIf
QUIGLINE 1048
	
QUIGLINE 1049
	
QUIGLINE 1050
	If Score =>11 And Score<=20 Then
QUIGLINE 1051
		f=160
QUIGLINE 1052
		For i=3 To 6
QUIGLINE 1053
			Sprite.Pattern.Set i,f
QUIGLINE 1054
			f=f+1
QUIGLINE 1055
		Next
QUIGLINE 1056
		Sprite.Position.Group.Set 3,82,80,2,2
QUIGLINE 1057
	EndIf
QUIGLINE 1058
	
QUIGLINE 1059
	If Score =>21 And Score<=30 Then
QUIGLINE 1060
		f=14
QUIGLINE 1061
		For i=3 To 6
QUIGLINE 1062
			Sprite.Pattern.Set i,f
QUIGLINE 1063
			f=f+1
QUIGLINE 1064
		Next
QUIGLINE 1065
		Sprite.Position.Group.Set 3,82,80,2,2
QUIGLINE 1066
	EndIf
QUIGLINE 1067
	
QUIGLINE 1068
	If Score =>31  Then
QUIGLINE 1069
		f=156
QUIGLINE 1070
		For i=3 To 6
QUIGLINE 1071
			Sprite.Pattern.Set i,f
QUIGLINE 1072
			f=f+1
QUIGLINE 1073
		Next
QUIGLINE 1074
		Sprite.Position.Group.Set 3,82,80,2,2
QUIGLINE 1075
	EndIf
QUIGLINE 1076
	
QUIGLINE 1077
	//score translated to sprites patterns
QUIGLINE 1078
	
QUIGLINE 1079
	Digit0Low =  Score Mod 10
QUIGLINE 1080
	Digit1Low=	 (Score/10) Mod 10
QUIGLINE 1081
	Digit2Low=	(Score/100) Mod 10
QUIGLINE 1082
	
QUIGLINE 1083
	Sprite.Pattern.Set 7,114+Digit2Low
QUIGLINE 1084
	Sprite.Pattern.Set 8,114+Digit1Low
QUIGLINE 1085
	Sprite.Pattern.Set 9,114+Digit0Low
QUIGLINE 1086
	Sprite.Position.Set 7, 143,81
QUIGLINE 1087
	Sprite.Position.Set 8, 153,81
QUIGLINE 1088
	Sprite.Position.Set 9, 163,81
QUIGLINE 1089
	
QUIGLINE 1090
	//Highscore
QUIGLINE 1091
	
QUIGLINE 1092
	Digit0High=  TopScore Mod 10
QUIGLINE 1093
	Digit1High= (TopScore/10) Mod 10
QUIGLINE 1094
	Digit2High=(TopScore/100) Mod 10
QUIGLINE 1095
	
QUIGLINE 1096
	
QUIGLINE 1097
	Sprite.Pattern.Set 10,114+Digit2High
QUIGLINE 1098
	Sprite.Pattern.Set 11,114+Digit1High
QUIGLINE 1099
	Sprite.Pattern.Set 12,114+Digit0High
QUIGLINE 1100
	
QUIGLINE 1101
	Sprite.Position.Set 10, 143,102
QUIGLINE 1102
	Sprite.Position.Set 11, 153,102
QUIGLINE 1103
	Sprite.Position.Set 12, 163,102
QUIGLINE 1104
	
QUIGLINE 1105
EndF
QUIGLINE 1106

QUIGLINE 1107
// Menu item Show
QUIGLINE 1108
Function RemoveScoreBoard:Void()
QUIGLINE 1109
	For i=3 To 44
QUIGLINE 1110
		Sprite.Pattern.Set i,191
QUIGLINE 1111
		Sprite.Position.Set i,1,166
QUIGLINE 1112
	Next
QUIGLINE 1113
EndF
QUIGLINE 1114

QUIGLINE 1115
// Menu item Show
QUIGLINE 1116
Function RemoveLogo:Void
QUIGLINE 1117
	For i=192 To 203
QUIGLINE 1118
		Sprite.Pattern.Set	 i,191
QUIGLINE 1119
		Sprite.Position.Set i,1,166
QUIGLINE 1120
	Next
QUIGLINE 1121
EndF
QUIGLINE 1122

QUIGLINE 1123
// End of the demo game, thanks for reading



    ASM
;**** Core End
.Quig_CodeEnd:db 0
;**********************
;**** Data Section ****
;**********************
.AppDatBeg
.AppFormStart:    dw Form1_Begin
.AppFormLists
    dw Form1_ControlWindowData
;**** Form Icon Data ***
;**** Form Icon ***
.Form1_Icon:
        db 2,8,8
     db #0F,#0F,#3F,#CF,#7F,#EF,#6F,#6F,#6F,#67,#7F,#23,#3F,#89,#0F,#0F
;**** Define User Graphics ****
.Icon24_Data
.Icon24_Data_WidthByte:     db 12
.Icon24_Data_WidthPixel:    db 24
.Icon24_Data_Height:        db 24
.Icon24_Data_DataAddr:      dw Icon24_Data_Data
.Icon24_Data_EncodeAddr:    dw Icon24_Data_Encode
.Icon24_Data_Size:          dw 288
.Icon24_Data_Encode:        db 5
.Icon24_Data_Data:          
             db 68,68,68,68,68,68,68,68,68,86,119,84
             db 68,68,68,68,68,68,68,68,68,86,119,84
             db 68,72,132,68,68,68,68,68,69,86,119,117
             db 68,136,136,68,68,136,136,68,69,86,119,117
             db 68,68,68,68,68,68,136,68,68,68,68,68
             db 68,68,68,68,68,68,68,68,68,68,136,68
             db 68,68,68,68,68,68,68,68,68,68,68,68
             db 68,68,136,132,68,68,68,68,69,86,119,117
             db 68,68,68,68,68,68,68,68,69,86,119,117
             db 153,153,153,153,153,153,153,153,149,86,119,85
             db 153,153,153,145,17,17,25,153,153,86,119,89
             db 153,153,145,18,34,24,129,153,153,86,119,89
             db 153,153,18,34,33,136,24,25,153,86,119,89
             db 153,145,34,34,33,216,24,129,153,86,119,89
             db 153,18,34,34,34,29,136,129,153,86,119,89
             db 153,17,17,25,34,33,17,17,25,86,119,89
             db 145,136,136,129,34,31,255,255,241,86,119,89
             db 145,216,136,209,33,241,17,17,25,86,119,89
             db 153,17,17,18,34,31,255,255,25,86,119,89
             db 153,145,34,34,34,33,17,17,153,86,119,89
             db 153,153,17,17,17,25,153,153,153,86,119,89
             db 153,153,153,153,153,153,153,153,153,86,119,89
             db 170,170,170,170,170,170,170,170,170,86,119,90
             db 170,170,170,170,170,170,170,170,170,86,119,90
.Sheet_Data4:                   
.Sheet_Data4_WidthByte:     db 2
.Sheet_Data4_WidthPixel:    db 1
.Sheet_Data4_Height:        db 1
.Sheet_Data4_DataAddr:      dw Sheet_Data4_Data
.Sheet_Data4_EncodeAddr:    dw Sheet_Data4_Encode
.Sheet_Data4_Size:          dw 1
.Sheet_Data4_Encode:        db 0
.Sheet_Data4_Data:          dw 0
;**** Define User Variables ****
.File_Select_Text:   dw File_Select_Text_Data+4
.Directory_Select_Text:   dw Directory_Select_Text_Data+4
.var_wrd_GameOn:   dw 0
.var_wrd_PattsLoaded:   dw 0
.var_wrd_SkipFrame:   dw 0
.var_wrd_f:   dw 0
.var_wrd_k:   dw 0
.var_wrd_i:   dw 0
.var_wrd_g:   dw 0
.var_wrd_h:   dw 0
.var_wrd_g1:   dw 0
.var_wrd_h1:   dw 0
.var_wrd_menuOn:   dw 0
.var_wrd_menuX:   dw 64
.var_wrd_menuY:   dw 64
.var_wrd_MouseKey:   dw 0
.var_wrd_mouseX:   dw 100
.var_wrd_mouseY:   dw 100
.var_wrd_Pauze:   dw 0
.var_wrd_PlayButtonAnimation:   dw 0
.var_wrd_getReadyAnimation:   dw 0
.var_wrd_waittostart:   dw 0
.var_wrd_BirdX1:   dw 114
.var_wrd_BirdY1:   dw 60
.var_wrd_JumpIncrement:   dw 0
.var_wrd_Jumping:   dw 0
.var_wrd_DoBirdAnimation:   dw 0
.var_wrd_pipe1X:   dw 1
.var_wrd_pipe1y:   dw 143
.var_wrd_Pipe1SizeGab:   dw 5
.var_wrd_Pipe1GabStart:   dw 3
.var_wrd_Top1:   dw 0
.var_wrd_Bot1:   dw 0
.var_wrd_pipe2X:   dw 100
.var_wrd_pipe2y:   dw 143
.var_wrd_Pipe2SizeGab:   dw 5
.var_wrd_Pipe2GabStart:   dw 3
.var_wrd_hasCollide:   dw 0
.var_wrd_Top2:   dw 0
.var_wrd_Bot2:   dw 0
.var_wrd_pipe3X:   dw 200
.var_wrd_pipe3y:   dw 143
.var_wrd_Pipe3SizeGab:   dw 5
.var_wrd_Pipe3GabStart:   dw 3
.var_wrd_Top3:   dw 0
.var_wrd_Bot3:   dw 0
.var_wrd_pipespeed:   dw 1
.var_wrd_DrawFirstLine:   dw 0
.var_wrd_cx1:   dw 0
.var_wrd_cy1:   dw 0
.var_wrd_cw1:   dw 0
.var_wrd_ch1:   dw 0
.var_wrd_cx2:   dw 0
.var_wrd_cy2:   dw 0
.var_wrd_cw2:   dw 0
.var_wrd_ch2:   dw 0
.var_wrd_Digit0:   dw 0
.var_wrd_Digit1:   dw 0
.var_wrd_Digit2:   dw 0
.var_wrd_Digit0High:   dw 0
.var_wrd_Digit1High:   dw 0
.var_wrd_Digit2High:   dw 0
.var_wrd_Digit0Low:   dw 0
.var_wrd_Digit1Low:   dw 0
.var_wrd_Digit2Low:   dw 0
.var_wrd_TopScore:   dw 0
.var_wrd_Score:   dw 0
.var_wrd_waittimer:   dw 0
.var_wrd_falldown:   dw 0
.var_wrd_loading:   dw 0
.var_wrd_Pal1:   dw 0
.var_wrd_Pal2:   dw 0
.var_wrd_Pal3:   dw 0
.var_wrd_Lev:   dw 0
.var_wrd_Loop:   dw 0
;Spongebob
;**** String Data ****
.Quigs_String_Data_Start:
.File_Select_Text_Data:         dw File_Select_Text:dw 1:db 0
.Directory_Select_Text_Data:    dw Directory_Select_Text:dw 1:db 0
.Quig_Dialog_1_Data:            dw Quig_Dialog_1:dw 1:db 0
.Quig_Dialog_2_Data:            dw Quig_Dialog_2:dw 1:db 0
.Quig_Dialog_3_Data:            dw Quig_Dialog_3:dw 1:db 0
.Form1_Text_Data:               dw Form1_Text:dw 7:db "Form 1",0
.Form1_Status_Text_Data:        dw Form1_Status_Text:dw 1:db 0
.Quig_String_Count   Equ 7
.Quig_String_End_Text:   db  0,0,0,0,0


;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    256
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;0 Message No 16
.Event_Form_ID       db 0         ;1 Event happned on which Form
.Event_Type          db 0         ;2 Type of Event
.Event_UserInput     db 0         ;3 Key or Mouse Event
.Event_Key_ASCII                  ; Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;4 MouseX when event happens
.Event_MouseY        dw 0         ;6 MouseY when event happens
.Event_Control_ID    dw 0         ;8 Control ID No
.Event_8             db 0         ;10
.Event_9             db 0         ;11
.Event_10            db 0         ;12
.Event_11            db 0         ;13
.Quig_Machine_Type   db 0    ;0=464, 1=664, 2=6128, 3=464Plus, 4=6128Plus 6=Enterprise 64/128 7=MSX1 8=MSX2, 9=MSX2+, 10=MSX TurboR 12=PCW8xxx, 13=PCW9xxx
.Quig_Null_String    db 0
;**** Dialog Transfer ****
.Quig_Dialog_1:      dw Quig_Dialog_1_Data+4,6
.Quig_Dialog_2:      dw Quig_Dialog_2_Data+4,6
.Quig_Dialog_3:      dw Quig_Dialog_3_Data+4,6
.Quig_Dialog_4:      dw AppIcnLrg
.App_Form_List
       dw  Form1_Begin,0,0,0,0,0,0,Form1
.ControWindowDataList
     dw Form1_ControlWindowData
     dw Form1_ControlToolData
;***
;**** Z80 version of Form Form1 ***
;***
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 92
.Form1_SizeAdjust:              db 20
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 0
.Form1_Top:                     dw 0
.Form1_Width:                   dw 200
.Form1_Height:                  dw 122
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 191
.Form1_ContentHeight:           dw 122
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 1024
.Form1_MaxHeight:               dw 212
.Form1_IconAddr:                dw 0
.Form1_Text:                    dw Form1_Text_Data+4
.Form1_Status_Text:             dw Form1_Status_Text_Data+4
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  0
     ds 140,0                   ;Symbos Reserved
.Form1_Menu_List:               
.Form1_Menu:                    

        dw  0

;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 1
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** Object Window Background Data Record ****
dw 0,255*256+0,2,  0,0,1000,1000,0
;****
;**** Data Control Record (ControlTool) ****
;****
.Form1_ControlTool:             
.Form1_ControlToolCount:        db 1
.Form1_ControlToolOwnerID:      db 0
.Form1_ControlToolDataAddr:     dw Form1_ControlToolData
.Form1_ControlToolCalcAddr:     dw 0; Form1_ControlToolCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlToolFocus:        db 0
     db 0
;****
.Form1_ControlToolData:         
;**** Object Window Background Data Record ****
dw 0,255*256+0,2,  0,0,1000,1000,0
.SyStud_TimerRoutines    dw 0
.Quig_File_Select_Ext          ds 4
.Quig_File_Select_File         ds 256
.AppTrnEnd


