
;*******************
;**** Code G9K *****
;*******************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****

		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer

	#IF USETIMER	
		;**** Sets up the Timer Stack ****
		ld		hl,Quig_TimerStack
		ld		a,(AppBnkNum)
		ld		e,7
		call	SyKernel_MTADDT
  		jp      c,Quig_End
       	ld      (PrgPstSpz+AppCodBeg),a
	#ENDIF
	
		;**** Set to Full Screen
		INCLIB 	SYDESKTOP.SERVICE
		ld 		a,DSK_SRV_MODGET
        call	SyDesktop_Service
		ld		(Quig_ModeUsed),de
		ld 		a,DSK_SRV_DSKSTP
		ld 		e,1
		call 	SyDesktop_Service
;		;**** Set to G9K Mode
		INCLIB 	QUIG.G9K.SETMODE.50
		call	Quig_G9K_SETMODE_50
		
		;ld		hl,G9kInterrupt
		;ld		(#39),hl
		
		;G9KWriteReg
		ld		a,g9k_PALETTE_PTR
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		xor		a
		ld		bc,CG9K_REG_DATA
		out		(c),a
;		ld		b,196
;		.quig_fullscreenon_loop
;		out		(g9k_palette),a
;		djnz	quig_fullscreenon_loop

		ld		bc,CG9K_OUTPUT_CTRL
        out  	(c),A    	   	; Set output GFX9000	
		
		
		;Set Back/Fore Palettes
		INCLIB 	QUIG.G9K.FORE.PALETTE.SET
		call	Quig_g9k_ForeBack_Palette_Set
		
;		;**** Call Init Function
		call	qfunc_initialize
		;
;****************************************
;**** Main Application Control Loop *****
;****************************************

.Quig_Control_Loop:
		call	Quig_G9K_Top_Screen
		;INCLIB 	QUIG.G9K.VWAIT
		;call	Quig_G9K_VWait

;		ld		a,(V_App_In_Use)
;		And		a
;		jr		nz,Quig_Control_Loop_1
;		rst		#30								;Wait for message
;		ld		a,(AppPrzN)		
;      	db		#dd:ld l,a
;		db		#dd:ld h,-1
;		ld		iy,AppMsgB
;		rst		#18
;		db		#dd:dec l						;AppMsgB should be populated
;		jr		nz,Quig_Control_Loop_2			;No Message so just run Main()code.	
;#IF USENET
;		ld		a,(Quig_Net_Process)			;Get Process number (Default 255 until set)
;		cp		255							
;		jr		z,Quig_Control_Loop_99			;=255 Net not initialized so skip
;		db 		#dd:cp h
;		jp		z,Quig_Net_Event				;IXH = Process number so must be Net Event
;.Quig_Control_Loop_99:		
;#ENDIF

.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
;		Xor		a
;		ld		(V_App_In_Use),a	
		jp		Quig_Control_Loop
		
.Quig_ModeUsed:	dw	0
		
#IF USENET		
;**** NET EVENTS		
.Quig_Net_Event:
;		INCLIB   QUIG.NET.TCP.FIND.FREE.HANDLE
;		INCLIB   QUIG.NET.TCP.SOCKET.COUNT
        call 	snwmsgo_afbcdehlixiy
		ld		(Quig_Event_Net_Handle),a
		ld		a,l
		ld		(Quig_Event_Net),a
		
		ld		(Quig_Net_Received_Value),bc
		
		ld		a,(Quig_Event_Net)
		cp		2					;tcpestablished
		jp		z,Quig_Found_TCP_Establish
		cp		128
		jp		z,Quig_Found_Data_Received
		cp		3
		jp		z,Quig_Found_Data_Received		
		cp		4
		jp		z,Quig_Found_Data_Received
		
		jp		Quig_Control_Loop_2

.Quig_Found_Data_Received:
		jp		Quig_Net_Event6
		
.Quig_Found_TCP_Establish:
		ld		(Quig_Event_Net_Port),de
		ld		(Quig_Event_Net_IXIY),ix
		ld		(Quig_Event_Net_IXIY+2),iy
.Quig_Net_Event6:		
		call 	QFunc_Net_Event	
.Quig_Net_Event7:
		jp		Quig_Control_Loop_2
		
.Quig_Net_Error:			dw	0
.Quig_Net_Handle:			db	255
.Quig_Net_Process:			db	255

.Quig_Net_TCP_Server:		db	0
.Quig_Net_TCP_Server_Port:	dw	0
.Quig_Net_TCP_Socket:		db 	0
.Quig_Net_TCP_Socket_Max:	db 	0

.Quig_Net_Received_Value:	dw	0
.Quig_Net_Transfered_Value:	dw 	0
.Quig_Net_Send_Wait_Value:	dw 	0

.Quig_Event_Net:			db	0
.Quig_Event_Net_Handle:		db	255
.Quig_Event_Net_Port:		dw	0
.Quig_Event_Net_IXIY:		dw	0,0

#ENDIF


.Quig_G9K_Top_Screen:
		INCLIB 	QUIG.G9K.VWAIT
		call	Quig_G9K_VWait
		di
		INCLIB QUIG.G9K.SCROLL.A
		call	Quig_G9K_SCROLL_A
		INCLIB	QUIG.G9K.SCROLL.B
		call	Quig_G9K_SCROLL_B
		ei
		ld		a,(Quig_G9K_Map_Engine)
		and		a
		ret		z
		
		ld		a,(Quig_G9K_IntCount)
		cp		0
		jp		z,Quig_Fore_SideScroll
		cp		1
		jp		z,Quig_Back_SideScroll
		cp		2
		jp		z,Quig_Fore_VertScroll
		cp		3
		jp		z,Quig_Back_VertScroll
		
.Quig_G9K_Top_Screen_9:
		ld		a,(Quig_G9K_IntCount)
		inc		a
		and		%11
		ld		(Quig_G9K_IntCount),a
		ret

.Quig_G9K_Map_Engine:		db	0
.Quig_G9k_Meta_Count:		dw 	0
.Quig_G9k_Meta_Size:		dw	0

.Quig_MetaLoad_Handle:		db	0
.Quig_MetaLoad_VAddr:		dw	0
.Quig_LoadSize:				dw	0
.Quig_LoadMeta_Buffer:		dw	0

.Quig_G9k_MapA_Width:		dw 	0
.Quig_G9k_MapA_Height:		dw	0
.Quig_G9k_MapA_MetaWidth:	dw	0
.Quig_G9k_MapA_MetaHeight:	dw	0
.Quig_G9k_MapA_Size:		dw	0
.Quig_G9k_MapB_Width:		dw 	0
.Quig_G9k_MapB_Height:		dw	0
.Quig_G9k_MapB_MetaWidth:	dw	0
.Quig_G9k_MapB_MetaHeight:	dw	0
.Quig_G9k_MapB_Size:		dw	0
		
.Quig_G9K_IntCount:			db	0		
.Quig_G9K_ScrollA_XPos:		dw	0
.Quig_G9K_ScrollA_YPos:		dw	0
.Quig_G9K_ScrollB_XPos:		dw	0
.Quig_G9K_ScrollB_YPos:		dw	0
.Quig_G9K_ScrollA_XPosOld:	dw	0
.Quig_G9K_ScrollA_YPosOld:	dw	0
.Quig_G9K_ScrollB_XPosOld:	dw	0
.Quig_G9K_ScrollB_YPosOld:	dw	0


.Quig_G9K_Sprite_NextXPos:		dw	0
.Quig_G9K_Sprite_NextYPos:		dw	0		
.Quig_G9K_Sprite_NextPattern:	dw	0
.Quig_G9K_Sprite_NextAddr:		dw	0

.Quig_G9K_a:				dw	0
.Quig_G9K_y:				dw	0
.Quig_G9K_x:				dw	0

.Quig_G9K_GameObjDataAddr:	dw	0
.Quig_G9k_GameObjList:		ds	2048

.Quig_Fore_SideScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollA_XPosOld)					;Get Old XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old XPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_XPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Fore_SideScroll_a
		ld		de,-1
.Quig_Fore_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollA_XPos)
		ld		(Quig_G9K_ScrollA_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_F_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl
		ld		hl,(Quig_G9K_ScrollA_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32				
		dec		hl
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapA_MetaWidth)
		ld		(Quig_F_SideScroll_av+1),hl
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		
		ld		b,9
.Quig_F_SideScroll_a1:		
		push 	bc
.Quig_F_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapA_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapA_Meta	
		ld		hl,(Quig_G9K_a)
.Quig_F_SideScroll_av:		
		ld		de,0
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_F_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit		
;***********************************
.Quig_Fore_VertScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollA_YPosOld)					;Get Old YPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Fore_VertScroll_a
		ld		de,-1
.Quig_Fore_VertScroll_a:
;***************		
		ld		hl,(Quig_G9K_ScrollA_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollA_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Fore_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapA_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		;****** Get The X and convert down into across
		ld		hl,(Quig_G9K_ScrollA_XPos)			;Get the XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;Div 128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		;*****************
		ld		b,11
.Quig_Fore_VertScroll_a1:		
		push 	bc
		;***** X Increase
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		;*****
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapA_Get			;Get Metatile Number
		;***** 
.Quig_Fore_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapA_Meta			;X,Y,Address	
		;*******
		pop		bc							;Retrieve Counter
		djnz	Quig_Fore_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
;****************************		
		
.Quig_Back_SideScroll:
		INCLIB 	QUIG.G9K.MAPB.META
		INCLIB	QUIG.G9K.MAPB.GET	
		INCLIB 	QUIG.MUL16
		ld		hl,(Quig_G9K_ScrollB_XPosOld)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl
		ld		hl,(Quig_G9K_ScrollB_XPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Back_SideScroll_a
		ld		de,-2
.Quig_Back_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollB_XPos)
		ld		(Quig_G9K_ScrollB_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_Back_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl

		ld		hl,(Quig_G9K_ScrollB_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapB_MetaWidth)		
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		
		ld		b,8
.Quig_Back_SideScroll_a1:		
		push 	bc
.Quig_Back_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapB_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapB_Meta	
		ld		hl,(Quig_G9K_a)
		ld		de,(Quig_G9k_MapB_MetaWidth)
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit				
		
;***********************************
.Quig_Back_VertScroll:
		INCLIB 	QUIG.G9K.MAPA.META
		INCLIB	QUIG.G9K.MAPA.GET
		ld		hl,(Quig_G9K_ScrollB_YPosOld)					;Get Old YPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;/128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollB_YPos)
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Back_VertScroll_a
		ld		de,-1
.Quig_Back_VertScroll_a:
;***************		
		ld		hl,(Quig_G9K_ScrollB_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollB_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Back_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapB_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		;****** Get The X and convert down into across
		ld		hl,(Quig_G9K_ScrollB_XPos)			;Get the XPos
		;SHR7 	/128
;		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a	;Div 128
		;SHR5
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		;*****************
		ld		b,11
.Quig_Back_VertScroll_a1:		
		push 	bc
		;***** X Increase
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		;*****
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapB_Get			;Get Metatile Number
		;***** 
.Quig_Back_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapB_Meta			;X,Y,Address	
		;*******
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
;****************************			
		
.G9kInterrupt:
		di
		
		ei
		reti
		
;**** Redirect a Clicked on Control Event		
;.Quig_Control_Event:
;		ld		a,1
;		ld		(V_App_In_Use),a
;		ld		a,(Event_Type)	 		
;	
;		cp		DSK_ACT_CLOSE
;		jp		z,Quig_End
;
;		cp		DSK_ACT_KEY
;		jp		z,Quig_Key		
;		jp		Quig_Control_Loop_1
;		
		
;*********************
;**** Key Control ****
;*********************
;.Quig_Key:
;		ld		a,(AppMsgB+4)
;		and		%10000000
;		jp		z,Quig_Content
;		jp		Quig_Control_Loop_1
;

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.Quig_End:
		INCLIB 	SYDESKTOP.SERVICE
		ld		de,(Quig_ModeUsed)
		ld		a,e
		or		%10000000
		ld		e,a
		ld 		a,DSK_SRV_MODSET
        call 	SyDesktop_Service
		
		ld 		a,DSK_SRV_DSKCNT
		call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKPLT
		call	SyDesktop_Service

		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1

;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
		
;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret
		
.Quig_Sprite_Attributes		
		ds		512		

.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255

.Quig_Directory_Error_Byte:		db	0
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_Top			equ AppTrnEnd+260+AppTrnLen2
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4

		
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0


#IF USETIMER
.Quig_Timer_Code:
		ld		a,(Quig_Timer_On)
		and		a
		jp		nz,feet1
		rst		#30
		jp		Quig_Timer_Code
.feet1		
		di
.feet	jr		feet	

		
.Quig_Timer_On:				db	0
.Quig_Timer_Count:			dw	0
		
#ENDIF	
#IF USENET



;### SUB ROUTINES #############################################################
.snwmsgi_afbcdehlixiy
        ld (AppMsgB+10),ix   ;store registers to message buffer
        ld (AppMsgB+12),iy
.snwmsgi_afbcdehl
        ld (AppMsgB+04),bc
.snwmsgi_afdehl
        ld (AppMsgB+06),de
.snwmsgi_afhl
        ld (AppMsgB+08),hl
.snwmsgi_af
        push af:pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld a,(hl)               ;set command
        inc hl
        push hl
        ld (AppMsgB+0),a
        ld (snwmsg2+1),a
        ld iy,AppMsgB
        ld a,(AppPrzN)	;ld a,(App_PrcID)
        db #dd:ld l,a
        ld a,(Quig_Net_Process)
        db #dd:ld h,a
        ld (snwmsg1+2),ix
        rst #10                 ;send message
.snwmsg1 ld ix,0                 ;wait for response
        rst #08
        db #dd:dec l
        jr nz,snwmsg1
        ld a,(AppMsgB)
        sub 128
.snwmsg2 cp 0
        ret z
        ld	a,(AppPrzN)			;ld a,(App_PrcID)        ;wrong response code -> re-send and wait for correct one
        db #dd:ld h,a
        ld a,(Quig_Net_Process)
        db #dd:ld l,a
        rst #10
        rst #30
        jr snwmsg1
.snwmsgo_afbcdehlixiy
        ld ix,(AppMsgB+10)   ;get registers from the message buffer
        ld iy,(AppMsgB+12)
        ld de,(AppMsgB+06)
.snwmsgo_afbchl
        ld bc,(AppMsgB+04)
.snwmsgo_afhl
        ld hl,(AppMsgB+02)
        push hl
        pop af
        ld hl,(AppMsgB+08)
        ret
#ENDIF	
