.PRC_ID_KERNEL   equ 95   ;kernel proces
.PRC_ID_DESKTOP  equ 2   ;desktop manager process
.PRC_ID_SYSTEM   equ 3   ;system manager process
.MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself
.MSC_GEN_FOCUS   equ 255 ;application is beeing asked, to focus its window
.MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
.MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
.MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
.MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
.MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
.MSC_KRL_MTWAKP  equ 6   ;wake up process
.MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
.MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
.MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)
.MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELP  equ 130 ;process has been deleted
.MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELT  equ 132 ;timer has been removed
.MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
.MSR_KRL_MTWAKP  equ 134 ;process has been waked up
.MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
.MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
.MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted
.MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
.MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
.MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
.MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
.MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
.MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
.MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
.MSC_SYS_SYSOFF  equ 23  ;shut down (-)
.MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
.MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
.MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSC_SYS_SYSHLP  equ 27  ;start help (-)
.MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
.MSC_SYS_SYSWRN  equ 29  ;open message/confirm window (P1/2=adresse, P3=ram bank, P4=number of buttons)
.MSC_SYS_PRGSRV  equ 30  ;shared service function (P4=type [0=search, 1=start, 2=release], P1/2=addresse 12char ID, P3=ram bank 12char ID or P3=program ID, if type=2)
.MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)
.MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading  [P8=filemanager error code], 4=memory full, P8=app ID, P9=process ID)
.MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSR_SYS_SYSWRN  equ 157 ;message/confirm window response (P1 -> 0=already in use, 1=opened [P2=number], 2=ok, 3=yes, 4=no, 5=cancel/close)
.MSR_SYS_PRGSRV  equ 158 ;shared service function response (P1=state [5=not found, other codes see MSR_SYS_PRGRUN], P8=app ID, P9=process ID)
.MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, modal window has been opened [P2=number])
.MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
.MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
.MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
.MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
.MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
.MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
.MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
.MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
.MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
.MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
.MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
.MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/-Num/Objekt, P3=Object) [always]
.MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
.MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
.MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Ylen) [always]
.MSC_DSK_WINSIN  equ 51  ;redraw content of a super control (P1=window ID, P2=super control ID, P3=SubObject) [always]
.MSC_DSK_MENCTX  equ 52  ;opens context menu (P1=ram bank, P2/3=address data record, P4/5=Xbeg [-1=mouse position], P6/7=Ybeg) ##!!## doc+lib
.MSC_DSK_STIADD  equ 53  ;adds systray-icon (P1=ram bank, P2/3=address, P4=ID)
.MSC_DSK_STIREM  equ 54  ;removes systray-icon (P1=number)
.MSC_DSK_STIUPD  equ 55  ;updates systray-icon (P1=number)
.MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
.MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
.MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
.MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
.MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])
.MSR_DSK_WRESIZ  equ 166 ;window has been resized (P1=window number)
.MSR_DSK_WSCROL  equ 167 ;window content has been scrolled (P1=window number)
.MSR_DSK_MENCTX  equ 168 ;menu has been clicked or canceld (P1=1 ok, P2/3=value, P4=type [0=normal, 1=check]) ##!!## doc+lib
.MSR_DSK_STIADD  equ 169 ;result of adding systray-icon (P1=1 ok, P2=number)
.MSR_DSK_STICLK  equ 170 ;systray-icon has been clicked (P1=ID)
.MSR_DSK_EXTDSK  equ 191 ;command for extended desktop (used internally; P1=command, P2-x=parameters)
.FNC_DXT_DSKBGR  equ 001 ;background has been updated
.FNC_DXT_FILRUN  equ 002 ;file has been opened via prgrun (P2/3=address, P4=bank)
.FNC_DXT_FILBRW  equ 003 ;file has been selected via file browser (P2/3=address, P4=bank)
.FNC_DXT_MENCLK  equ 004 ;startmenu has been clicked (P2/3=value)
.FNC_DXT_DSKCLK  equ 005 ;desktop window has been clicked (P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
.MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
.MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
.MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
.MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)
.MSC_SHL_PTHADD  equ 69  ;add additional path to current one (P1=base path, P3=addition path, P5=final path, P7=ram bank)
.MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
.MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
.MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
.MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)
.MSR_SHL_PTHADD  equ 197 ;path has been combined (P1=total end address, P3=directory end address, P5=flags)
.MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
.MSC_SAV_START   equ 2   ;start screen saver
.MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
.MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])
.DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
.DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
.DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
.DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
.DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)
.DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
.DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
.DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
.DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
.DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
.DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)
.DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode, P3=virtual desktop)
.DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode, P3=virtual desktop)
.DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
.DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
.DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
.DSK_SRV_DSKCNT  equ 6   ;continue desktop
.DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
.DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
.DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop
.DSK_SRV_DSKOPN  equ 11  ;open desktop background window
.CLPTYP_TEXT     equ 1   ;plain text
.CLPTYP_GRAPHIC  equ 2   ;graphic with extended header
.CLPTYP_ITEMS    equ 3   ;item list (*not defined yet*)
.CLPTYP_ICON     equ 4   ;desktop icon shortcut
.jmp_memsum  equ #8100 ;MEMSUM
.jmp_sysinf  equ #8103 ;SYSINF
.jmp_clcnum  equ #8106 ;CLCNUM
.jmp_mtgcnt  equ #8109 ;MTGCNT
.jmp_timget  equ #810C ;TIMGET
.jmp_timset  equ #810F ;TIMSET
.jmp_memget  equ #8118 ;MEMGET
.jmp_memfre  equ #811B ;MEMFRE
.jmp_memsiz  equ #811E ;MEMSIZ
.jmp_meminf  equ #8121 ;MEMINF
.jmp_bnkrwd  equ #8124 ;BNKRWD
.jmp_bnkwwd  equ #8127 ;BNKWWD
.jmp_bnkrbt  equ #812A ;BNKRBT
.jmp_bnkwbt  equ #812D ;BNKWBT
.jmp_bnkcop  equ #8130 ;BNKCOP
.jmp_bnkget  equ #8133 ;BNKGET
.jmp_scrget  equ #8139 ;SCRGET
.jmp_mosget  equ #813C ;MOSGET
.jmp_moskey  equ #813F ;MOSKEY
.jmp_bnk16c  equ #8142 ;BNK16C
.jmp_keytst  equ #8145 ;KEYTST
.jmp_keysta  equ #8148 ;KEYSTA
.jmp_keyput  equ #814B ;KEYPUT
.jmp_bufput  equ #814E ;BUFPUT
.jmp_bufget  equ #8151 ;BUFGET
.jmp_bufsta  equ #8154 ;BUFSTA
.jmp_iominp  equ #8157 ;IOMINP (cpc only)
.jmp_iomout  equ #815a ;IOMOUT (cpc only)
.jmp_bnkcll  equ #ff03 ;BNKCLL
.jmp_bnkret  equ #ff00 ;BNKRET
.FNC_FIL_STOINI  equ 000 ;Storage Init (Removes all mass storage devices)
.FNC_FIL_STONEW  equ 001 ;Storage New (Adds a new mass storage device)
.FNC_FIL_STORLD  equ 002 ;Storage Reload (Reloads a mass storage device, if its "removeable media" status is activated)
.FNC_FIL_STODEL  equ 003 ;Storage Delete (Removes an existing mass storage device)
.FNC_FIL_STOINP  equ 004 ;Storage ReadSector (Reads a sector from a mass storage device (no memory banking))
.FNC_FIL_STOOUT  equ 005 ;Storage WriteSector (Write a sector to a mass storage device (no memory banking))
.FNC_FIL_STOACT  equ 006 ;Storage Activate (Loads the format and the file system type of a mass storage device)
.FNC_FIL_STOINF  equ 007 ;Storage Information (Returns information about a mass storage device)
.FNC_FIL_STOTRN  equ 008 ;Storage DataTransfer (Reads or writes a number of sectors (512 bytes) from/to the mass storage device)
.FNC_FIL_DEVDIR  equ 013 ;
.FNC_FIL_DEVINI  equ 014 ;
.FNC_FIL_DEVSET  equ 015 ;
.FNC_FIL_FILINI  equ 016 ;File Init (Initialises the whole file manager)
.FNC_FIL_FILNEW  equ 017 ;File New (Creates a new file and opens it for read/write access)
.FNC_FIL_FILOPN  equ 018 ;File Open (Opens an existing file for read/write access)
.FNC_FIL_FILCLO  equ 019 ;File Close (Closes an opened file)
.FNC_FIL_FILINP  equ 020 ;File Input (Reads a specified amount of bytes out of an opened file)
.FNC_FIL_FILOUT  equ 021 ;File Output (Writes a specified amount of bytes into an opened file)
.FNC_FIL_FILPOI  equ 022 ;File Pointer (Moves the file pointer to another position)
.FNC_FIL_FILF2T  equ 023 ;File Decode Timestamp (Decodes the file timestamp, which is used for the file system)
.FNC_FIL_FILT2F  equ 024 ;File Encode Timestamp (Encodes the file timestamp, which is used for the file system)
.FNC_FIL_FILLIN  equ 025 ;File LineInput (Reads one text line out of an opened file)
.FNC_FIL_DIRDEV  equ 032 ;Directory Device (Selects the current drive)
.FNC_FIL_DIRPTH  equ 033 ;Directory Path (Selects the current path for the current or a different drive)
.FNC_FIL_DIRPRS  equ 034 ;Directory Property Set (Changes a property of a file or a directory)
.FNC_FIL_DIRPRR  equ 035 ;Directory Property Get (Reads a property of a file or a directory)
.FNC_FIL_DIRREN  equ 036 ;Directory Rename (Renames a file or a directory)
.FNC_FIL_DIRNEW  equ 037 ;Directory New (Creates a new directory)
.FNC_FIL_DIRINP  equ 038 ;Directory Input (Reads the content of a directory)
.FNC_FIL_DIRDEL  equ 039 ;Directory Delete (Deletes one or more files)
.FNC_FIL_DIRRMD  equ 040 ;Directory Delete Directory (Deletes a sub directory)
.FNC_FIL_DIRMOV  equ 041 ;Directory Move (Moves a file or sub directory into another directory of the same drive)
.FNC_FIL_DIRINF  equ 042 ;Directory Drive Information (Returns information about one drive)
.FNC_NET_CFGGET  equ 001 ;config information
.FNC_NET_CFGSET  equ 002 ;config setting
.FNC_NET_TCPOPN  equ 016 ;TCP open
.FNC_NET_TCPCLO  equ 017 ;TCP close
.FNC_NET_TCPSTA  equ 018 ;TCP status
.FNC_NET_TCPRCV  equ 019 ;TCP receive
.FNC_NET_TCPSND  equ 020 ;TCP send
.FNC_NET_TCPSKP  equ 021 ;TCP skip received data
.FNC_NET_TCPFLS  equ 022 ;TCP flush send buffer
.FNC_NET_TCPDIS  equ 023 ;TCP disconnect
.MSR_NET_TCPEVT  equ 159 ;TCP event
.FNC_NET_UDPOPN  equ 032 ;UDP open
.FNC_NET_UDPCLO  equ 033 ;UDP close
.FNC_NET_UDPSTA  equ 034 ;UDP status
.FNC_NET_UDPRCV  equ 035 ;UDP receive
.FNC_NET_UDPSND  equ 036 ;UDP send
.FNC_NET_UDPSKP  equ 037 ;UDP skip received data
.MSR_NET_UDPEVT  equ 175 ;UDP event
.FNC_NET_DNSRSV  equ 112 ;DNS resolve
.FNC_NET_DNSVFY  equ 113 ;DNS verify
.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 62  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatVer     equ 88  ;Version 3
.PrgDatLen     equ 256 ;
.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;
.ScanCode_E	equ 45
.CG9K_VRAM				equ	#ff60			; R/W
.g9k_PALETTE			equ	#61				; R/W
.CG9K_PALETTE			equ	#ff61				; R/W
.g9k_CMD_DATA			equ	#62				; R/W
.g9k_REG_DATA			equ	#63				; R/W
.CG9K_REG_DATA			equ	#ff63				; R/W
.CG9K_REG_SELECT		equ	#ff64			; W
.CG9K_STATUS			equ	#ff65			; R
.g9k_INT_FLAG			equ	#66				; R/W
.g9k_SYS_CTRL			equ	#67				; W
.g9k_OUTPUT_CTRL		equ	#6F 		    ; R/W
.CG9K_OUTPUT_CTRL		equ	#ff6F 		    ; R/W
.g9k_SYS_CTRL_SRS		equ	2				; Power on reset state
.g9k_SYS_CTRL_MCKIN		equ	1				; Select MCKIN terminal
.g9k_SYS_CTRL_XTAL		equ	0				; Select XTAL
G9K_INT_V_LINE_LO
.g9k_WRITE_ADDR			equ	0				; W
.g9k_READ_ADDR			equ	3				; W
.g9k_SCREEN_MODE0		equ	6				; R/W
.g9k_SCREEN_MODE1		equ 7				; R/W
.g9k_CTRL				equ	8				; R/W
.g9k_INT_ENABLE         equ 9       		; R/W
.g9k_INT_V_LINE_LO		equ	10				; R/W	
.g9k_INT_V_LINE_HI		equ	11				; R/W
.g9k_INT_H_LINE			equ	12				; R/W	
.g9k_PALETTE_CTRL		equ	13				; W
.g9k_PALETTE_PTR		equ	14				; W
.g9k_BACK_DROP_COLOR 	equ 15		      	; R/W
.CG9K_BACK_DROP_COLOR 	equ 15		      	; R/W
.g9k_DISPLAY_ADJUST		equ	16				; R/W
.g9k_SCROLL_LOW_Y		equ 17 			    ; R/W
.g9k_SCROLL_HIGH_Y		equ 18      		; R/W
.g9k_SCROLL_LOW_X		equ 19      		; R/W
.g9k_SCROLL_HIGH_X		equ 20      		; R/W
.g9k_SCROLL_LOW_Y_B		equ 21 				; R/W
.g9k_SCROLL_HIGH_Y_B	equ 22      		; R/W
.g9k_SCROLL_LOW_X_B		equ 23      		; R/W
.g9k_SCROLL_HIGH_X_B	equ 24      		; R/W
.g9k_PAT_GEN_TABLE   	equ 25      		; R/W
.g9k_LCD_CTRL        	equ 26      		; R/W
.g9k_PRIORITY_CTRL  	equ 27      		; R/W
.g9k_SPR_PAL_CTRL		equ	28				; W
.g9k_SC_X				equ	32				; W
.g9k_SC_Y				equ	34				; W
.g9k_DS_X				equ	36				; W
.g9k_DS_Y				equ	38				; W
.g9k_NX					equ	40				; W
.g9k_NY					equ	42				; W
.g9k_ARG				equ	44				; W
.g9k_LOP				equ	45				; W
.g9k_WRITE_MASK			equ	46				; W
.g9k_FC					equ	48				; W
.g9k_BC					equ	50				; W
.g9k_OPCODE				equ	52				; W
.g9k_DIS_INC_READ		equ	64
.g9k_DIS_INC_WRITE		equ	128
.g9k_SCR0_STANDBY		equ	192				; Stand by mode
.g9k_SCR0_BITMAP		equ	128				; Select Bit map mode
.g9k_SCR0_P2			equ	64				; Select P1 mode
.g9k_SCR0_P1			equ	0				; Select P1 mode
.g9k_SCR0_DTCLK			equ	32				; Master Dot clock not divided
.g9k_SCR0_DTCLK2		equ	16				; Master Dot clock divided by 2
.g9k_SCR0_DTCLK4		equ	0				; Master Dot clock divided by 4
.g9k_SCR0_XIM2048		equ	12				; Image size = 2048
.g9k_SCR0_XIM1024		equ	8				; Image size = 1024
.g9k_SCR0_XIM512		equ	4				; Image size = 512
.g9k_SCR0_XIM256		equ	0				; Image size = 256
.g9k_SCR0_16BIT			equ	3				; 16 bits/dot
.g9k_SCR0_8BIT			equ	2				; 8 bits/dot
.g9k_SCR0_4BIT			equ	1				; 4 bits/dot
.g9k_SCR0_2BIT			equ 0				; 2 bits/dot
.g9k_SCR1_C25M			equ	64				; Select 640*480 mode
.g9k_SCR1_SM1			equ	32				; Selection of 263 lines during non interlace , else 262
.g9k_SCR1_SM			equ	16				; Selection of horizontal frequency 1H=fsc/227.5
.g9k_SCR1_PAL			equ	8				; Select PAL, else NTSC
.g9k_SCR1_EO			equ	4				; Select of vertical resoltion of twice the non-interlace resolution
.g9k_SCR1_IL			equ	2				; Select Interlace
.g9k_SCR1_HSCN			equ	1				; Select High scan mode
.g9k_CTRL_DISP			equ	128				; Display VRAM
.g9k_CTRL_DIS_SPD		equ	64				; Disable display sprite (cursor)
.g9k_CTRL_YSE			equ	32				; /YS Enable
.g9k_CTRL_VWTE			equ	16				; VRAM Serial data bus control during digitization
.g9k_CTRL_VWM			equ	8				; VRAM write control during digitization
.g9k_CTRL_DMAE			equ	4				; Enable DMAQ output
.g9k_CTRL_VRAM512		equ	2				; VRAM=512KB
.g9k_CTRL_VRAM256		equ	1				; VRAM=256KB
.g9k_CTRL_VRAM128		equ	0				; VRAM=128KB
.g9k_INT_IECE	        equ 4       		; Command end interrupt enable control
.g9k_INT_IEH	        equ 2       		; Display position interrupt enable
.g9k_INT_IEV	        equ 1       		; Int. enable during vertical retrace line interval
.g9k_PAL_CTRL_YUV		equ	192				; YUV mode
.g9k_PAL_CTRL_YJK		equ	128				; YJK mode
.g9k_PAL_CTRL_256		equ	64				; 256 color mode
.g9k_PAL_CTRL_PAL		equ	0				; Pallete mode
.g9k_PAL_CTRL_YAE		equ	32				; Enable YUV/YJK RGB mixing mode
.g9k_LOP_TP				equ	16
.g9k_LOP_WCSC			equ	12
.g9k_LOP_WCNOTSC		equ	3
.g9k_LOP_WCANDSC		equ	8
.g9k_LOP_WCORSC			equ	14
.g9k_LOP_WCEORSC		equ	6
.g9k_ARG_MAJ			equ	1
.g9k_ARG_NEG			equ	2
.g9k_ARG_DIX			equ	4
.g9k_ARG_DIY			equ	8
.g9k_OPCODE_STOP		equ	#00				; Command being excuted is stopped 
.g9k_OPCODE_LMMC		equ	#10     		; Data is transferred from CPU to VRAM rectangle area
.g9k_OPCODE_LMMV		equ	#20     		; VRAM rectangle area is painted out
.g9k_OPCODE_LMCM		equ	#30				; VRAM rectangle area is transferred to CPU
.g9k_OPCODE_LMMM		equ	#40				; Rectangle area os transferred from VRAM to VRAM
.g9k_OPCODE_CMMC		equ	#050			; CPU character data is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMK		equ	#060			; Kanji ROM data is is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMM		equ	#070			; VRAM character data is color-developed and transferred to VRAM rectangle area 
.g9k_OPCODE_BMXL		equ	#080			; Data on VRAM linear address is transferred to VRAM rectangle area
.g9k_OPCODE_BMLX		equ	#090			; VRAM rectangle area is transferred to VRAM linear address 
.g9k_OPCODE_BMLL		equ	#0A0			; Data on VRAM linear address is transferred to VRAM linear address 
.g9k_OPCODE_LINE		equ	#0B0			; Straight line is drawer on X-Y co-ordinates
.g9k_OPCODE_SRCH		equ	#0C0			; Border color co-ordinates on X-Y are detected
.g9k_OPCODE_POINT		equ	#0D0			; Color code on specified point on X-Y is read out
.g9k_OPCODE_PSET		equ	#0E0			; Drawing is executed at drawing point on X-Y co-ordinates
.g9k_OPCODE_ADVN		equ	#0F0			; Drawing point on X-Y co-ordinates is shifted
.g9k_STATUS_TR          equ 128
.g9k_STATUS_VR          equ 64
.g9k_STATUS_HR          equ 32
.g9k_STATUS_BD          equ 16
.g9k_STATUS_MSC         equ 4
.g9k_STATUS_EO          equ 2
.g9k_STATUS_CE          equ 1
.g9k_MODE_P1			equ	0				; Pattern mode 0 256 212
.g9k_MODE_P2			equ	1				; Pattern mode 1 512 212
.g9k_MODE_B1			equ	2				; Bitmap mode 1 256 212
.g9k_MODE_B2			equ	3				; Bitmap mode 2 384 240
.g9k_MODE_B3			equ	4				; Bitmap mode 3 512 212
.g9k_MODE_B4			equ	5				; Bitmap mode 4 768 240
.g9k_MODE_B5			equ	6				; Bitmap mode 5 640 400 (VGA)
.g9k_MODE_B6			equ	7				; Bitmap mode 6 640 480 (VGA)
.g9k_MODE_B7			equ	8				; Bitmap mode 7 1024 212 (Undocumented v9990 mode)
.g9k_RED                 equ 32
.g9k_GREEN               equ 1024
.g9k_BLUE                equ 1
SYMBOS_ORG #100
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
.AppDataSize   dw  AppTrnBeg-AppDatBeg      ;Length of Dat
.AppTrnSize    dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
               dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "G9K Flappy              ",0
.AppIcon16     db  1
.AppIconOff    dw  Icon24_Data-AppCodBeg
.Appxxxx       db  0,0,0,0,0
.AppMemTab     db  "SymExe10"             ;File Check
.AppDataLen    equ  AppTrnBeg-AppDatBeg      ;Length of Data
.AppTrnLen     equ  AppTrnEnd-AppTrnBeg      ;Length of Transfer
.AppTrnLen2    equ  16100-AppTrnLen
.AppDataLen2    equ  16100-AppDataLen
.AppExtCode    dw  0
.AppExtData    dw  AppDataLen2
.AppExtTrans   dw  AppTrnLen2
               ds  28
.AppIcnSml    
.AppStartForm  equ 0
        db 2,8,8
      db     15,15,14,3,13,13,73,73,73,73,75,75,60,135,15,15
.AppIcnBig    
.AppIcnLrg       db 6,24,24
             db 0,0,0,0,33,236
             db 0,0,0,0,33,236
             db 0,0,0,0,97,254
             db 0,0,0,0,97,254
             db 0,0,0,0,0,0
             db 0,0,0,0,0,0
             db 0,0,0,0,0,0
             db 0,0,0,0,97,254
             db 0,0,0,0,97,254
             db 240,240,240,240,225,252
             db 240,240,240,240,225,252
             db 240,225,44,112,225,252
             db 240,135,72,176,225,252
             db 240,15,104,144,225,252
             db 225,15,60,16,225,252
             db 240,240,30,240,225,252
             db 192,16,61,255,233,252
             db 224,48,122,240,225,252
             db 240,225,61,255,225,252
             db 240,15,30,240,225,252
             db 240,240,240,240,225,252
             db 240,240,240,240,225,252
             db 15,15,15,15,45,237
             db 15,15,15,15,45,237
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3
.V_App_In_Use			db 	0
.AppPrz:
		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer
		ld 		a,DSK_SRV_MODGET
        call	SyDesktop_Service
		ld		(Quig_ModeUsed),de
		ld 		a,DSK_SRV_DSKSTP
		ld 		e,1
		call 	SyDesktop_Service
		call	Quig_G9K_SETMODE_50
		ld		a,g9k_PALETTE_PTR
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		xor		a
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ld		bc,CG9K_OUTPUT_CTRL
        out  	(c),A    	   	; Set output GFX9000	
		call	Quig_g9k_ForeBack_Palette_Set
		call	qfunc_initialize
.Quig_Control_Loop:
		call	Quig_G9K_Top_Screen
.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
		jp		Quig_Control_Loop
.Quig_ModeUsed:	dw	0
.Quig_G9K_Top_Screen:
		call	Quig_G9K_VWait
		di
		call	Quig_G9K_SCROLL_A
		call	Quig_G9K_SCROLL_B
		ei
		ld		a,(Quig_G9K_Map_Engine)
		and		a
		ret		z
		ld		a,(Quig_G9K_IntCount)
		cp		0
		jp		z,Quig_Fore_SideScroll
		cp		1
		jp		z,Quig_Back_SideScroll
		cp		2
		jp		z,Quig_Fore_VertScroll
		cp		3
		jp		z,Quig_Back_VertScroll
.Quig_G9K_Top_Screen_9:
		ld		a,(Quig_G9K_IntCount)
		inc		a
		and		%11
		ld		(Quig_G9K_IntCount),a
		ret
.Quig_G9K_Map_Engine:		db	0
.Quig_G9k_Meta_Count:		dw 	0
.Quig_G9k_Meta_Size:		dw	0
.Quig_MetaLoad_Handle:		db	0
.Quig_MetaLoad_VAddr:		dw	0
.Quig_LoadSize:				dw	0
.Quig_LoadMeta_Buffer:		dw	0
.Quig_G9k_MapA_Width:		dw 	0
.Quig_G9k_MapA_Height:		dw	0
.Quig_G9k_MapA_MetaWidth:	dw	0
.Quig_G9k_MapA_MetaHeight:	dw	0
.Quig_G9k_MapA_Size:		dw	0
.Quig_G9k_MapB_Width:		dw 	0
.Quig_G9k_MapB_Height:		dw	0
.Quig_G9k_MapB_MetaWidth:	dw	0
.Quig_G9k_MapB_MetaHeight:	dw	0
.Quig_G9k_MapB_Size:		dw	0
.Quig_G9K_IntCount:			db	0		
.Quig_G9K_ScrollA_XPos:		dw	0
.Quig_G9K_ScrollA_YPos:		dw	0
.Quig_G9K_ScrollB_XPos:		dw	0
.Quig_G9K_ScrollB_YPos:		dw	0
.Quig_G9K_ScrollA_XPosOld:	dw	0
.Quig_G9K_ScrollA_YPosOld:	dw	0
.Quig_G9K_ScrollB_XPosOld:	dw	0
.Quig_G9K_ScrollB_YPosOld:	dw	0
.Quig_G9K_Sprite_NextXPos:		dw	0
.Quig_G9K_Sprite_NextYPos:		dw	0		
.Quig_G9K_Sprite_NextPattern:	dw	0
.Quig_G9K_Sprite_NextAddr:		dw	0
.Quig_G9K_a:				dw	0
.Quig_G9K_y:				dw	0
.Quig_G9K_x:				dw	0
.Quig_G9K_GameObjDataAddr:	dw	0
.Quig_G9k_GameObjList:		ds	2048
.Quig_Fore_SideScroll:
		ld		hl,(Quig_G9K_ScrollA_XPosOld)					;Get Old XPos
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old XPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_XPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Fore_SideScroll_a
		ld		de,-1
.Quig_Fore_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollA_XPos)
		ld		(Quig_G9K_ScrollA_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_F_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl
		ld		hl,(Quig_G9K_ScrollA_YPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32				
		dec		hl
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapA_MetaWidth)
		ld		(Quig_F_SideScroll_av+1),hl
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		ld		b,9
.Quig_F_SideScroll_a1:		
		push 	bc
.Quig_F_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapA_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapA_Meta	
		ld		hl,(Quig_G9K_a)
.Quig_F_SideScroll_av:		
		ld		de,0
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_F_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit		
.Quig_Fore_VertScroll:
		ld		hl,(Quig_G9K_ScrollA_YPosOld)					;Get Old YPos
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollA_YPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Fore_VertScroll_a
		ld		de,-1
.Quig_Fore_VertScroll_a:
		ld		hl,(Quig_G9K_ScrollA_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollA_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Fore_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapA_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		ld		hl,(Quig_G9K_ScrollA_XPos)			;Get the XPos
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		ld		b,11
.Quig_Fore_VertScroll_a1:		
		push 	bc
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapA_Get			;Get Metatile Number
.Quig_Fore_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapA_Meta			;X,Y,Address	
		pop		bc							;Retrieve Counter
		djnz	Quig_Fore_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
.Quig_Back_SideScroll:
		ld		hl,(Quig_G9K_ScrollB_XPosOld)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ex		de,hl
		ld		hl,(Quig_G9K_ScrollB_XPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,9
		jr		nc,Quig_Back_SideScroll_a
		ld		de,-2
.Quig_Back_SideScroll_a:
		ld		hl,(Quig_G9K_ScrollB_XPos)
		ld		(Quig_G9K_ScrollB_XPosOld),hl
		ld		h,b
		ld		l,c
		add		hl,de
		ld		(Quig_Back_SideScroll_az+1),hl
		ld		(Quig_G9K_a),hl
		ld		hl,(Quig_G9K_ScrollB_YPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl
		ld		(Quig_G9K_y),de
		ld		hl,(Quig_G9k_MapB_MetaWidth)		
		call	Quig_Mul16
		ld		de,(Quig_G9K_a)
		add		hl,de
		ld		(Quig_G9K_a),hl
		ld		b,8
.Quig_Back_SideScroll_a1:		
		push 	bc
.Quig_Back_SideScroll_az:
		ld		hl,0
		push	hl
		ld		hl,(Quig_G9K_a)
		call	Quig_g9k_MapB_Get			;Get Metatile Number
		ld		de,(Quig_G9K_y)
		inc		de
		ld		(Quig_G9K_y),de
		dec		de
		call	Quig_g9k_MapB_Meta	
		ld		hl,(Quig_G9K_a)
		ld		de,(Quig_G9k_MapB_MetaWidth)
		add		hl,de
		ld		(Quig_G9K_a),hl
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_SideScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit				
.Quig_Back_VertScroll:
		ld		hl,(Quig_G9K_ScrollB_YPosOld)					;Get Old YPos
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32
		ex		de,hl											;DE=Old YPos MetaTiles
		ld		hl,(Quig_G9K_ScrollB_YPos)
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		ld		b,h
		ld		c,l
		xor		a
		sbc		hl,de
		jp 		z,Quig_G9K_Top_Screen_9
		ld		de,7
		jr		nc,Quig_Back_VertScroll_a
		ld		de,-1
.Quig_Back_VertScroll_a:
		ld		hl,(Quig_G9K_ScrollB_YPos)			;Get YPos
		ld		(Quig_G9K_ScrollB_YPosOld),hl		;Store In Old
		ld		h,b									;Get Y Divide/128 Version from BC									
		ld		l,c
		add		hl,de								;Add to Proper Y
		ld		(Quig_Back_VertScroll_Y+1),hl		;Put Y Value into Loop
		ld		de,(Quig_G9k_MapB_MetaWidth)		;Width*Y
		call	Quig_Mul16							;
		ex		de,hl								;Store Offset in DE
		ld		hl,(Quig_G9K_ScrollB_XPos)			;Get the XPos
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a		;/32		
		dec		hl
		ld		(Quig_G9k_x),hl						;Store X
		add		hl,de								;Add Offset+X
		ld		(Quig_G9K_a),hl						;Store in a
		ld		b,11
.Quig_Back_VertScroll_a1:		
		push 	bc
		ld		hl,(Quig_G9k_x)				;Get X Across
		push	hl							;Put To stack for Meta
		inc		hl							;Increments
		ld		(Quig_G9k_x),hl				;Store	
		ld		hl,(Quig_G9K_a)				;Address
		inc		hl							;Increase
		ld		(Quig_G9K_a),hl				;Store
		dec		hl							;Reduce
		call	Quig_g9k_MapB_Get			;Get Metatile Number
.Quig_Back_VertScroll_Y:
		ld		de,0						;Y Down
		call	Quig_g9k_MapB_Meta			;X,Y,Address	
		pop		bc							;Retrieve Counter
		djnz	Quig_Back_VertScroll_a1		;Loop if not 0
		jp		Quig_G9K_Top_Screen_9		;Exit	
.G9kInterrupt:
		di
		ei
		reti
.Quig_End:
		ld		de,(Quig_ModeUsed)
		ld		a,e
		or		%10000000
		ld		e,a
		ld 		a,DSK_SRV_MODSET
        call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKCNT
		call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKPLT
		call	SyDesktop_Service
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret
.Quig_Sprite_Attributes		
		ds		512		
.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255
.Quig_Directory_Error_Byte:		db	0
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_Top			equ AppTrnEnd+260+AppTrnLen2
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0
.QFunc_INITIALIZE
.QLn_111		;//For f=240 To 255
		ld		hl,255		;//hl=number '255' [Qc054]
		ld 		(QFr823_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,240		;//hl=number '240' [Qc054]
		.QFr823_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr823_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr823_Start	;// [Qc307]
		jp		nz,QFr823_Exit	;// [Qc308]
.QFr823_Start:
.QLn_112		;//Ink.Set f,0,0,0
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,0		;//hl=number '0' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Ink_Set				;//Call 'Ink.Set' [Qc234]
.QLn_113		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr823_Loop		;// [Qc340]
.QFr823_Exit:
.QLn_115		;//Ink.Palette.Set 0,240
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,240		;//hl=number '240' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_116		;//Ink.Palette.Set 1,240
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,240		;//hl=number '240' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_117		;//Ink.Palette.Set 2,240
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,240		;//hl=number '240' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_118		;//Ink.Palette.Set 3,240
		Ld 		de,3			;// Optimize -6- [Qc1040]
		ld		hl,240		;//hl=number '240' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_120		;//BackColour.Set 5
		ld		hl,5		;//hl=number '5' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_121		;//Back.Palette.Set 2
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Back_Palette_Set				;//Call 'Back.Palette.Set' [Qc234]
.QLn_122		;//Fore.Palette.Set 1
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_Fore_Palette_Set				;//Call 'Fore.Palette.Set' [Qc234]
.QLn_126		;//For f=0 To 124
		ld		hl,124		;//hl=number '124' [Qc054]
		ld 		(QFr877_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr877_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr877_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr877_Start	;// [Qc307]
		jp		nz,QFr877_Exit	;// [Qc308]
.QFr877_Start:
.QLn_127		;//Sprite.Palette.Set f,0
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Palette				;//Call 'Sprite.Palette.Set' [Qc234]
.QLn_128		;//Sprite.Position.Set f,200,0
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,200			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_129		;//Sprite.Display.Set	 f,0
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Display				;//Call 'Sprite.Display.Set' [Qc234]
.QLn_130		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr877_Loop		;// [Qc340]
.QFr877_Exit:
.QLn_132		;//Sprite.Refresh
		call	Quig_G9K_Sprite_Refresh				;//Call 'Sprite.Refresh' [Qc234]
.QLn_135		;//PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy4.qpt",4928,32)
		call	Quig_App_Path		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,directstr_1+2		;//hl points static string [Qc055]
		call	Quig_Str_Add		;//Compare strings equals HL=DE [Qc057]
		push		hl 		;//Store result [Qc001]
		Ld 		de,4928			;// Optimize -6- [Qc1040]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_g9k_TileALoad		;/ Call Function [Qc052]
		ld		(var_wrd_PattsLoaded),hl		;//Int variable 'var_wrd_PattsLoaded'=expression result [Qc219]
.QLn_137		;//For f=0 To 31
		ld		hl,31		;//hl=number '31' [Qc054]
		ld 		(QFr923_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr923_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr923_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr923_Start	;// [Qc307]
		jp		nz,QFr923_Exit	;// [Qc308]
.QFr923_Start:
.QLn_138		;//For g=0 To 63
		ld		hl,63		;//hl=number '63' [Qc054]
		ld 		(QFr934_Top+1),hl 		;/Copy Result into static'var_wrd_g' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr934_Loop:ld 		(var_wrd_g),hl ;/Loop Repeat Point [Qc301]
		.QFr934_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr934_Start	;// [Qc307]
		jp		nz,QFr934_Exit	;// [Qc308]
.QFr934_Start:
.QLn_139		;//Fore.ScreenMap.Set 4928,g,f
		ld		hl,4928		;//hl=number '4928' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_g) 	;//hl=value of 'var_wrd_g' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_DrawTileA				;//Call 'Fore.ScreenMap.Set' [Qc234]
.QLn_140		;//Next
		ld		hl,(var_wrd_g) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr934_Loop		;// [Qc340]
.QFr934_Exit:
.QLn_141		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr923_Loop		;// [Qc340]
.QFr923_Exit:
.QLn_142		;//i=4928
		ld		hl,4928		;//hl=number '4928' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_144		;//For f=4 To 15
		ld		hl,15		;//hl=number '15' [Qc054]
		ld 		(QFr965_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,4		;//hl=number '4' [Qc054]
		.QFr965_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr965_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr965_Start	;// [Qc307]
		jp		nz,QFr965_Exit	;// [Qc308]
.QFr965_Start:
.QLn_145		;//For g=6 To 27
		ld		hl,27		;//hl=number '27' [Qc054]
		ld 		(QFr976_Top+1),hl 		;/Copy Result into static'var_wrd_g' [Qc303]
		ld		hl,6		;//hl=number '6' [Qc054]
		.QFr976_Loop:ld 		(var_wrd_g),hl ;/Loop Repeat Point [Qc301]
		.QFr976_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr976_Start	;// [Qc307]
		jp		nz,QFr976_Exit	;// [Qc308]
.QFr976_Start:
.QLn_146		;//Fore.ScreenMap.Set i,g,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_g) 	;//hl=value of 'var_wrd_g' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_DrawTileA				;//Call 'Fore.ScreenMap.Set' [Qc234]
.QLn_147		;//i=i+1
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_148		;//Next
		ld		hl,(var_wrd_g) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr976_Loop		;// [Qc340]
.QFr976_Exit:
.QLn_149		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr965_Loop		;// [Qc340]
.QFr965_Exit:
.QLn_152		;//For f=0 To 127 Step 8
		ld		hl,127		;//hl=number '127' [Qc054]
		ld 		(QFr1008_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1008_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr1008_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1008_Start	;// [Qc307]
		jp		nz,QFr1008_Exit	;// [Qc308]
.QFr1008_Start:
.QLn_153		;//PalFade(32,240,128,f)
		ld		hl,32		;//hl=number '32' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,240		;//hl=number '240' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,128			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	QFunc_PalFade				;//Call 'PalFade' [Qc234]
.QLn_154		;//Ink.Palette.Set 1,128
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,128		;//hl=number '128' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_155		;//VWait
		call	Quig_G9K_VWait				;//Call 'VWait' [Qc234]
.QLn_156		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		ld		de,8		;// [Qc338]
		add		hl,de 	;// [Qc339]
		jp		QFr1008_Loop		;// [Qc340]
.QFr1008_Exit:
.QLn_160		;//Ink.Palette.Set 3,32
		Ld 		de,3			;// Optimize -6- [Qc1040]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_161		;//Fore.Palette.Set 3
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_g9k_Fore_Palette_Set				;//Call 'Fore.Palette.Set' [Qc234]
.QLn_166		;//loading=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_loading),hl		;//Int variable 'var_wrd_loading'=expression result [Qc219]
.QLn_167		;//GameOn=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_169		;//EndF
		ret		;// [Qc262]
.QLn_172		;//Function Collide:Int(cx1,cy1,cw1,ch1,cx2,cy2,cw2,ch2)
.QFunc_COLLIDE
		pop		iy		;//Get the Return Position [Qc235]
		ld		(var_wrd_ch2),hl		;// Loads HL into variable [Qc242]
		ld		(var_wrd_cw2),de		;//Loads DE into variable [Qc243]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_cy2),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_cx2),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_ch1),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_cw1),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_cy1),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_cx1),bc		;// [Qc245]
		push		iy		;// Restores Exit position [Qc246]
.QLn_173		;//If cx1<cx2+cw2  Then
		ld		hl,(var_wrd_cx1) 	;//hl=value of 'var_wrd_cx1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_cx2) 	;//hl=value of 'var_wrd_cx2' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_cw2) 	;//hl=value of 'var_wrd_cw2' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc050]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf1083_Exit				;// [Qc1220]
.QLn_174		;//If cx1+cw1>=cx2 Then
		ld		hl,(var_wrd_cx1) 	;//hl=value of 'var_wrd_cx1' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_cw1) 	;//hl=value of 'var_wrd_cw1' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_cx2) 	;//hl=value of 'var_wrd_cx2' [Qc053]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf1094_Exit				;// [Qc1220]
.QLn_175		;//If cy1<cy2+ch2 Then
		ld		hl,(var_wrd_cy1) 	;//hl=value of 'var_wrd_cy1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_cy2) 	;//hl=value of 'var_wrd_cy2' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_ch2) 	;//hl=value of 'var_wrd_ch2' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc050]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf1106_Exit				;// [Qc1220]
.QLn_176		;//If cy1+ch1>=cy2 Then
		ld		hl,(var_wrd_cy1) 	;//hl=value of 'var_wrd_cy1' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_ch1) 	;//hl=value of 'var_wrd_ch1' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_cy2) 	;//hl=value of 'var_wrd_cy2' [Qc053]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf1117_Exit				;// [Qc1220]
.QLn_177		;//Return 1
		ld		hl,1		;//hl=number '1' [Qc054]
		ret		;// [Qc250]
.QLn_178		;//EndIf
.QIf1117_Exit:
.QLn_179		;//EndIf
.QIf1106_Exit:
.QLn_180		;//EndIf
.QIf1094_Exit:
.QLn_181		;//EndIf
.QIf1083_Exit:
.QLn_182		;//Return 0
		ld		hl,0		;//hl=number '0' [Qc054]
		ret		;// [Qc250]
.QLn_183		;//EndF
		ld		hl,0		;// Return 0 Value [Qc260]
		ret		;// [Qc262]
.QLn_187		;//Function PalFade:Void(Pal1,Pal2,Pal3,Lev)
.QFunc_PALFADE
		pop		iy		;//Get the Return Position [Qc235]
		ld		(var_wrd_Lev),hl		;// Loads HL into variable [Qc242]
		ld		(var_wrd_Pal3),de		;//Loads DE into variable [Qc243]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_Pal2),bc		;// [Qc245]
		pop		bc		;//Pops from stack into variable [Qc244]
		ld		(var_wrd_Pal1),bc		;// [Qc245]
		push		iy		;// Restores Exit position [Qc246]
.QLn_189		;//For Loop=0 To 15
		ld		hl,15		;//hl=number '15' [Qc054]
		ld 		(QFr1148_Top+1),hl 		;/Copy Result into static'var_wrd_Loop' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1148_Loop:ld 		(var_wrd_Loop),hl ;/Loop Repeat Point [Qc301]
		.QFr1148_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1148_Start	;// [Qc307]
		jp		nz,QFr1148_Exit	;// [Qc308]
.QFr1148_Start:
.QLn_190		;//Ink.Set Pal3,Ink.Fade(Ink.Red.Get(Pal1),Ink.Red.Get(Pal2),Lev),Ink.Fade(Ink.Green.Get(Pal1),Ink.Green.Get(Pal2),Lev),Ink.Fade(Ink.Blue.Get(Pal1),Ink.Blue.Get(Pal2),Lev)
		ld		hl,(var_wrd_Pal3) 	;//hl=value of 'var_wrd_Pal3' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_Pal1) 	;//hl=value of 'var_wrd_Pal1' [Qc053]
		call	Quig_G9k_Ink_R_Get		;/ Call Function [Qc052]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pal2) 	;//hl=value of 'var_wrd_Pal2' [Qc053]
		call	Quig_G9k_Ink_R_Get		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Lev) 	;//hl=value of 'var_wrd_Lev' [Qc053]
		call	Quig_g9k_Ink_Fade		;/ Call Function [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_Pal1) 	;//hl=value of 'var_wrd_Pal1' [Qc053]
		call	Quig_G9k_Ink_G_Get		;/ Call Function [Qc052]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pal2) 	;//hl=value of 'var_wrd_Pal2' [Qc053]
		call	Quig_G9k_Ink_G_Get		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Lev) 	;//hl=value of 'var_wrd_Lev' [Qc053]
		call	Quig_g9k_Ink_Fade		;/ Call Function [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_Pal1) 	;//hl=value of 'var_wrd_Pal1' [Qc053]
		call	Quig_G9k_Ink_B_Get		;/ Call Function [Qc052]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pal2) 	;//hl=value of 'var_wrd_Pal2' [Qc053]
		call	Quig_G9k_Ink_B_Get		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Lev) 	;//hl=value of 'var_wrd_Lev' [Qc053]
		call	Quig_g9k_Ink_Fade		;/ Call Function [Qc052]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Ink_Set				;//Call 'Ink.Set' [Qc234]
.QLn_191		;//Pal1=Pal1+1
		ld		hl,(var_wrd_Pal1) 	;//hl=value of 'var_wrd_Pal1' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Pal1),hl		;//Int variable 'var_wrd_Pal1'=expression result [Qc219]
.QLn_192		;//Pal2=Pal2+1
		ld		hl,(var_wrd_Pal2) 	;//hl=value of 'var_wrd_Pal2' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Pal2),hl		;//Int variable 'var_wrd_Pal2'=expression result [Qc219]
.QLn_193		;//Pal3=Pal3+1
		ld		hl,(var_wrd_Pal3) 	;//hl=value of 'var_wrd_Pal3' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Pal3),hl		;//Int variable 'var_wrd_Pal3'=expression result [Qc219]
.QLn_194		;//Next
		ld		hl,(var_wrd_Loop) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1148_Loop		;// [Qc340]
.QFr1148_Exit:
.QLn_195		;//EndF
		ret		;// [Qc262]
.QLn_199		;//Function ScoreUP:Void
.QFunc_SCOREUP
.QLn_200		;//Score=Score+1
		ld		hl,(var_wrd_Score) 	;//hl=value of 'var_wrd_Score' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Score),hl		;//Int variable 'var_wrd_Score'=expression result [Qc219]
.QLn_201		;//If Score => TopScore	Then
		ld		hl,(var_wrd_Score) 	;//hl=value of 'var_wrd_Score' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_TopScore) 	;//hl=value of 'var_wrd_TopScore' [Qc053]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf1219_Exit				;// [Qc1220]
.QLn_202		;//TopScore=Score
		ld		hl,(var_wrd_Score) 	;//hl=value of 'var_wrd_Score' [Qc053]
		ld		(var_wrd_TopScore),hl		;//Int variable 'var_wrd_TopScore'=expression result [Qc219]
.QLn_203		;//EndIf
.QIf1219_Exit:
.QLn_205		;//Digit0=Digit0+1
		ld		hl,(var_wrd_Digit0) 	;//hl=value of 'var_wrd_Digit0' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Digit0),hl		;//Int variable 'var_wrd_Digit0'=expression result [Qc219]
.QLn_206		;//If Digit0>9 Then
		Ld		de,(var_wrd_Digit0)			;// Optimize -1- [Qc1001]
		Ld		hl,9			;// [Qc1002]
		call 	Quig_GT_HL_Direct		;// Optimize -3d- [Qc1219]
		jp		z,QIf1236_Exit				;// [Qc1220]
.QLn_207		;//Digit0=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit0),hl		;//Int variable 'var_wrd_Digit0'=expression result [Qc219]
.QLn_208		;//Digit1=Digit1+1
		ld		hl,(var_wrd_Digit1) 	;//hl=value of 'var_wrd_Digit1' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Digit1),hl		;//Int variable 'var_wrd_Digit1'=expression result [Qc219]
.QLn_209		;//If Digit1>9 Then
		Ld		de,(var_wrd_Digit1)			;// Optimize -1- [Qc1001]
		Ld		hl,9			;// [Qc1002]
		call 	Quig_GT_HL_Direct		;// Optimize -3d- [Qc1219]
		jp		z,QIf1251_Exit				;// [Qc1220]
.QLn_210		;//Digit1=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit1),hl		;//Int variable 'var_wrd_Digit1'=expression result [Qc219]
.QLn_211		;//Digit2=Digit2+1
		ld		hl,(var_wrd_Digit2) 	;//hl=value of 'var_wrd_Digit2' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_Digit2),hl		;//Int variable 'var_wrd_Digit2'=expression result [Qc219]
.QLn_212		;//If Digit2>9 Then
		Ld		de,(var_wrd_Digit2)			;// Optimize -1- [Qc1001]
		Ld		hl,9			;// [Qc1002]
		call 	Quig_GT_HL_Direct		;// Optimize -3d- [Qc1219]
		jp		z,QIf1266_Exit				;// [Qc1220]
.QLn_213		;//Digit2=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit2),hl		;//Int variable 'var_wrd_Digit2'=expression result [Qc219]
.QLn_214		;//EndIf
.QIf1266_Exit:
.QLn_215		;//Sprite.Pattern.Set 52, 124+(Digit2*2)
		ld		hl,52		;//hl=number '52' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit2)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_216		;//Sprite.Pattern.Set 53, 125+(Digit2*2)
		ld		hl,53		;//hl=number '53' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit2)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_217		;//EndIf
.QIf1251_Exit:
.QLn_218		;//Sprite.Pattern.Set 50, 124+(Digit1*2)
		ld		hl,50		;//hl=number '50' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit1)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_219		;//Sprite.Pattern.Set 51, 125+(Digit1*2)
		ld		hl,51		;//hl=number '51' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit1)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_220		;//EndIf
.QIf1236_Exit:
.QLn_221		;//Sprite.Pattern.Set 48, 124+(Digit0*2)
		ld		hl,48		;//hl=number '48' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit0)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_222		;//Sprite.Pattern.Set 49, 125+(Digit0*2)
		ld		hl,49		;//hl=number '49' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit0)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_224		;//EndF
		ret		;// [Qc262]
.QLn_227		;//Function DisplayAndResetScore:Void
.QFunc_DISPLAYANDRESETSCORE
.QLn_229		;//Digit0=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit0),hl		;//Int variable 'var_wrd_Digit0'=expression result [Qc219]
.QLn_230		;//Digit1=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit1),hl		;//Int variable 'var_wrd_Digit1'=expression result [Qc219]
.QLn_231		;//Digit2=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Digit2),hl		;//Int variable 'var_wrd_Digit2'=expression result [Qc219]
.QLn_233		;//Sprite.Pattern.Set 48, 124+(Digit0*2)
		ld		hl,48		;//hl=number '48' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit0)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_234		;//Sprite.Pattern.Set 49, 125+(Digit0*2)
		ld		hl,49		;//hl=number '49' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit0)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_235		;//Sprite.Pattern.Set 50, 124+(Digit1*2)
		ld		hl,50		;//hl=number '50' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit1)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_236		;//Sprite.Pattern.Set 51, 125+(Digit1*2)
		ld		hl,51		;//hl=number '51' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit1)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_237		;//Sprite.Pattern.Set 52, 124+(Digit2*2)
		ld		hl,52		;//hl=number '52' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,124		;//hl=number '124' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit2)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_238		;//Sprite.Pattern.Set 53, 125+(Digit2*2)
		ld		hl,53		;//hl=number '53' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,125		;//hl=number '125' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Digit2)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_240		;//Sprite.Position.Set 52,104,180
		ld		hl,52		;//hl=number '52' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,104			;// Optimize -6- [Qc1040]
		ld		hl,180		;//hl=number '180' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_241		;//Sprite.Position.Set 53,104,196
		ld		hl,53		;//hl=number '53' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,104			;// Optimize -6- [Qc1040]
		ld		hl,196		;//hl=number '196' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_242		;//Sprite.Position.Set 50,120,180
		ld		hl,50		;//hl=number '50' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,120			;// Optimize -6- [Qc1040]
		ld		hl,180		;//hl=number '180' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_243		;//Sprite.Position.Set 51,120,196
		ld		hl,51		;//hl=number '51' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,120			;// Optimize -6- [Qc1040]
		ld		hl,196		;//hl=number '196' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_244		;//Sprite.Position.Set 48,136,180
		ld		hl,48		;//hl=number '48' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,136			;// Optimize -6- [Qc1040]
		ld		hl,180		;//hl=number '180' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_245		;//Sprite.Position.Set 49,136,196
		ld		hl,49		;//hl=number '49' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,136			;// Optimize -6- [Qc1040]
		ld		hl,196		;//hl=number '196' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_247		;//EndF
		ret		;// [Qc262]
.QLn_251		;//Function Restart:Void()
.QFunc_RESTART
.QLn_253		;//Score=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Score),hl		;//Int variable 'var_wrd_Score'=expression result [Qc219]
.QLn_254		;//GameOn=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_255		;//waittostart=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_waittostart),hl		;//Int variable 'var_wrd_waittostart'=expression result [Qc219]
.QLn_256		;//Pauze=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Pauze),hl		;//Int variable 'var_wrd_Pauze'=expression result [Qc219]
.QLn_257		;//BirdX1=114
		ld		hl,114		;//hl=number '114' [Qc054]
		ld		(var_wrd_BirdX1),hl		;//Int variable 'var_wrd_BirdX1'=expression result [Qc219]
.QLn_258		;//BirdY1=60
		ld		hl,60		;//hl=number '60' [Qc054]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_260		;//Sprite.Pattern.Set 36,191
		Ld 		de,36			;// Optimize -6- [Qc1040]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_261		;//Sprite.Pattern.Set 37,191
		Ld 		de,37			;// Optimize -6- [Qc1040]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_262		;//Sprite.Pattern.Set	 110,191
		Ld 		de,110			;// Optimize -6- [Qc1040]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_264		;//pipespeed=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_pipespeed),hl		;//Int variable 'var_wrd_pipespeed'=expression result [Qc219]
.QLn_265		;//pipe1X=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_pipe1X),hl		;//Int variable 'var_wrd_pipe1X'=expression result [Qc219]
.QLn_266		;//pipe1y=143
		ld		hl,143		;//hl=number '143' [Qc054]
		ld		(var_wrd_pipe1y),hl		;//Int variable 'var_wrd_pipe1y'=expression result [Qc219]
.QLn_267		;//pipe2X=100
		ld		hl,100		;//hl=number '100' [Qc054]
		ld		(var_wrd_pipe2X),hl		;//Int variable 'var_wrd_pipe2X'=expression result [Qc219]
.QLn_268		;//pipe2y=143
		ld		hl,143		;//hl=number '143' [Qc054]
		ld		(var_wrd_pipe2y),hl		;//Int variable 'var_wrd_pipe2y'=expression result [Qc219]
.QLn_269		;//pipe3X=200
		ld		hl,200		;//hl=number '200' [Qc054]
		ld		(var_wrd_pipe3X),hl		;//Int variable 'var_wrd_pipe3X'=expression result [Qc219]
.QLn_270		;//pipe3y=143
		ld		hl,143		;//hl=number '143' [Qc054]
		ld		(var_wrd_pipe3y),hl		;//Int variable 'var_wrd_pipe3y'=expression result [Qc219]
.QLn_271		;//Pipe1SizeGab=5
		ld		hl,5		;//hl=number '5' [Qc054]
		ld		(var_wrd_Pipe1SizeGab),hl		;//Int variable 'var_wrd_Pipe1SizeGab'=expression result [Qc219]
.QLn_272		;//Pipe1GabStart=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_Pipe1GabStart),hl		;//Int variable 'var_wrd_Pipe1GabStart'=expression result [Qc219]
.QLn_273		;//Pipe2SizeGab=5
		ld		hl,5		;//hl=number '5' [Qc054]
		ld		(var_wrd_Pipe2SizeGab),hl		;//Int variable 'var_wrd_Pipe2SizeGab'=expression result [Qc219]
.QLn_274		;//Pipe2GabStart=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_Pipe2GabStart),hl		;//Int variable 'var_wrd_Pipe2GabStart'=expression result [Qc219]
.QLn_275		;//Pipe3SizeGab=5
		ld		hl,5		;//hl=number '5' [Qc054]
		ld		(var_wrd_Pipe3SizeGab),hl		;//Int variable 'var_wrd_Pipe3SizeGab'=expression result [Qc219]
.QLn_276		;//Pipe3GabStart=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_Pipe3GabStart),hl		;//Int variable 'var_wrd_Pipe3GabStart'=expression result [Qc219]
.QLn_277		;//RemoveScoreBoard
		call	QFunc_RemoveScoreBoard				;//Call 'RemoveScoreBoard' [Qc234]
.QLn_279		;//SetPipe1
		call	QFunc_SetPipe1				;//Call 'SetPipe1' [Qc234]
.QLn_280		;//SetPipe2
		call	QFunc_SetPipe2				;//Call 'SetPipe2' [Qc234]
.QLn_281		;//SetPipe3
		call	QFunc_SetPipe3				;//Call 'SetPipe3' [Qc234]
.QLn_283		;//Sprite.Position.Group0.Set 68,pipe1X,143,2,10
		ld		hl,68		;//hl=number '68' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe1X) 	;//hl=value of 'var_wrd_pipe1X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_285		;//Sprite.Position.Group0.Set 88,pipe2X,143,2,10
		ld		hl,88		;//hl=number '88' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe2X) 	;//hl=value of 'var_wrd_pipe2X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_287		;//If menuOn=0 Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf1605_Exit				;// [Qc1012]
.QLn_288		;//If GameOn>1  Then
		Ld		de,(var_wrd_GameOn)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_GT_HL_Direct		;// Optimize -3d- [Qc1219]
		jp		z,QIf1613_Exit				;// [Qc1220]
.QLn_289		;//Sprite.Position.Group0.Set 10,pipe3X,143,2,10
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe3X) 	;//hl=value of 'var_wrd_pipe3X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_290		;//EndIf
.QIf1613_Exit:
.QLn_291		;//EndIf
.QIf1605_Exit:
.QLn_292		;//falldown=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_falldown),hl		;//Int variable 'var_wrd_falldown'=expression result [Qc219]
.QLn_294		;//ShowLogo
		call	QFunc_ShowLogo				;//Call 'ShowLogo' [Qc234]
.QLn_295		;//ShowTab
		call	QFunc_ShowTab				;//Call 'ShowTab' [Qc234]
.QLn_297		;//EndF
		ret		;// [Qc262]
.QLn_301		;//Function LoadGame:Void:()
.QFunc_LOADGAME
.QLn_305		;//PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy1.qpt",0,0)
		call	Quig_App_Path		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,directstr_2+2		;//hl points static string [Qc055]
		call	Quig_Str_Add		;//Compare strings equals HL=DE [Qc057]
		push		hl 		;//Store result [Qc001]
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_TileALoad		;/ Call Function [Qc052]
		ld		(var_wrd_PattsLoaded),hl		;//Int variable 'var_wrd_PattsLoaded'=expression result [Qc219]
.QLn_308		;//Ink.Palette.Set 1,240
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,240		;//hl=number '240' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_310		;//For f=0 To 124
		ld		hl,124		;//hl=number '124' [Qc054]
		ld 		(QFr1659_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1659_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr1659_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1659_Start	;// [Qc307]
		jp		nz,QFr1659_Exit	;// [Qc308]
.QFr1659_Start:
.QLn_311		;//Sprite.Palette.Set f,0
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Palette				;//Call 'Sprite.Palette.Set' [Qc234]
.QLn_312		;//Sprite.Position.Set f,f,166
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_313		;//Sprite.Pattern.Set f,191
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_314		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1659_Loop		;// [Qc340]
.QFr1659_Exit:
.QLn_317		;//Sprite.Pattern.Set 0,2
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_318		;//Sprite.Pattern.Set 1,22
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,22		;//hl=number '22' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_319		;//Sprite.Pattern.Set 2,0
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_321		;//Sprite.Position.Set 1,2,2
		ld		hl,1		;//hl=number '1' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_322		;//Sprite.Position.Set 2,238,2
		ld		hl,2		;//hl=number '2' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,238			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_326		;//PattsLoaded = Fore.Pattern.Load (App.Path+ "flappy3.qpt",832,16)
		call	Quig_App_Path		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,directstr_3+2		;//hl points static string [Qc055]
		call	Quig_Str_Add		;//Compare strings equals HL=DE [Qc057]
		push		hl 		;//Store result [Qc001]
		Ld 		de,832			;// Optimize -6- [Qc1040]
		ld		hl,16		;//hl=number '16' [Qc054]
		call	Quig_g9k_TileALoad		;/ Call Function [Qc052]
		ld		(var_wrd_PattsLoaded),hl		;//Int variable 'var_wrd_PattsLoaded'=expression result [Qc219]
.QLn_328		;//PattsLoaded = Back.Pattern.Load(App.Path+ "flappy2.qpt",2880,48)
		call	Quig_App_Path		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,directstr_4+2		;//hl points static string [Qc055]
		call	Quig_Str_Add		;//Compare strings equals HL=DE [Qc057]
		push		hl 		;//Store result [Qc001]
		Ld 		de,2880			;// Optimize -6- [Qc1040]
		ld		hl,48		;//hl=number '48' [Qc054]
		call	Quig_g9k_TileBLoad		;/ Call Function [Qc052]
		ld		(var_wrd_PattsLoaded),hl		;//Int variable 'var_wrd_PattsLoaded'=expression result [Qc219]
.QLn_332		;//For  f=127 To 0 Step -8
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		(QFr1743_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,127		;//hl=number '127' [Qc054]
		.QFr1743_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr1743_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		ld		a,h			;// HL<DE THEN BRANCH IF FALSE [Qc320]
		xor		d 			;// [Qc321]
		jp		m,QFr1743_1x	;// [Qc322]
		sbc		hl,de 		;// [Qc323]
		jr		nc,QFr1743_Start 	 ;// [Qc325]
		jp		QFr1743_Exit	;// [Qc328]
		.QFr1743_1x:bit		7,d		;// [Qc326]
		jp		z,QFr1743_Exit	;// [Qc327]
.QFr1743_Start:
.QLn_333		;//PalFade(32,240,128,f)
		ld		hl,32		;//hl=number '32' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,240		;//hl=number '240' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,128			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	QFunc_PalFade				;//Call 'PalFade' [Qc234]
.QLn_334		;//Ink.Palette.Set 3,128
		Ld 		de,3			;// Optimize -6- [Qc1040]
		ld		hl,128		;//hl=number '128' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_335		;//VWait
		call	Quig_G9K_VWait				;//Call 'VWait' [Qc234]
.QLn_336		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		ld		de,-8		;// [Qc338]
		add		hl,de 	;// [Qc339]
		jp		QFr1743_Loop		;// [Qc340]
.QFr1743_Exit:
.QLn_340		;//i=832
		ld		hl,832		;//hl=number '832' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_341		;//For f=0 To 31
		ld		hl,31		;//hl=number '31' [Qc054]
		ld 		(QFr1783_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1783_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr1783_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1783_Start	;// [Qc307]
		jp		nz,QFr1783_Exit	;// [Qc308]
.QFr1783_Start:
.QLn_342		;//For g=0 To 63
		ld		hl,63		;//hl=number '63' [Qc054]
		ld 		(QFr1794_Top+1),hl 		;/Copy Result into static'var_wrd_g' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1794_Loop:ld 		(var_wrd_g),hl ;/Loop Repeat Point [Qc301]
		.QFr1794_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1794_Start	;// [Qc307]
		jp		nz,QFr1794_Exit	;// [Qc308]
.QFr1794_Start:
.QLn_343		;//Fore.ScreenMap.Set i,g,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_g) 	;//hl=value of 'var_wrd_g' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_DrawTileA				;//Call 'Fore.ScreenMap.Set' [Qc234]
.QLn_344		;//i=i+1
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_345		;//Next
		ld		hl,(var_wrd_g) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1794_Loop		;// [Qc340]
.QFr1794_Exit:
.QLn_346		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1783_Loop		;// [Qc340]
.QFr1783_Exit:
.QLn_348		;//i=2880
		ld		hl,2880		;//hl=number '2880' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_349		;//For f=0 To 31
		ld		hl,31		;//hl=number '31' [Qc054]
		ld 		(QFr1829_Top+1),hl 		;/Copy Result into static'var_wrd_f' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1829_Loop:ld 		(var_wrd_f),hl ;/Loop Repeat Point [Qc301]
		.QFr1829_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1829_Start	;// [Qc307]
		jp		nz,QFr1829_Exit	;// [Qc308]
.QFr1829_Start:
.QLn_350		;//For g=0 To 63
		ld		hl,63		;//hl=number '63' [Qc054]
		ld 		(QFr1840_Top+1),hl 		;/Copy Result into static'var_wrd_g' [Qc303]
		ld		hl,0		;//hl=number '0' [Qc054]
		.QFr1840_Loop:ld 		(var_wrd_g),hl ;/Loop Repeat Point [Qc301]
		.QFr1840_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr1840_Start	;// [Qc307]
		jp		nz,QFr1840_Exit	;// [Qc308]
.QFr1840_Start:
.QLn_351		;//Back.ScreenMap.Set i,g,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_g) 	;//hl=value of 'var_wrd_g' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_DrawTileB				;//Call 'Back.ScreenMap.Set' [Qc234]
.QLn_352		;//i=i+1
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_353		;//Next
		ld		hl,(var_wrd_g) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1840_Loop		;// [Qc340]
.QFr1840_Exit:
.QLn_354		;//Next
		ld		hl,(var_wrd_f) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr1829_Loop		;// [Qc340]
.QFr1829_Exit:
.QLn_358		;//Ink.Palette.Set 0,0
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_359		;//Ink.Palette.Set 1,16
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,16		;//hl=number '16' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_360		;//Ink.Palette.Set 2,48
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,48		;//hl=number '48' [Qc054]
		call	Quig_G9k_Ink_Palette_Set				;//Call 'Ink.Palette.Set' [Qc234]
.QLn_362		;//Back.Palette.Set 2
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Back_Palette_Set				;//Call 'Back.Palette.Set' [Qc234]
.QLn_363		;//Fore.Palette.Set 1
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_Fore_Palette_Set				;//Call 'Fore.Palette.Set' [Qc234]
.QLn_367		;//SetPipe1
		call	QFunc_SetPipe1				;//Call 'SetPipe1' [Qc234]
.QLn_368		;//MovePipe1
		call	QFunc_MovePipe1				;//Call 'MovePipe1' [Qc234]
.QLn_370		;//SetPipe2
		call	QFunc_SetPipe2				;//Call 'SetPipe2' [Qc234]
.QLn_371		;//MovePipe2
		call	QFunc_MovePipe2				;//Call 'MovePipe2' [Qc234]
.QLn_373		;//SetPipe3
		call	QFunc_SetPipe3				;//Call 'SetPipe3' [Qc234]
.QLn_374		;//MovePipe3
		call	QFunc_MovePipe3				;//Call 'MovePipe3' [Qc234]
.QLn_379		;//ShowTab
		call	QFunc_ShowTab				;//Call 'ShowTab' [Qc234]
.QLn_380		;//ShowLogo
		call	QFunc_ShowLogo				;//Call 'ShowLogo' [Qc234]
.QLn_383		;//loading=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_loading),hl		;//Int variable 'var_wrd_loading'=expression result [Qc219]
.QLn_384		;//GameOn=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_386		;//EndF
		ret		;// [Qc262]
.QLn_390		;//Function Main:Void()
.QFunc_MAIN
.QLn_394		;//If loading=0 Then
		Ld		hl,(var_wrd_loading)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf1928_Exit				;// [Qc1012]
.QLn_395		;//loading=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_loading),hl		;//Int variable 'var_wrd_loading'=expression result [Qc219]
.QLn_396		;//LoadGame
		call	QFunc_LoadGame				;//Call 'LoadGame' [Qc234]
.QLn_397		;//EndIf
.QIf1928_Exit:
.QLn_399		;//If loading=1 Then
		Ld		hl,(var_wrd_loading)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf1948_Exit				;// [Qc1012]
.QLn_402		;//If GameOn=1 And menuOn=0 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf1978_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_404		;//PlayButtonAnimation=PlayButtonAnimation+1
		ld		hl,(var_wrd_PlayButtonAnimation) 	;//hl=value of 'var_wrd_PlayButtonAnimation' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_PlayButtonAnimation),hl		;//Int variable 'var_wrd_PlayButtonAnimation'=expression result [Qc219]
.QLn_405		;//If PlayButtonAnimation=20 Then
		Ld		hl,(var_wrd_PlayButtonAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,20			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf1995_Exit				;// [Qc1012]
.QLn_406		;//RemovePlay
		call	QFunc_RemovePlay				;//Call 'RemovePlay' [Qc234]
.QLn_407		;//Else
		jp		QIf1995_Exit2		;//Jump to EndIf
.QIf1995_Exit:
.QLn_408		;//If PlayButtonAnimation = 40 Then
		Ld		hl,(var_wrd_PlayButtonAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,40			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2013_Exit				;// [Qc1012]
.QLn_409		;//ShowPlay
		call	QFunc_ShowPlay				;//Call 'ShowPlay' [Qc234]
.QLn_410		;//PlayButtonAnimation=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_PlayButtonAnimation),hl		;//Int variable 'var_wrd_PlayButtonAnimation'=expression result [Qc219]
.QLn_411		;//EndIf
.QIf2013_Exit:
.QLn_412		;//EndIf
.QIf1995_Exit2:
.QLn_413		;//EndIf
.QIf1978_Exit:
.QLn_416		;//If GameOn=4 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,4			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2037_Exit				;// [Qc1012]
.QLn_417		;//getReadyAnimation=getReadyAnimation+1
		ld		hl,(var_wrd_getReadyAnimation) 	;//hl=value of 'var_wrd_getReadyAnimation' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_getReadyAnimation),hl		;//Int variable 'var_wrd_getReadyAnimation'=expression result [Qc219]
.QLn_418		;//If getReadyAnimation=10 Then
		Ld		hl,(var_wrd_getReadyAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,10			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2054_Exit				;// [Qc1012]
.QLn_419		;//RemoveGetReady
		call	QFunc_RemoveGetReady				;//Call 'RemoveGetReady' [Qc234]
.QLn_420		;//Else
		jp		QIf2054_Exit2		;//Jump to EndIf
.QIf2054_Exit:
.QLn_421		;//If getReadyAnimation = 20 Then
		Ld		hl,(var_wrd_getReadyAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,20			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2072_Exit				;// [Qc1012]
.QLn_422		;//ShowGetReady
		call	QFunc_ShowGetReady				;//Call 'ShowGetReady' [Qc234]
.QLn_423		;//getReadyAnimation=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_getReadyAnimation),hl		;//Int variable 'var_wrd_getReadyAnimation'=expression result [Qc219]
.QLn_424		;//EndIf
.QIf2072_Exit:
.QLn_425		;//EndIf
.QIf2054_Exit2:
.QLn_427		;//EndIf
.QIf2037_Exit:
.QLn_432		;//mouseX = Mouse.X
		call	Quig_Mouse_X		;/ Call Function [Qc052]
		ld		(var_wrd_mouseX),hl		;//Int variable 'var_wrd_mouseX'=expression result [Qc219]
.QLn_433		;//mouseY = Mouse.Y
		call	Quig_Mouse_Y		;/ Call Function [Qc052]
		ld		(var_wrd_mouseY),hl		;//Int variable 'var_wrd_mouseY'=expression result [Qc219]
.QLn_434		;//MouseKey = Mouse.Key
		call	Quig_Mouse_Key		;/ Call Function [Qc052]
		ld		(var_wrd_MouseKey),hl		;//Int variable 'var_wrd_MouseKey'=expression result [Qc219]
.QLn_438		;//mouseX = Max(3,Min(mouseX,250))
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_mouseX)			;// Optimize -1- [Qc1001]
		Ld		hl,250			;// [Qc1002]
		call	Quig_Min_Int		;/ Call Function [Qc052]
		pop		de		;//Restore value from stack [Qc050]
		call	Quig_Max_Int		;/ Call Function [Qc052]
		ld		(var_wrd_mouseX),hl		;//Int variable 'var_wrd_mouseX'=expression result [Qc219]
.QLn_439		;//mouseY = Max(3,Min(mouseY,203))
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_mouseY)			;// Optimize -1- [Qc1001]
		Ld		hl,203			;// [Qc1002]
		call	Quig_Min_Int		;/ Call Function [Qc052]
		pop		de		;//Restore value from stack [Qc050]
		call	Quig_Max_Int		;/ Call Function [Qc052]
		ld		(var_wrd_mouseY),hl		;//Int variable 'var_wrd_mouseY'=expression result [Qc219]
.QLn_440		;//Sprite.Position.Set 0,mouseX,mouseY
		ld		hl,0		;//hl=number '0' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_443		;//If GameOn=1 And menuOn=0 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2149_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_445		;//If MouseKey = 1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2162_Exit				;// [Qc1012]
.QLn_446		;//If Collide(mouseX,mouseY,10,10,97,120,64,32)=1  Then
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,97		;//hl=number '97' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,120		;//hl=number '120' [Qc054]
		push		hl 		;//Store result [Qc001]
		Ld 		de,64			;// Optimize -6- [Qc1040]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2190_Exit				;// [Qc1012]
.QLn_447		;//RemovePlay
		call	QFunc_RemovePlay				;//Call 'RemovePlay' [Qc234]
.QLn_449		;//Sprite.Pattern.Set 36,174
		Ld 		de,36			;// Optimize -6- [Qc1040]
		ld		hl,174		;//hl=number '174' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_450		;//Sprite.Pattern.Set 37,175
		Ld 		de,37			;// Optimize -6- [Qc1040]
		ld		hl,175		;//hl=number '175' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_451		;//Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
		ld		hl,36		;//hl=number '36' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_452		;//ShowGetReady
		call	QFunc_ShowGetReady				;//Call 'ShowGetReady' [Qc234]
.QLn_453		;//DisplayAndResetScore
		call	QFunc_DisplayAndResetScore				;//Call 'DisplayAndResetScore' [Qc234]
.QLn_454		;//pipespeed=4
		ld		hl,4		;//hl=number '4' [Qc054]
		ld		(var_wrd_pipespeed),hl		;//Int variable 'var_wrd_pipespeed'=expression result [Qc219]
.QLn_455		;//GameOn=2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_456		;//EndIf
.QIf2190_Exit:
.QLn_457		;//EndIf
.QIf2162_Exit:
.QLn_458		;//EndIf
.QIf2149_Exit:
.QLn_460		;//If menuOn=0 Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2242_Exit				;// [Qc1012]
.QLn_462		;//If MouseKey = 1 And menuOn=0 And Collide(mouseX,mouseY,10,10,238,2,20,20)=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,238		;//hl=number '238' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,2		;//hl=number '2' [Qc054]
		push		hl 		;//Store result [Qc001]
		Ld 		de,20			;// Optimize -6- [Qc1040]
		ld		hl,20		;//hl=number '20' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2304_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_463		;//menuOn=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_menuOn),hl		;//Int variable 'var_wrd_menuOn'=expression result [Qc219]
.QLn_464		;//EndIf
.QIf2304_Exit:
.QLn_467		;//If MouseKey = 1 And menuOn=0 And Collide(mouseX,mouseY,10,10,2,2,20,20)=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,2		;//hl=number '2' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,2		;//hl=number '2' [Qc054]
		push		hl 		;//Store result [Qc001]
		Ld 		de,20			;// Optimize -6- [Qc1040]
		ld		hl,20		;//hl=number '20' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2371_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_468		;//If Pauze=1 Then
		Ld		hl,(var_wrd_Pauze)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2384_Exit				;// [Qc1012]
.QLn_469		;//Pauze=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Pauze),hl		;//Int variable 'var_wrd_Pauze'=expression result [Qc219]
.QLn_470		;//Sprite.Pattern.Set 1,22
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,22		;//hl=number '22' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_471		;//Else
		jp		QIf2384_Exit2		;//Jump to EndIf
.QIf2384_Exit:
.QLn_472		;//Pauze=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_Pauze),hl		;//Int variable 'var_wrd_Pauze'=expression result [Qc219]
.QLn_473		;//Sprite.Pattern.Set 1,24
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,24		;//hl=number '24' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_474		;//EndIf
.QIf2384_Exit2:
.QLn_475		;//MouseKey=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_MouseKey),hl		;//Int variable 'var_wrd_MouseKey'=expression result [Qc219]
.QLn_476		;//EndIf
.QIf2371_Exit:
.QLn_477		;//Else
		jp		QIf2242_Exit2		;//Jump to EndIf
.QIf2242_Exit:
.QLn_478		;//If menuOn=2 Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,2			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2426_Exit				;// [Qc1012]
.QLn_480		;//If MouseKey=1 And  menuOn=2 And Collide(mouseX,mouseY,10,10,menuX+96,menuY+48,32,10)=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,2			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuX)			;// Optimize -1a- [Qc1060]
		Ld		de,96			;// [Qc1061]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuY)			;// Optimize -1a- [Qc1060]
		Ld		de,48			;// [Qc1061]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		push		hl 		;//Store result [Qc001]
		Ld 		de,32			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2494_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_481		;//App.Exit
		call	Quig_End				;//Call 'App.Exit' [Qc234]
.QLn_482		;//EndIf
.QIf2494_Exit:
.QLn_484		;//If MouseKey=1 And  menuOn=2 And Collide(mouseX,mouseY,10,10,menuX+110,menuY,20,20)=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,2			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuX)			;// Optimize -1a- [Qc1060]
		Ld		de,110			;// [Qc1061]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_menuY) 	;//hl=value of 'var_wrd_menuY' [Qc053]
		push		hl 		;//Store result [Qc001]
		Ld 		de,20			;// Optimize -6- [Qc1040]
		ld		hl,20		;//hl=number '20' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2563_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_485		;//RemoveMenu
		call	QFunc_RemoveMenu				;//Call 'RemoveMenu' [Qc234]
.QLn_486		;//menuX=64
		ld		hl,64		;//hl=number '64' [Qc054]
		ld		(var_wrd_menuX),hl		;//Int variable 'var_wrd_menuX'=expression result [Qc219]
.QLn_487		;//menuY=64
		ld		hl,64		;//hl=number '64' [Qc054]
		ld		(var_wrd_menuY),hl		;//Int variable 'var_wrd_menuY'=expression result [Qc219]
.QLn_488		;//If GameOn= 6 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,6			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2584_Exit				;// [Qc1012]
.QLn_489		;//ShowScoreBoard
		call	QFunc_ShowScoreBoard				;//Call 'ShowScoreBoard' [Qc234]
.QLn_490		;//EndIf
.QIf2584_Exit:
.QLn_491		;//menuOn=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_menuOn),hl		;//Int variable 'var_wrd_menuOn'=expression result [Qc219]
.QLn_492		;//EndIf
.QIf2563_Exit:
.QLn_496		;//If MouseKey=1  And Collide(menuX,menuY,104,10,mouseX,mouseY,104,10)=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_menuX) 	;//hl=value of 'var_wrd_menuX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_menuY) 	;//hl=value of 'var_wrd_menuY' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,104		;//hl=number '104' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_mouseY) 	;//hl=value of 'var_wrd_mouseY' [Qc053]
		push		hl 		;//Store result [Qc001]
		Ld 		de,104			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2638_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_497		;//menuX=mouseX-50
		Ld		hl,(var_wrd_mouseX)			;// Optimize -1a- [Qc1064]
		Ld		de,50			;// [Qc1065]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_menuX),hl		;//Int variable 'var_wrd_menuX'=expression result [Qc219]
.QLn_498		;//menuY=mouseY-4
		Ld		hl,(var_wrd_mouseY)			;// Optimize -1a- [Qc1064]
		Ld		de,4			;// [Qc1065]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_menuY),hl		;//Int variable 'var_wrd_menuY'=expression result [Qc219]
.QLn_499		;//Sprite.Position.Group.Set 3,menuX,menuY,8,4
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_menuX) 	;//hl=value of 'var_wrd_menuX' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_menuY) 	;//hl=value of 'var_wrd_menuY' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,8			;// Optimize -6- [Qc1040]
		ld		hl,4		;//hl=number '4' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_501		;//EndIf
.QIf2638_Exit:
.QLn_503		;//EndIf
.QIf2426_Exit:
.QLn_505		;//If menuOn=1 Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2682_Exit				;// [Qc1012]
.QLn_506		;//menuOn=2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_menuOn),hl		;//Int variable 'var_wrd_menuOn'=expression result [Qc219]
.QLn_507		;//ShowMenu
		call	QFunc_ShowMenu				;//Call 'ShowMenu' [Qc234]
.QLn_508		;//EndIf
.QIf2682_Exit:
.QLn_510		;//EndIf
.QIf2242_Exit2:
.QLn_517		;//Fore.Scroll	 Shl2(g),160
		ld		hl,(var_wrd_g) 	;//hl=value of 'var_wrd_g' [Qc053]
		call	Quig_Shl2		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc232]
		ld		hl,160		;//hl=number '160' [Qc054]
		call	Quig_g9k_Scroll_A_Set				;//Call 'Fore.Scroll' [Qc234]
.QLn_518		;//Back.Scroll 	Shl2(Shr1(h)),Shl2(60+Shr4(BirdY1))
		ld		hl,(var_wrd_h) 	;//hl=value of 'var_wrd_h' [Qc053]
		call	Quig_Shr1		;/ Call Function [Qc052]
		call	Quig_Shl2		;/ Call Function [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,60		;//hl=number '60' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		call	Quig_Shr4		;/ Call Function [Qc052]
		pop		de		;//Restore value from stack [Qc050]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		call	Quig_Shl2		;/ Call Function [Qc052]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_g9k_Scroll_B_Set				;//Call 'Back.Scroll' [Qc234]
.QLn_519		;//Sprite.Refresh
		call	Quig_G9K_Sprite_Refresh				;//Call 'Sprite.Refresh' [Qc234]
.QLn_521		;//g=(g+3)  And 511				;Layer 1 scroll moves left but wraps 512
		Ld		hl,(var_wrd_g)			;// Optimize -1a- [Qc1060]
		Ld		de,3			;// [Qc1061]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,511		;//hl=number '511' [Qc054]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		(var_wrd_g),hl		;//Int variable 'var_wrd_g'=expression result [Qc219]
.QLn_522		;//h=(h+1)  And  1023				;Layer B scroll moves left but wraps 1024 as /2 for half speed
		ld		hl,(var_wrd_h) 	;//hl=value of 'var_wrd_h' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc269]
		ld		hl,1023		;//hl=number '1023' [Qc054]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		(var_wrd_h),hl		;//Int variable 'var_wrd_h'=expression result [Qc219]
.QLn_526		;//If GameOn=4 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,4			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2752_Exit				;// [Qc1012]
.QLn_527		;//waittostart=waittostart+1
		ld		hl,(var_wrd_waittostart) 	;//hl=value of 'var_wrd_waittostart' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_waittostart),hl		;//Int variable 'var_wrd_waittostart'=expression result [Qc219]
.QLn_529		;//If waittostart=>150 Then
		Ld		de,(var_wrd_waittostart)			;// Optimize -1- [Qc1001]
		Ld		hl,150			;// [Qc1002]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf2764_Exit				;// [Qc1220]
.QLn_530		;//waittostart=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_waittostart),hl		;//Int variable 'var_wrd_waittostart'=expression result [Qc219]
.QLn_531		;//GameOn=5
		ld		hl,5		;//hl=number '5' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_532		;//RemoveGetReady
		call	QFunc_RemoveGetReady				;//Call 'RemoveGetReady' [Qc234]
.QLn_533		;//RemoveTab
		call	QFunc_RemoveTab				;//Call 'RemoveTab' [Qc234]
.QLn_534		;//pipespeed=2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_pipespeed),hl		;//Int variable 'var_wrd_pipespeed'=expression result [Qc219]
.QLn_536		;//EndIf
.QIf2764_Exit:
.QLn_537		;//EndIf
.QIf2752_Exit:
.QLn_539		;//If GameOn=3 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,3			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2794_Exit				;// [Qc1012]
.QLn_540		;//If MouseKey=1 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2807_Exit				;// [Qc1012]
.QLn_541		;//GameOn=4
		ld		hl,4		;//hl=number '4' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_542		;//EndIf
.QIf2807_Exit:
.QLn_543		;//EndIf
.QIf2794_Exit:
.QLn_545		;//If GameOn=6 And menuOn=0  Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,6			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf2844_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_546		;//If  MouseKey=2 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,2			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2857_Exit				;// [Qc1012]
.QLn_547		;//Restart
		call	QFunc_Restart				;//Call 'Restart' [Qc234]
.QLn_548		;//EndIf
.QIf2857_Exit:
.QLn_550		;//If falldown=1 Then
		Ld		hl,(var_wrd_falldown)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2874_Exit				;// [Qc1012]
.QLn_551		;//BirdY1=BirdY1+2
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		inc		hl		;//Plus 2 [Qc091]
		inc		hl		;// [Qc092]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_552		;//Sprite.Pattern.Set 36,204
		Ld 		de,36			;// Optimize -6- [Qc1040]
		ld		hl,204		;//hl=number '204' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_553		;//Sprite.Pattern.Set 37,191
		Ld 		de,37			;// Optimize -6- [Qc1040]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_554		;//Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
		ld		hl,36		;//hl=number '36' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_555		;//If BirdY1=>145 Then
		Ld		de,(var_wrd_BirdY1)			;// Optimize -1- [Qc1001]
		Ld		hl,145			;// [Qc1002]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf2908_Exit				;// [Qc1220]
.QLn_556		;//falldown=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_falldown),hl		;//Int variable 'var_wrd_falldown'=expression result [Qc219]
.QLn_557		;//Sprite.Pattern.Set	 110,204
		Ld 		de,110			;// Optimize -6- [Qc1040]
		ld		hl,204		;//hl=number '204' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_558		;//Sprite.Position.Set  110,BirdX1,BirdY1
		ld		hl,110		;//hl=number '110' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_559		;//RemovePipe
		call	QFunc_RemovePipe				;//Call 'RemovePipe' [Qc234]
.QLn_560		;//ShowScoreBoard
		call	QFunc_ShowScoreBoard				;//Call 'ShowScoreBoard' [Qc234]
.QLn_561		;//EndIf
.QIf2908_Exit:
.QLn_563		;//EndIf
.QIf2874_Exit:
.QLn_565		;//If  falldown=3 Then
		Ld		hl,(var_wrd_falldown)			;// Optimize -1a- [Qc1062]
		Ld		de,3			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2944_Exit				;// [Qc1012]
.QLn_566		;//waittostart=waittostart+1
		ld		hl,(var_wrd_waittostart) 	;//hl=value of 'var_wrd_waittostart' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_waittostart),hl		;//Int variable 'var_wrd_waittostart'=expression result [Qc219]
.QLn_567		;//If waittostart=>500 Then
		Ld		de,(var_wrd_waittostart)			;// Optimize -1- [Qc1001]
		Ld		hl,500			;// [Qc1002]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf2956_Exit				;// [Qc1220]
.QLn_568		;//waittostart=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_waittostart),hl		;//Int variable 'var_wrd_waittostart'=expression result [Qc219]
.QLn_569		;//Restart
		call	QFunc_Restart				;//Call 'Restart' [Qc234]
.QLn_570		;//EndIf
.QIf2956_Exit:
.QLn_571		;//EndIf
.QIf2944_Exit:
.QLn_573		;//EndIf
.QIf2844_Exit:
.QLn_576		;//If GameOn=5  Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,5			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf2980_Exit				;// [Qc1012]
.QLn_578		;//If MouseKey =1 And menuOn=0  Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf3010_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_581		;//If BirdX1<mouseX Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_mouseX) 	;//hl=value of 'var_wrd_mouseX' [Qc053]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf3018_Exit				;// [Qc1220]
.QLn_582		;//BirdX1=BirdX1+1
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_BirdX1),hl		;//Int variable 'var_wrd_BirdX1'=expression result [Qc219]
.QLn_583		;//Else
		jp		QIf3018_Exit2		;//Jump to EndIf
.QIf3018_Exit:
.QLn_584		;//BirdX1=BirdX1-1
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		dec		hl		;//Minus 1 [Qc093]
		ld		(var_wrd_BirdX1),hl		;//Int variable 'var_wrd_BirdX1'=expression result [Qc219]
.QLn_585		;//EndIf
.QIf3018_Exit2:
.QLn_587		;//EndIf
.QIf3010_Exit:
.QLn_589		;//If MouseKey = 1 And Jumping=0 Then
		Ld		hl,(var_wrd_MouseKey)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_Jumping)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf3063_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_590		;//JumpIncrement = -9
		ld		hl,-9		;//hl=number '-9' [Qc054]
		ld		(var_wrd_JumpIncrement),hl		;//Int variable 'var_wrd_JumpIncrement'=expression result [Qc219]
.QLn_591		;//Jumping=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_Jumping),hl		;//Int variable 'var_wrd_Jumping'=expression result [Qc219]
.QLn_592		;//EndIf
.QIf3063_Exit:
.QLn_593		;//If JumpIncrement<1 Then
		Ld		de,(var_wrd_JumpIncrement)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf3079_Exit				;// [Qc1220]
.QLn_594		;//JumpIncrement=JumpIncrement+1
		ld		hl,(var_wrd_JumpIncrement) 	;//hl=value of 'var_wrd_JumpIncrement' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_JumpIncrement),hl		;//Int variable 'var_wrd_JumpIncrement'=expression result [Qc219]
.QLn_595		;//EndIf
.QIf3079_Exit:
.QLn_596		;//If Jumping = 1 And JumpIncrement>0 Then
		Ld		hl,(var_wrd_Jumping)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_JumpIncrement)			;// Optimize -1- [Qc1001]
		Ld		hl,0			;// [Qc1002]
		call	Quig_GT_HL		;/Checks HL>DE - True HL=1 False HL=0 [Qc115]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf3110_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_597		;//Jumping =0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_Jumping),hl		;//Int variable 'var_wrd_Jumping'=expression result [Qc219]
.QLn_598		;//EndIf
.QIf3110_Exit:
.QLn_599		;//BirdY1=BirdY1+JumpIncrement
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_JumpIncrement) 	;//hl=value of 'var_wrd_JumpIncrement' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_601		;//If menuOn=0 Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3134_Exit				;// [Qc1012]
.QLn_602		;//Sprite.Position.Group.Set 36,BirdX1,BirdY1,2,1
		ld		hl,36		;//hl=number '36' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_603		;//EndIf
.QIf3134_Exit:
.QLn_607		;//BirdY1=BirdY1+1
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_608		;//Sprite.Pattern.Set 36,174+k
		Ld		de,174 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_k)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,36						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_609		;//Sprite.Pattern.Set 37,175+k
		Ld		de,175 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_k)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,37						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_611		;//If  DoBirdAnimation=0 Then
		Ld		hl,(var_wrd_DoBirdAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3182_Exit				;// [Qc1012]
.QLn_612		;//k=k+2
		ld		hl,(var_wrd_k) 	;//hl=value of 'var_wrd_k' [Qc053]
		inc		hl		;//Plus 2 [Qc091]
		inc		hl		;// [Qc092]
		ld		(var_wrd_k),hl		;//Int variable 'var_wrd_k'=expression result [Qc219]
.QLn_613		;//If k=6 Then
		Ld		hl,(var_wrd_k)			;// Optimize -1a- [Qc1062]
		Ld		de,6			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3200_Exit				;// [Qc1012]
.QLn_614		;//k=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_k),hl		;//Int variable 'var_wrd_k'=expression result [Qc219]
.QLn_615		;//EndIf
.QIf3200_Exit:
.QLn_616		;//EndIf
.QIf3182_Exit:
.QLn_618		;//DoBirdAnimation=DoBirdAnimation	+1
		ld		hl,(var_wrd_DoBirdAnimation) 	;//hl=value of 'var_wrd_DoBirdAnimation' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_DoBirdAnimation),hl		;//Int variable 'var_wrd_DoBirdAnimation'=expression result [Qc219]
.QLn_620		;//If DoBirdAnimation= 10 Then
		Ld		hl,(var_wrd_DoBirdAnimation)			;// Optimize -1a- [Qc1062]
		Ld		de,10			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3224_Exit				;// [Qc1012]
.QLn_621		;//DoBirdAnimation=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_DoBirdAnimation),hl		;//Int variable 'var_wrd_DoBirdAnimation'=expression result [Qc219]
.QLn_622		;//EndIf
.QIf3224_Exit:
.QLn_627		;//hasCollide=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_629		;//If BirdY1 => 150 Then
		Ld		de,(var_wrd_BirdY1)			;// Optimize -1- [Qc1001]
		Ld		hl,150			;// [Qc1002]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf3240_Exit				;// [Qc1220]
.QLn_630		;//BirdY1= 150
		ld		hl,150		;//hl=number '150' [Qc054]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_631		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_632		;//EndIf
.QIf3240_Exit:
.QLn_634		;//If BirdY1 =< 1 Then
		Ld		de,(var_wrd_BirdY1)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3256_Exit				;// [Qc1220]
.QLn_635		;//BirdY1=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_BirdY1),hl		;//Int variable 'var_wrd_BirdY1'=expression result [Qc219]
.QLn_636		;//EndIf
.QIf3256_Exit:
.QLn_642		;//If Collide(BirdX1,BirdY1,5,5,pipe1X,8,16,Top1-2)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe1X) 	;//hl=value of 'var_wrd_pipe1X' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,8		;//hl=number '8' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,16		;//hl=number '16' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Top1) 	;//hl=value of 'var_wrd_Top1' [Qc053]
		dec		hl 			;** Integer x=x-2 [Qc094]
		dec		hl			;// [Qc095]
		pop		de		;//Restore value from stack [Qc050]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3292_Exit				;// [Qc1012]
.QLn_643		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_644		;//EndIf
.QIf3292_Exit:
.QLn_645		;//If Collide(BirdX1,BirdY1,5,5,pipe2X,8,16,Top2-2)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe2X) 	;//hl=value of 'var_wrd_pipe2X' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,8		;//hl=number '8' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,16		;//hl=number '16' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Top2) 	;//hl=value of 'var_wrd_Top2' [Qc053]
		dec		hl 			;** Integer x=x-2 [Qc094]
		dec		hl			;// [Qc095]
		pop		de		;//Restore value from stack [Qc050]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3328_Exit				;// [Qc1012]
.QLn_646		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_647		;//EndIf
.QIf3328_Exit:
.QLn_648		;//If Collide(BirdX1,BirdY1,5,5,pipe3X,8,16,Top3-2)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe3X) 	;//hl=value of 'var_wrd_pipe3X' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,8		;//hl=number '8' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,16		;//hl=number '16' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Top3) 	;//hl=value of 'var_wrd_Top3' [Qc053]
		dec		hl 			;** Integer x=x-2 [Qc094]
		dec		hl			;// [Qc095]
		pop		de		;//Restore value from stack [Qc050]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3364_Exit				;// [Qc1012]
.QLn_649		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_650		;//EndIf
.QIf3364_Exit:
.QLn_651		;//If Collide(BirdX1,BirdY1,5,5,pipe1X,Bot1,16,140)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe1X) 	;//hl=value of 'var_wrd_pipe1X' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Bot1) 	;//hl=value of 'var_wrd_Bot1' [Qc053]
		push		hl 		;//Store result [Qc001]
		Ld 		de,16			;// Optimize -6- [Qc1040]
		ld		hl,140		;//hl=number '140' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3397_Exit				;// [Qc1012]
.QLn_652		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_653		;//EndIf
.QIf3397_Exit:
.QLn_654		;//If Collide(BirdX1,BirdY1,5,5,pipe2X,Bot2,16,140)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe2X) 	;//hl=value of 'var_wrd_pipe2X' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Bot2) 	;//hl=value of 'var_wrd_Bot2' [Qc053]
		push		hl 		;//Store result [Qc001]
		Ld 		de,16			;// Optimize -6- [Qc1040]
		ld		hl,140		;//hl=number '140' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3430_Exit				;// [Qc1012]
.QLn_655		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_656		;//EndIf
.QIf3430_Exit:
.QLn_657		;//If Collide(BirdX1,BirdY1,5,5,pipe3X,Bot3,16,140)=1 Then
		ld		hl,(var_wrd_BirdX1) 	;//hl=value of 'var_wrd_BirdX1' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_BirdY1) 	;//hl=value of 'var_wrd_BirdY1' [Qc053]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc001]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_pipe3X) 	;//hl=value of 'var_wrd_pipe3X' [Qc053]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Bot3) 	;//hl=value of 'var_wrd_Bot3' [Qc053]
		push		hl 		;//Store result [Qc001]
		Ld 		de,16			;// Optimize -6- [Qc1040]
		ld		hl,140		;//hl=number '140' [Qc054]
		call	QFunc_Collide		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,1		;//hl=number '1' [Qc054]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3463_Exit				;// [Qc1012]
.QLn_658		;//hasCollide=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_hasCollide),hl		;//Int variable 'var_wrd_hasCollide'=expression result [Qc219]
.QLn_659		;//EndIf
.QIf3463_Exit:
.QLn_663		;//If hasCollide = 1  Then
		Ld		hl,(var_wrd_hasCollide)			;// Optimize -1a- [Qc1062]
		Ld		de,1			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3481_Exit				;// [Qc1012]
.QLn_664		;//Sprite.Pattern.Set 36,180
		Ld 		de,36			;// Optimize -6- [Qc1040]
		ld		hl,180		;//hl=number '180' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_665		;//Sprite.Pattern.Set 37,181
		Ld 		de,37			;// Optimize -6- [Qc1040]
		ld		hl,181		;//hl=number '181' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_666		;//ShowGameOver
		call	QFunc_ShowGameOver				;//Call 'ShowGameOver' [Qc234]
.QLn_667		;//falldown=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_falldown),hl		;//Int variable 'var_wrd_falldown'=expression result [Qc219]
.QLn_668		;//GameOn=6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_669		;//Pauze=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_Pauze),hl		;//Int variable 'var_wrd_Pauze'=expression result [Qc219]
.QLn_671		;//EndIf
.QIf3481_Exit:
.QLn_672		;//EndIf
.QIf2980_Exit:
.QLn_674		;//If menuOn=0 And Pauze=0  Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		hl,(var_wrd_Pauze)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf3536_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_679		;//If GameOn=2 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,2			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3549_Exit				;// [Qc1012]
.QLn_680		;//GameOn=3
		ld		hl,3		;//hl=number '3' [Qc054]
		ld		(var_wrd_GameOn),hl		;//Int variable 'var_wrd_GameOn'=expression result [Qc219]
.QLn_681		;//Pipe1GabStart = 2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_Pipe1GabStart),hl		;//Int variable 'var_wrd_Pipe1GabStart'=expression result [Qc219]
.QLn_682		;//Pipe1SizeGab =  6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld		(var_wrd_Pipe1SizeGab),hl		;//Int variable 'var_wrd_Pipe1SizeGab'=expression result [Qc219]
.QLn_683		;//SetPipe1
		call	QFunc_SetPipe1				;//Call 'SetPipe1' [Qc234]
.QLn_685		;//Pipe2GabStart = 2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_Pipe2GabStart),hl		;//Int variable 'var_wrd_Pipe2GabStart'=expression result [Qc219]
.QLn_686		;//Pipe2SizeGab =  6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld		(var_wrd_Pipe2SizeGab),hl		;//Int variable 'var_wrd_Pipe2SizeGab'=expression result [Qc219]
.QLn_687		;//SetPipe2
		call	QFunc_SetPipe2				;//Call 'SetPipe2' [Qc234]
.QLn_689		;//Pipe3GabStart = 2
		ld		hl,2		;//hl=number '2' [Qc054]
		ld		(var_wrd_Pipe3GabStart),hl		;//Int variable 'var_wrd_Pipe3GabStart'=expression result [Qc219]
.QLn_690		;//Pipe3SizeGab =  6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld		(var_wrd_Pipe3SizeGab),hl		;//Int variable 'var_wrd_Pipe3SizeGab'=expression result [Qc219]
.QLn_691		;//SetPipe3
		call	QFunc_SetPipe3				;//Call 'SetPipe3' [Qc234]
.QLn_693		;//getReadyAnimation=0
		ld		hl,0		;//hl=number '0' [Qc054]
		ld		(var_wrd_getReadyAnimation),hl		;//Int variable 'var_wrd_getReadyAnimation'=expression result [Qc219]
.QLn_694		;//Else
		jp		QIf3549_Exit2		;//Jump to EndIf
.QIf3549_Exit:
.QLn_697		;//If GameOn=5 Then
		Ld		hl,(var_wrd_GameOn)			;// Optimize -1a- [Qc1062]
		Ld		de,5			;// [Qc1063]
		Xor 	a						;// Optimize -3- [Qc1010]
		sbc		hl,de					;// [Qc1011]
		jp		nz,QIf3595_Exit				;// [Qc1012]
.QLn_698		;//If pipe1X=< -32 Then
		Ld		de,(var_wrd_pipe1X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3603_Exit				;// [Qc1220]
.QLn_700		;//i=Rnd(5)
		ld		hl,5		;//hl=number '5' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_701		;//If i <1 Then
		Ld		de,(var_wrd_i)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf3615_Exit				;// [Qc1220]
.QLn_702		;//i=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_703		;//EndIf
.QIf3615_Exit:
.QLn_704		;//Pipe1GabStart = i
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ld		(var_wrd_Pipe1GabStart),hl		;//Int variable 'var_wrd_Pipe1GabStart'=expression result [Qc219]
.QLn_705		;//Pipe1SizeGab = 5
		ld		hl,5		;//hl=number '5' [Qc054]
		ld		(var_wrd_Pipe1SizeGab),hl		;//Int variable 'var_wrd_Pipe1SizeGab'=expression result [Qc219]
.QLn_706		;//SetPipe1
		call	QFunc_SetPipe1				;//Call 'SetPipe1' [Qc234]
.QLn_707		;//ScoreUP
		call	QFunc_ScoreUP				;//Call 'ScoreUP' [Qc234]
.QLn_708		;//pipe1X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe1X),hl		;//Int variable 'var_wrd_pipe1X'=expression result [Qc219]
.QLn_709		;//EndIf
.QIf3603_Exit:
.QLn_712		;//If pipe2X=< -32 Then
		Ld		de,(var_wrd_pipe2X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3643_Exit				;// [Qc1220]
.QLn_714		;//i=Rnd(5)
		ld		hl,5		;//hl=number '5' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_715		;//If i <1 Then
		Ld		de,(var_wrd_i)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf3655_Exit				;// [Qc1220]
.QLn_716		;//i=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_717		;//EndIf
.QIf3655_Exit:
.QLn_718		;//Pipe2GabStart = i
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ld		(var_wrd_Pipe2GabStart),hl		;//Int variable 'var_wrd_Pipe2GabStart'=expression result [Qc219]
.QLn_719		;//Pipe2SizeGab = 4
		ld		hl,4		;//hl=number '4' [Qc054]
		ld		(var_wrd_Pipe2SizeGab),hl		;//Int variable 'var_wrd_Pipe2SizeGab'=expression result [Qc219]
.QLn_720		;//SetPipe2
		call	QFunc_SetPipe2				;//Call 'SetPipe2' [Qc234]
.QLn_721		;//ScoreUP
		call	QFunc_ScoreUP				;//Call 'ScoreUP' [Qc234]
.QLn_722		;//pipe2X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe2X),hl		;//Int variable 'var_wrd_pipe2X'=expression result [Qc219]
.QLn_723		;//EndIf
.QIf3643_Exit:
.QLn_725		;//If pipe3X=< -32 Then
		Ld		de,(var_wrd_pipe3X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3683_Exit				;// [Qc1220]
.QLn_727		;//i=Rnd(5)
		ld		hl,5		;//hl=number '5' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_728		;//If i <1 Then
		Ld		de,(var_wrd_i)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call 	Quig_LT_HL_Direct		;// Optimize -3j- [Qc1219]
		jp		z,QIf3695_Exit				;// [Qc1220]
.QLn_729		;//i=1
		ld		hl,1		;//hl=number '1' [Qc054]
		ld		(var_wrd_i),hl		;//Int variable 'var_wrd_i'=expression result [Qc219]
.QLn_730		;//EndIf
.QIf3695_Exit:
.QLn_731		;//Pipe3GabStart = i
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ld		(var_wrd_Pipe3GabStart),hl		;//Int variable 'var_wrd_Pipe3GabStart'=expression result [Qc219]
.QLn_732		;//Pipe3SizeGab = 4
		ld		hl,4		;//hl=number '4' [Qc054]
		ld		(var_wrd_Pipe3SizeGab),hl		;//Int variable 'var_wrd_Pipe3SizeGab'=expression result [Qc219]
.QLn_733		;//SetPipe3
		call	QFunc_SetPipe3				;//Call 'SetPipe3' [Qc234]
.QLn_734		;//ScoreUP
		call	QFunc_ScoreUP				;//Call 'ScoreUP' [Qc234]
.QLn_735		;//pipe3X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe3X),hl		;//Int variable 'var_wrd_pipe3X'=expression result [Qc219]
.QLn_736		;//EndIf
.QIf3683_Exit:
.QLn_737		;//EndIf
.QIf3595_Exit:
.QLn_738		;//EndIf
.QIf3549_Exit2:
.QLn_742		;//If pipe1X=< -32 Then
		Ld		de,(var_wrd_pipe1X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3727_Exit				;// [Qc1220]
.QLn_743		;//pipe1X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe1X),hl		;//Int variable 'var_wrd_pipe1X'=expression result [Qc219]
.QLn_744		;//EndIf
.QIf3727_Exit:
.QLn_745		;//If pipe2X=< -32 Then
		Ld		de,(var_wrd_pipe2X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3740_Exit				;// [Qc1220]
.QLn_746		;//pipe2X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe2X),hl		;//Int variable 'var_wrd_pipe2X'=expression result [Qc219]
.QLn_747		;//EndIf
.QIf3740_Exit:
.QLn_748		;//If pipe3X=< -32 Then
		Ld		de,(var_wrd_pipe3X)			;// Optimize -1- [Qc1001]
		Ld		hl,-32			;// [Qc1002]
		call 	Quig_LTE_HL_Direct		;// Optimize -3l- [Qc1219]
		jp		z,QIf3753_Exit				;// [Qc1220]
.QLn_749		;//pipe3X = 256
		ld		hl,256		;//hl=number '256' [Qc054]
		ld		(var_wrd_pipe3X),hl		;//Int variable 'var_wrd_pipe3X'=expression result [Qc219]
.QLn_750		;//EndIf
.QIf3753_Exit:
.QLn_755		;//pipe1X=pipe1X-pipespeed
		ld		hl,(var_wrd_pipe1X) 	;//hl=value of 'var_wrd_pipe1X' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_pipespeed) 	;//hl=value of 'var_wrd_pipespeed' [Qc053]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_pipe1X),hl		;//Int variable 'var_wrd_pipe1X'=expression result [Qc219]
.QLn_756		;//pipe2X=pipe2X-pipespeed
		ld		hl,(var_wrd_pipe2X) 	;//hl=value of 'var_wrd_pipe2X' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_pipespeed) 	;//hl=value of 'var_wrd_pipespeed' [Qc053]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_pipe2X),hl		;//Int variable 'var_wrd_pipe2X'=expression result [Qc219]
.QLn_757		;//pipe3X=pipe3X-pipespeed
		ld		hl,(var_wrd_pipe3X) 	;//hl=value of 'var_wrd_pipe3X' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_pipespeed) 	;//hl=value of 'var_wrd_pipespeed' [Qc053]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_pipe3X),hl		;//Int variable 'var_wrd_pipe3X'=expression result [Qc219]
.QLn_759		;//MovePipe1
		call	QFunc_MovePipe1				;//Call 'MovePipe1' [Qc234]
.QLn_760		;//MovePipe2
		call	QFunc_MovePipe2				;//Call 'MovePipe2' [Qc234]
.QLn_761		;//MovePipe3
		call	QFunc_MovePipe3				;//Call 'MovePipe3' [Qc234]
.QLn_763		;//EndIf
.QIf3536_Exit:
.QLn_765		;//EndIf
.QIf1948_Exit:
.QLn_767		;//EndF
		ret		;// [Qc262]
.QLn_771		;//Function SetPipe1:Void()
.QFunc_SETPIPE1
.QLn_773		;//Pipe1GabStart = Pipe1GabStart *2
		Ld		de,(var_wrd_Pipe1GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe1GabStart),hl		;//Int variable 'var_wrd_Pipe1GabStart'=expression result [Qc219]
.QLn_774		;//Pipe1SizeGab = Pipe1SizeGab *2
		Ld		de,(var_wrd_Pipe1SizeGab)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe1SizeGab),hl		;//Int variable 'var_wrd_Pipe1SizeGab'=expression result [Qc219]
.QLn_777		;//For i=68 To 86 Step 2
		ld		hl,86		;//hl=number '86' [Qc054]
		ld 		(QFr3812_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,68		;//hl=number '68' [Qc054]
		.QFr3812_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr3812_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr3812_Start	;// [Qc307]
		jp		nz,QFr3812_Exit	;// [Qc308]
.QFr3812_Start:
.QLn_778		;//Sprite.Pattern.Set i,12
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,12		;//hl=number '12' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_779		;//Sprite.Pattern.Set i+1,13
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,13		;//hl=number '13' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_780		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr3812_Loop		;// [Qc340]
.QFr3812_Exit:
.QLn_783		;//Sprite.Pattern.Set 68+Pipe1GabStart,10
		Ld 		de,68			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_784		;//Sprite.Pattern.Set 68+Pipe1GabStart+1,11
		Ld 		de,68			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,11		;//hl=number '11' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_787		;//Sprite.Pattern.Set 68+Pipe1GabStart+Pipe1SizeGab,112
		Ld 		de,68			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe1SizeGab) 	;//hl=value of 'var_wrd_Pipe1SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,112		;//hl=number '112' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_788		;//Sprite.Pattern.Set 68+Pipe1GabStart+Pipe1SizeGab+1,113
		Ld 		de,68			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe1SizeGab) 	;//hl=value of 'var_wrd_Pipe1SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,113		;//hl=number '113' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_791		;//For i=Pipe1GabStart  +2 To Pipe1SizeGab+Pipe1GabStart-1
		ld		hl,(var_wrd_Pipe1SizeGab) 	;//hl=value of 'var_wrd_Pipe1SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		dec		hl		;//Minus 1 [Qc093]
		ld 		(QFr3880_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		inc		hl		;//Plus 2 [Qc091]
		inc		hl		;// [Qc092]
		.QFr3880_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr3880_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr3880_Start	;// [Qc307]
		jp		nz,QFr3880_Exit	;// [Qc308]
.QFr3880_Start:
.QLn_792		;//Sprite.Pattern.Set	 68+i,219
		Ld 		de,68			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,219		;//hl=number '219' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_793		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr3880_Loop		;// [Qc340]
.QFr3880_Exit:
.QLn_794		;//Top1=155-((Pipe1SizeGab+Pipe1GabStart)*8)
		ld		hl,155		;//hl=number '155' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pipe1SizeGab) 	;//hl=value of 'var_wrd_Pipe1SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe1GabStart) 	;//hl=value of 'var_wrd_Pipe1GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,8		;//hl=number '8' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Top1),hl		;//Int variable 'var_wrd_Top1'=expression result [Qc219]
.QLn_795		;//Bot1=143 -((Pipe1GabStart)*8)
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Pipe1GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,8			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Bot1),hl		;//Int variable 'var_wrd_Bot1'=expression result [Qc219]
.QLn_798		;//EndF
		ret		;// [Qc262]
.QLn_801		;//Function MovePipe1:Void()
.QFunc_MOVEPIPE1
.QLn_803		;//Sprite.Position.Group0.Set 68,pipe1X,143,2,10
		ld		hl,68		;//hl=number '68' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe1X) 	;//hl=value of 'var_wrd_pipe1X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_805		;//EndF
		ret		;// [Qc262]
.QLn_809		;//Function SetPipe2:Void()
.QFunc_SETPIPE2
.QLn_811		;//Pipe2GabStart = Pipe2GabStart *2
		Ld		de,(var_wrd_Pipe2GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe2GabStart),hl		;//Int variable 'var_wrd_Pipe2GabStart'=expression result [Qc219]
.QLn_812		;//Pipe2SizeGab = Pipe2SizeGab *2
		Ld		de,(var_wrd_Pipe2SizeGab)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe2SizeGab),hl		;//Int variable 'var_wrd_Pipe2SizeGab'=expression result [Qc219]
.QLn_814		;//For i=88 To 106 Step 2
		ld		hl,106		;//hl=number '106' [Qc054]
		ld 		(QFr3968_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,88		;//hl=number '88' [Qc054]
		.QFr3968_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr3968_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr3968_Start	;// [Qc307]
		jp		nz,QFr3968_Exit	;// [Qc308]
.QFr3968_Start:
.QLn_815		;//Sprite.Pattern.Set i,12
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,12		;//hl=number '12' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_816		;//Sprite.Pattern.Set i+1,13
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,13		;//hl=number '13' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_817		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr3968_Loop		;// [Qc340]
.QFr3968_Exit:
.QLn_820		;//Sprite.Pattern.Set 88+Pipe2GabStart,10
		Ld 		de,88			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_821		;//Sprite.Pattern.Set 88+Pipe2GabStart+1,11
		Ld 		de,88			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,11		;//hl=number '11' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_824		;//Sprite.Pattern.Set 88+Pipe2GabStart+Pipe2SizeGab,112
		Ld 		de,88			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe2SizeGab) 	;//hl=value of 'var_wrd_Pipe2SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,112		;//hl=number '112' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_825		;//Sprite.Pattern.Set 88+Pipe2GabStart+Pipe2SizeGab+1,113
		Ld 		de,88			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe2SizeGab) 	;//hl=value of 'var_wrd_Pipe2SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,113		;//hl=number '113' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_829		;//For i=Pipe2GabStart +2 To Pipe2SizeGab+Pipe2GabStart-1
		ld		hl,(var_wrd_Pipe2SizeGab) 	;//hl=value of 'var_wrd_Pipe2SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		dec		hl		;//Minus 1 [Qc093]
		ld 		(QFr4036_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		inc		hl		;//Plus 2 [Qc091]
		inc		hl		;// [Qc092]
		.QFr4036_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4036_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4036_Start	;// [Qc307]
		jp		nz,QFr4036_Exit	;// [Qc308]
.QFr4036_Start:
.QLn_830		;//Sprite.Pattern.Set	 88+i,219
		Ld 		de,88			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,219		;//hl=number '219' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_831		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4036_Loop		;// [Qc340]
.QFr4036_Exit:
.QLn_832		;//Top2=155-((Pipe2SizeGab+Pipe2GabStart)*8)
		ld		hl,155		;//hl=number '155' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pipe2SizeGab) 	;//hl=value of 'var_wrd_Pipe2SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe2GabStart) 	;//hl=value of 'var_wrd_Pipe2GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,8		;//hl=number '8' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Top2),hl		;//Int variable 'var_wrd_Top2'=expression result [Qc219]
.QLn_833		;//Bot2=143 -((Pipe2GabStart)*8)
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Pipe2GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,8			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Bot2),hl		;//Int variable 'var_wrd_Bot2'=expression result [Qc219]
.QLn_835		;//EndF
		ret		;// [Qc262]
.QLn_838		;//Function MovePipe2:Void()
.QFunc_MOVEPIPE2
.QLn_840		;//Sprite.Position.Group0.Set 88,pipe2X,143,2,10
		ld		hl,88		;//hl=number '88' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe2X) 	;//hl=value of 'var_wrd_pipe2X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_842		;//EndF
		ret		;// [Qc262]
.QLn_849		;//Function SetPipe3:Void()
.QFunc_SETPIPE3
.QLn_851		;//If menuOn=0 And GameOn>1  Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_GameOn)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call	Quig_GT_HL		;/Checks HL>DE - True HL=1 False HL=0 [Qc115]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf4133_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_853		;//Pipe3GabStart = Pipe3GabStart *2
		Ld		de,(var_wrd_Pipe3GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe3GabStart),hl		;//Int variable 'var_wrd_Pipe3GabStart'=expression result [Qc219]
.QLn_854		;//Pipe3SizeGab = Pipe3SizeGab *2
		Ld		de,(var_wrd_Pipe3SizeGab)			;// Optimize -1- [Qc1001]
		Ld		hl,2			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		ld		(var_wrd_Pipe3SizeGab),hl		;//Int variable 'var_wrd_Pipe3SizeGab'=expression result [Qc219]
.QLn_856		;//For i=10 To 28 Step 2
		ld		hl,28		;//hl=number '28' [Qc054]
		ld 		(QFr4149_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,10		;//hl=number '10' [Qc054]
		.QFr4149_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4149_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4149_Start	;// [Qc307]
		jp		nz,QFr4149_Exit	;// [Qc308]
.QFr4149_Start:
.QLn_857		;//Sprite.Pattern.Set i,12
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,12		;//hl=number '12' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_858		;//Sprite.Pattern.Set i+1,13
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,13		;//hl=number '13' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_859		;//Sprite.Display.Set i,0
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Display				;//Call 'Sprite.Display.Set' [Qc234]
.QLn_860		;//Sprite.Display.Set i+1,0
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Sprite_Set_Display				;//Call 'Sprite.Display.Set' [Qc234]
.QLn_861		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr4149_Loop		;// [Qc340]
.QFr4149_Exit:
.QLn_864		;//Sprite.Pattern.Set 10+Pipe3GabStart,10
		Ld 		de,10			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_865		;//Sprite.Pattern.Set 10+Pipe3GabStart+1,11
		Ld 		de,10			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,11		;//hl=number '11' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_868		;//Sprite.Pattern.Set 10+Pipe3GabStart+Pipe3SizeGab,112
		Ld 		de,10			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe3SizeGab) 	;//hl=value of 'var_wrd_Pipe3SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,112		;//hl=number '112' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_869		;//Sprite.Pattern.Set 10+Pipe3GabStart+Pipe3SizeGab+1,113
		Ld 		de,10			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe3SizeGab) 	;//hl=value of 'var_wrd_Pipe3SizeGab' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,113		;//hl=number '113' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_873		;//For i=Pipe3GabStart +2 To Pipe3SizeGab+Pipe3GabStart-1
		ld		hl,(var_wrd_Pipe3SizeGab) 	;//hl=value of 'var_wrd_Pipe3SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		dec		hl		;//Minus 1 [Qc093]
		ld 		(QFr4228_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		inc		hl		;//Plus 2 [Qc091]
		inc		hl		;// [Qc092]
		.QFr4228_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4228_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4228_Start	;// [Qc307]
		jp		nz,QFr4228_Exit	;// [Qc308]
.QFr4228_Start:
.QLn_874		;//Sprite.Pattern.Set	 10+i,219
		Ld 		de,10			;// Optimize -6- [Qc1040]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,219		;//hl=number '219' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_875		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4228_Loop		;// [Qc340]
.QFr4228_Exit:
.QLn_876		;//Top3=155-((Pipe3SizeGab+Pipe3GabStart)*8)
		ld		hl,155		;//hl=number '155' [Qc054]
		push		hl 		;//Store result [Qc002]
		ld		hl,(var_wrd_Pipe3SizeGab) 	;//hl=value of 'var_wrd_Pipe3SizeGab' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_Pipe3GabStart) 	;//hl=value of 'var_wrd_Pipe3GabStart' [Qc053]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc269]
		ld		hl,8		;//hl=number '8' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Top3),hl		;//Int variable 'var_wrd_Top3'=expression result [Qc219]
.QLn_877		;//Bot3=143 -((Pipe3GabStart)*8)
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Pipe3GabStart)			;// Optimize -1- [Qc1001]
		Ld		hl,8			;// [Qc1002]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc050]
		ex		de,hl		;//Sub Integer x-y [Qc059]
		or		a		;// [Qc060]
		sbc		hl,de		;// [Qc061]
		ld		(var_wrd_Bot3),hl		;//Int variable 'var_wrd_Bot3'=expression result [Qc219]
.QLn_880		;//EndIf
.QIf4133_Exit:
.QLn_883		;//EndF
		ret		;// [Qc262]
.QLn_886		;//Function MovePipe3:Void()
.QFunc_MOVEPIPE3
.QLn_887		;//If menuOn=0 And GameOn>1  Then
		Ld		hl,(var_wrd_menuOn)			;// Optimize -1a- [Qc1062]
		Ld		de,0			;// [Qc1063]
		xor 	a			;** Integer x=y ** [Qc097]
		sbc 	hl,de		;//Compare hl/de - n means Equal [Qc098]
		ld 		h,a			;//Make h=0 [Qc099]
		jr 		nz,1		;//Skip inc a [Qc100]
		inc 	a			;//inc a [Qc101]
		ld 		l,a         ;//l=0 Or 1 [Qc102]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_GameOn)			;// Optimize -1- [Qc1001]
		Ld		hl,1			;// [Qc1002]
		call	Quig_GT_HL		;/Checks HL>DE - True HL=1 False HL=0 [Qc115]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf4312_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_888		;//Sprite.Position.Group0.Set 10,pipe3X,143,2,10
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_wrd_pipe3X) 	;//hl=value of 'var_wrd_pipe3X' [Qc053]
		push		hl		;// Store result [Qc225]
		ld		hl,143		;//hl=number '143' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_Sprite_Set_Position3				;//Call 'Sprite.Position.Group0.Set' [Qc234]
.QLn_889		;//EndIf
.QIf4312_Exit:
.QLn_891		;//EndF
		ret		;// [Qc262]
.QLn_894		;//Function ShowGetReady:Void
.QFunc_SHOWGETREADY
.QLn_895		;//f=56
		ld		hl,56		;//hl=number '56' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_896		;//For i=98 To 109
		ld		hl,109		;//hl=number '109' [Qc054]
		ld 		(QFr4336_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,98		;//hl=number '98' [Qc054]
		.QFr4336_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4336_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4336_Start	;// [Qc307]
		jp		nz,QFr4336_Exit	;// [Qc308]
.QFr4336_Start:
.QLn_897		;//Sprite.Pattern.Set	 f,i
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_898		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_899		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4336_Loop		;// [Qc340]
.QFr4336_Exit:
.QLn_901		;//Sprite.Position.Group.Set 56,81,30,6,2
		ld		hl,56		;//hl=number '56' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,81		;//hl=number '81' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,30		;//hl=number '30' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,6			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_902		;//EndF
		ret		;// [Qc262]
.QLn_905		;//Function ShowGameOver:Void
.QFunc_SHOWGAMEOVER
.QLn_907		;//f=56
		ld		hl,56		;//hl=number '56' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_908		;//For i=144 To 155
		ld		hl,155		;//hl=number '155' [Qc054]
		ld 		(QFr4379_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,144		;//hl=number '144' [Qc054]
		.QFr4379_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4379_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4379_Start	;// [Qc307]
		jp		nz,QFr4379_Exit	;// [Qc308]
.QFr4379_Start:
.QLn_909		;//Sprite.Pattern.Set	 f,i
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_910		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_911		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4379_Loop		;// [Qc340]
.QFr4379_Exit:
.QLn_913		;//Sprite.Position.Group.Set 56,81,30,6,2
		ld		hl,56		;//hl=number '56' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,81		;//hl=number '81' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,30		;//hl=number '30' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,6			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_915		;//EndF
		ret		;// [Qc262]
.QLn_918		;//Function ShowPlay:Void
.QFunc_SHOWPLAY
.QLn_920		;//f=48
		ld		hl,48		;//hl=number '48' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_921		;//For i=164 To 171
		ld		hl,171		;//hl=number '171' [Qc054]
		ld 		(QFr4422_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,164		;//hl=number '164' [Qc054]
		.QFr4422_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4422_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4422_Start	;// [Qc307]
		jp		nz,QFr4422_Exit	;// [Qc308]
.QFr4422_Start:
.QLn_922		;//Sprite.Pattern.Set	 f,i
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_923		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_924		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4422_Loop		;// [Qc340]
.QFr4422_Exit:
.QLn_926		;//Sprite.Position.Group.Set 48,97,120,4,2
		ld		hl,48		;//hl=number '48' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,97		;//hl=number '97' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,120		;//hl=number '120' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,4			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_928		;//EndF
		ret		;// [Qc262]
.QLn_931		;//Function RemovePlay:Void
.QFunc_REMOVEPLAY
.QLn_933		;//For i=48 To 55
		ld		hl,55		;//hl=number '55' [Qc054]
		ld 		(QFr4462_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,48		;//hl=number '48' [Qc054]
		.QFr4462_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4462_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4462_Start	;// [Qc307]
		jp		nz,QFr4462_Exit	;// [Qc308]
.QFr4462_Start:
.QLn_934		;//Sprite.Pattern.Set	 i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_935		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_936		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4462_Loop		;// [Qc340]
.QFr4462_Exit:
.QLn_938		;//EndF
		ret		;// [Qc262]
.QLn_941		;//Function RemoveGetReady:Void
.QFunc_REMOVEGETREADY
.QLn_943		;//For i=56 To 67
		ld		hl,67		;//hl=number '67' [Qc054]
		ld 		(QFr4494_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,56		;//hl=number '56' [Qc054]
		.QFr4494_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4494_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4494_Start	;// [Qc307]
		jp		nz,QFr4494_Exit	;// [Qc308]
.QFr4494_Start:
.QLn_944		;//Sprite.Pattern.Set	 i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_945		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_946		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4494_Loop		;// [Qc340]
.QFr4494_Exit:
.QLn_948		;//EndF
		ret		;// [Qc262]
.QLn_951		;//Function ShowTab:Void
.QFunc_SHOWTAB
.QLn_953		;//Sprite.Pattern.Set	 40,3
		Ld 		de,40			;// Optimize -6- [Qc1040]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_954		;//Sprite.Pattern.Set 41,4
		Ld 		de,41			;// Optimize -6- [Qc1040]
		ld		hl,4		;//hl=number '4' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_955		;//Sprite.Pattern.Set	 42,7
		Ld 		de,42			;// Optimize -6- [Qc1040]
		ld		hl,7		;//hl=number '7' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_956		;//Sprite.Pattern.Set 43,8
		Ld 		de,43			;// Optimize -6- [Qc1040]
		ld		hl,8		;//hl=number '8' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_957		;//Sprite.Pattern.Set	 44,6
		Ld 		de,44			;// Optimize -6- [Qc1040]
		ld		hl,6		;//hl=number '6' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_958		;//Sprite.Pattern.Set 45,5
		Ld 		de,45			;// Optimize -6- [Qc1040]
		ld		hl,5		;//hl=number '5' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_959		;//Sprite.Pattern.Set 46,173
		Ld 		de,46			;// Optimize -6- [Qc1040]
		ld		hl,173		;//hl=number '173' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_960		;//Sprite.Pattern.Set 47,172
		Ld 		de,47			;// Optimize -6- [Qc1040]
		ld		hl,172		;//hl=number '172' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_962		;//Sprite.Position.Set 40,95,100
		ld		hl,40		;//hl=number '40' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,95			;// Optimize -6- [Qc1040]
		ld		hl,100		;//hl=number '100' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_963		;//Sprite.Position.Set 41,111,100
		ld		hl,41		;//hl=number '41' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,111			;// Optimize -6- [Qc1040]
		ld		hl,100		;//hl=number '100' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_964		;//Sprite.Position.Set 42,133,100
		ld		hl,42		;//hl=number '42' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,133			;// Optimize -6- [Qc1040]
		ld		hl,100		;//hl=number '100' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_965		;//Sprite.Position.Set 43,149,100
		ld		hl,43		;//hl=number '43' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,149			;// Optimize -6- [Qc1040]
		ld		hl,100		;//hl=number '100' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_966		;//Sprite.Position.Set 44,122,100
		ld		hl,44		;//hl=number '44' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,122			;// Optimize -6- [Qc1040]
		ld		hl,100		;//hl=number '100' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_967		;//Sprite.Position.Set 45,122,84
		ld		hl,45		;//hl=number '45' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,122			;// Optimize -6- [Qc1040]
		ld		hl,84		;//hl=number '84' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_968		;//Sprite.Position.Set 46,130,60
		ld		hl,46		;//hl=number '46' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,130			;// Optimize -6- [Qc1040]
		ld		hl,60		;//hl=number '60' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_969		;//Sprite.Position.Set 47,114,60
		ld		hl,47		;//hl=number '47' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,114			;// Optimize -6- [Qc1040]
		ld		hl,60		;//hl=number '60' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_971		;//EndF
		ret		;// [Qc262]
.QLn_974		;//Function RemoveTab:Void
.QFunc_REMOVETAB
.QLn_976		;//For i=40 To 47
		ld		hl,47		;//hl=number '47' [Qc054]
		ld 		(QFr4626_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,40		;//hl=number '40' [Qc054]
		.QFr4626_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4626_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4626_Start	;// [Qc307]
		jp		nz,QFr4626_Exit	;// [Qc308]
.QFr4626_Start:
.QLn_977		;//Sprite.Pattern.Set	 i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_978		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_979		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4626_Loop		;// [Qc340]
.QFr4626_Exit:
.QLn_981		;//EndF
		ret		;// [Qc262]
.QLn_984		;//Function ShowMenu:Void
.QFunc_SHOWMENU
.QLn_985		;//f=34
		ld		hl,34		;//hl=number '34' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_986		;//For i=3 To 34
		ld		hl,34		;//hl=number '34' [Qc054]
		ld 		(QFr4661_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr4661_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4661_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4661_Start	;// [Qc307]
		jp		nz,QFr4661_Exit	;// [Qc308]
.QFr4661_Start:
.QLn_987		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_988		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_989		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4661_Loop		;// [Qc340]
.QFr4661_Exit:
.QLn_991		;//Sprite.Position.Group.Set 3,64,64,8,4
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,64		;//hl=number '64' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,64		;//hl=number '64' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,8			;// Optimize -6- [Qc1040]
		ld		hl,4		;//hl=number '4' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_992		;//EndF
		ret		;// [Qc262]
.QLn_995		;//Function RemoveMenu:Void
.QFunc_REMOVEMENU
.QLn_996		;//For i=3 To 34
		ld		hl,34		;//hl=number '34' [Qc054]
		ld 		(QFr4701_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr4701_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4701_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4701_Start	;// [Qc307]
		jp		nz,QFr4701_Exit	;// [Qc308]
.QFr4701_Start:
.QLn_997		;//Sprite.Pattern.Set i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_998		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_999		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4701_Loop		;// [Qc340]
.QFr4701_Exit:
.QLn_1000		;//EndF
		ret		;// [Qc262]
.QLn_1003		;//Function RemovePipe:Void
.QFunc_REMOVEPIPE
.QLn_1004		;//For i=68 To 86 Step 2
		ld		hl,86		;//hl=number '86' [Qc054]
		ld 		(QFr4733_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,68		;//hl=number '68' [Qc054]
		.QFr4733_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4733_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4733_Start	;// [Qc307]
		jp		nz,QFr4733_Exit	;// [Qc308]
.QFr4733_Start:
.QLn_1005		;//Sprite.Pattern.Set i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1006		;//Sprite.Pattern.Set i+1,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1007		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr4733_Loop		;// [Qc340]
.QFr4733_Exit:
.QLn_1009		;//For i=88 To 106 Step 2
		ld		hl,106		;//hl=number '106' [Qc054]
		ld 		(QFr4761_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,88		;//hl=number '88' [Qc054]
		.QFr4761_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4761_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4761_Start	;// [Qc307]
		jp		nz,QFr4761_Exit	;// [Qc308]
.QFr4761_Start:
.QLn_1010		;//Sprite.Pattern.Set i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1011		;//Sprite.Pattern.Set i+1,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1012		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr4761_Loop		;// [Qc340]
.QFr4761_Exit:
.QLn_1014		;//For i=10 To 28 Step 2
		ld		hl,28		;//hl=number '28' [Qc054]
		ld 		(QFr4789_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,10		;//hl=number '10' [Qc054]
		.QFr4789_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4789_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4789_Start	;// [Qc307]
		jp		nz,QFr4789_Exit	;// [Qc308]
.QFr4789_Start:
.QLn_1015		;//Sprite.Pattern.Set i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1016		;//Sprite.Pattern.Set i+1,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1017		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc334]
		inc		hl 		;// [Qc335]
		jp		QFr4789_Loop		;// [Qc340]
.QFr4789_Exit:
.QLn_1018		;//EndF
		ret		;// [Qc262]
.QLn_1021		;//Function ShowLogo:Void
.QFunc_SHOWLOGO
.QLn_1022		;//f=56
		ld		hl,56		;//hl=number '56' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1023		;//For i=192 To 203
		ld		hl,203		;//hl=number '203' [Qc054]
		ld 		(QFr4824_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,192		;//hl=number '192' [Qc054]
		.QFr4824_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4824_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4824_Start	;// [Qc307]
		jp		nz,QFr4824_Exit	;// [Qc308]
.QFr4824_Start:
.QLn_1024		;//Sprite.Pattern.Set	 f,i
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1025		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1026		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4824_Loop		;// [Qc340]
.QFr4824_Exit:
.QLn_1027		;//Sprite.Position.Group.Set 56,81,30,6,2
		ld		hl,56		;//hl=number '56' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,81		;//hl=number '81' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,30		;//hl=number '30' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,6			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1028		;//EndF
		ret		;// [Qc262]
.QLn_1031		;//Function ShowScoreBoard:Void
.QFunc_SHOWSCOREBOARD
.QLn_1032		;//f=66
		ld		hl,66		;//hl=number '66' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1033		;//For i=13 To 44
		ld		hl,44		;//hl=number '44' [Qc054]
		ld 		(QFr4867_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,13		;//hl=number '13' [Qc054]
		.QFr4867_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4867_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4867_Start	;// [Qc307]
		jp		nz,QFr4867_Exit	;// [Qc308]
.QFr4867_Start:
.QLn_1034		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1035		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1036		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4867_Loop		;// [Qc340]
.QFr4867_Exit:
.QLn_1038		;//Sprite.Position.Group.Set 13,64,64,8,4
		ld		hl,13		;//hl=number '13' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,64		;//hl=number '64' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,64		;//hl=number '64' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,8			;// Optimize -6- [Qc1040]
		ld		hl,4		;//hl=number '4' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1040		;//If Score =>0 And Score<=10 Then
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,0			;// [Qc1002]
		call	Quig_GTE_HL		;/Checks HL>=DE - True HL=1 False HL=0 [Qc111]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,10			;// [Qc1002]
		call	Quig_LTE_HL		;/Checks HL<=DE - True HL=1 False HL=0 [Qc113]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf4919_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_1041		;//f=18
		ld		hl,18		;//hl=number '18' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1042		;//For i=3 To 6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld 		(QFr4926_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr4926_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4926_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4926_Start	;// [Qc307]
		jp		nz,QFr4926_Exit	;// [Qc308]
.QFr4926_Start:
.QLn_1043		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1044		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1045		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4926_Loop		;// [Qc340]
.QFr4926_Exit:
.QLn_1046		;//Sprite.Position.Group.Set 3,82,80,2,2
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,82		;//hl=number '82' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,80		;//hl=number '80' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1047		;//EndIf
.QIf4919_Exit:
.QLn_1050		;//If Score =>11 And Score<=20 Then
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,11			;// [Qc1002]
		call	Quig_GTE_HL		;/Checks HL>=DE - True HL=1 False HL=0 [Qc111]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,20			;// [Qc1002]
		call	Quig_LTE_HL		;/Checks HL<=DE - True HL=1 False HL=0 [Qc113]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf4980_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_1051		;//f=160
		ld		hl,160		;//hl=number '160' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1052		;//For i=3 To 6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld 		(QFr4987_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr4987_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr4987_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr4987_Start	;// [Qc307]
		jp		nz,QFr4987_Exit	;// [Qc308]
.QFr4987_Start:
.QLn_1053		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1054		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1055		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr4987_Loop		;// [Qc340]
.QFr4987_Exit:
.QLn_1056		;//Sprite.Position.Group.Set 3,82,80,2,2
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,82		;//hl=number '82' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,80		;//hl=number '80' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1057		;//EndIf
.QIf4980_Exit:
.QLn_1059		;//If Score =>21 And Score<=30 Then
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,21			;// [Qc1002]
		call	Quig_GTE_HL		;/Checks HL>=DE - True HL=1 False HL=0 [Qc111]
		push		hl 		;//Store result [Qc002]
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,30			;// [Qc1002]
		call	Quig_LTE_HL		;/Checks HL<=DE - True HL=1 False HL=0 [Qc113]
		pop		de		;//Restore value from stack [Qc050]
		ld		a,d		;//And HL & DE [Qc065]
		and		h		;// [Qc066]
		ld		h,a		;// [Qc067]
		ld		a,e		;// [Qc068]
		and		l		;// [Qc069]
		ld		l,a		;// [Qc070]
		ld		a,h 		;//Jump if HL=0 - fails condition [Qc280]
		or		l		;// [Qc281]
		jp		z,QIf5041_Exit		;//Jump to EndIf or Else [Qc282]
.QLn_1060		;//f=14
		ld		hl,14		;//hl=number '14' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1061		;//For i=3 To 6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld 		(QFr5048_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr5048_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr5048_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr5048_Start	;// [Qc307]
		jp		nz,QFr5048_Exit	;// [Qc308]
.QFr5048_Start:
.QLn_1062		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1063		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1064		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr5048_Loop		;// [Qc340]
.QFr5048_Exit:
.QLn_1065		;//Sprite.Position.Group.Set 3,82,80,2,2
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,82		;//hl=number '82' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,80		;//hl=number '80' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1066		;//EndIf
.QIf5041_Exit:
.QLn_1068		;//If Score =>31  Then
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,31			;// [Qc1002]
		call 	Quig_GTE_HL_Direct		;// Optimize -3f- [Qc1219]
		jp		z,QIf5090_Exit				;// [Qc1220]
.QLn_1069		;//f=156
		ld		hl,156		;//hl=number '156' [Qc054]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1070		;//For i=3 To 6
		ld		hl,6		;//hl=number '6' [Qc054]
		ld 		(QFr5097_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr5097_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr5097_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr5097_Start	;// [Qc307]
		jp		nz,QFr5097_Exit	;// [Qc308]
.QFr5097_Start:
.QLn_1071		;//Sprite.Pattern.Set i,f
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1072		;//f=f+1
		ld		hl,(var_wrd_f) 	;//hl=value of 'var_wrd_f' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ld		(var_wrd_f),hl		;//Int variable 'var_wrd_f'=expression result [Qc219]
.QLn_1073		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr5097_Loop		;// [Qc340]
.QFr5097_Exit:
.QLn_1074		;//Sprite.Position.Group.Set 3,82,80,2,2
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,82		;//hl=number '82' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,80		;//hl=number '80' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,2			;// Optimize -6- [Qc1040]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_g9k_Sprite_Set_Position2				;//Call 'Sprite.Position.Group.Set' [Qc234]
.QLn_1075		;//EndIf
.QIf5090_Exit:
.QLn_1079		;//Digit0Low =  Score Mod 10
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,10			;// [Qc1002]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit0Low),hl		;//Int variable 'var_wrd_Digit0Low'=expression result [Qc219]
.QLn_1080		;//Digit1Low=	 (Score/10) Mod 10
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,10			;// [Qc1002]
		call	Quig_Div16		;//Divide HL by DE [Qc062]
		ex		de,hl 		;// [Qc269]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit1Low),hl		;//Int variable 'var_wrd_Digit1Low'=expression result [Qc219]
.QLn_1081		;//Digit2Low=	(Score/100) Mod 10
		Ld		de,(var_wrd_Score)			;// Optimize -1- [Qc1001]
		Ld		hl,100			;// [Qc1002]
		call	Quig_Div16		;//Divide HL by DE [Qc062]
		ex		de,hl 		;// [Qc269]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit2Low),hl		;//Int variable 'var_wrd_Digit2Low'=expression result [Qc219]
.QLn_1083		;//Sprite.Pattern.Set 7,114+Digit2Low
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit2Low)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,7						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1084		;//Sprite.Pattern.Set 8,114+Digit1Low
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit1Low)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,8						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1085		;//Sprite.Pattern.Set 9,114+Digit0Low
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit0Low)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,9						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1086		;//Sprite.Position.Set 7, 143,81
		ld		hl,7		;//hl=number '7' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,143			;// Optimize -6- [Qc1040]
		ld		hl,81		;//hl=number '81' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1087		;//Sprite.Position.Set 8, 153,81
		ld		hl,8		;//hl=number '8' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,153			;// Optimize -6- [Qc1040]
		ld		hl,81		;//hl=number '81' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1088		;//Sprite.Position.Set 9, 163,81
		ld		hl,9		;//hl=number '9' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,163			;// Optimize -6- [Qc1040]
		ld		hl,81		;//hl=number '81' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1092		;//Digit0High=  TopScore Mod 10
		Ld		de,(var_wrd_TopScore)			;// Optimize -1- [Qc1001]
		Ld		hl,10			;// [Qc1002]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit0High),hl		;//Int variable 'var_wrd_Digit0High'=expression result [Qc219]
.QLn_1093		;//Digit1High= (TopScore/10) Mod 10
		Ld		de,(var_wrd_TopScore)			;// Optimize -1- [Qc1001]
		Ld		hl,10			;// [Qc1002]
		call	Quig_Div16		;//Divide HL by DE [Qc062]
		ex		de,hl 		;// [Qc269]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit1High),hl		;//Int variable 'var_wrd_Digit1High'=expression result [Qc219]
.QLn_1094		;//Digit2High=(TopScore/100) Mod 10
		Ld		de,(var_wrd_TopScore)			;// Optimize -1- [Qc1001]
		Ld		hl,100			;// [Qc1002]
		call	Quig_Div16		;//Divide HL by DE [Qc062]
		ex		de,hl 		;// [Qc269]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_Mod16		;/Mod HL by DE [Qc063]
		ld		(var_wrd_Digit2High),hl		;//Int variable 'var_wrd_Digit2High'=expression result [Qc219]
.QLn_1097		;//Sprite.Pattern.Set 10,114+Digit2High
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit2High)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,10						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1098		;//Sprite.Pattern.Set 11,114+Digit1High
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit1High)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,11						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1099		;//Sprite.Pattern.Set 12,114+Digit0High
		Ld		de,114 				;// Optimize 520 [Qc5100]
		Ld		hl,(var_wrd_Digit0High)				;// [Qc5101]
		add		hl,de						;// [Qc5102]
		Ld		de,12						;// [Qc5103]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1101		;//Sprite.Position.Set 10, 143,102
		ld		hl,10		;//hl=number '10' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,143			;// Optimize -6- [Qc1040]
		ld		hl,102		;//hl=number '102' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1102		;//Sprite.Position.Set 11, 153,102
		ld		hl,11		;//hl=number '11' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,153			;// Optimize -6- [Qc1040]
		ld		hl,102		;//hl=number '102' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1103		;//Sprite.Position.Set 12, 163,102
		ld		hl,12		;//hl=number '12' [Qc054]
		push		hl		;// Store result [Qc225]
		Ld 		de,163			;// Optimize -6- [Qc1040]
		ld		hl,102		;//hl=number '102' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1105		;//EndF
		ret		;// [Qc262]
.QLn_1108		;//Function RemoveScoreBoard:Void()
.QFunc_REMOVESCOREBOARD
.QLn_1109		;//For i=3 To 44
		ld		hl,44		;//hl=number '44' [Qc054]
		ld 		(QFr5283_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,3		;//hl=number '3' [Qc054]
		.QFr5283_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr5283_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr5283_Start	;// [Qc307]
		jp		nz,QFr5283_Exit	;// [Qc308]
.QFr5283_Start:
.QLn_1110		;//Sprite.Pattern.Set i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1111		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1112		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr5283_Loop		;// [Qc340]
.QFr5283_Exit:
.QLn_1113		;//EndF
		ret		;// [Qc262]
.QLn_1116		;//Function RemoveLogo:Void
.QFunc_REMOVELOGO
.QLn_1117		;//For i=192 To 203
		ld		hl,203		;//hl=number '203' [Qc054]
		ld 		(QFr5315_Top+1),hl 		;/Copy Result into static'var_wrd_i' [Qc303]
		ld		hl,192		;//hl=number '192' [Qc054]
		.QFr5315_Loop:ld 		(var_wrd_i),hl ;/Loop Repeat Point [Qc301]
		.QFr5315_Top:ld		de,0 		;//Compare value into DE  [Qc300]
		xor		a			;// [Qc305]
		sbc		hl,de		;//[Qc306]
		jr		c,QFr5315_Start	;// [Qc307]
		jp		nz,QFr5315_Exit	;// [Qc308]
.QFr5315_Start:
.QLn_1118		;//Sprite.Pattern.Set	 i,191
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,191		;//hl=number '191' [Qc054]
		call	Quig_g9k_Sprite_Set_Pattern				;//Call 'Sprite.Pattern.Set' [Qc234]
.QLn_1119		;//Sprite.Position.Set i,1,166
		ld		hl,(var_wrd_i) 	;//hl=value of 'var_wrd_i' [Qc053]
		push		hl		;// Store result [Qc225]
		Ld 		de,1			;// Optimize -6- [Qc1040]
		ld		hl,166		;//hl=number '166' [Qc054]
		call	Quig_g9k_Sprite_Set_Position				;//Call 'Sprite.Position.Set' [Qc234]
.QLn_1120		;//Next
		ld		hl,(var_wrd_i) ;// [Qc330]
		inc		hl		;// [Qc331]
		jp		QFr5315_Loop		;// [Qc340]
.QFr5315_Exit:
.QLn_1121		;//EndF
		ret		;// [Qc262]
.QLn_1123		;//ASM
.SyDesktop_Service:
		ld 		c,MSC_DSK_DSKSRV
        ld 		(SyDSrvN),a
        push 	af
        call 	SyDesktop_SendMessage
        pop 	af
        cp 		1
        jr 		z,SyDSrv1
        cp 		3
        jr 		z,SyDSrv1
        cp 		5
        ret 	nz
.SyDSrv1:
		call 	SyDesktop_WaitMessage
        cp 		MSR_DSK_DSKSRV
        jr 		nz,SyDSrv1
        ld 		a,(SyDSrvN)
        cp 		(iy+1)
        jr 		nz,SyDSrv1
        ld 		e,(iy+2)
        ld 		d,(iy+3)
        ld 		l,(iy+4)
        ld 		h,(iy+5)
        ret
.SyDSrvN db 0
.Quig_g9k_SetMode_50
		ld		a,0				;quit reset mode & select XTAL oscilator
		ld		bc,CG9K_VRAM+7
		out		(c),a
		ld		a,6				;set REGISTER 6,7,8 for P1 mode
		ld		bc,CG9K_VRAM+4
		out		(c),a
		ld		a,5				;reg #6
		ld		bc,CG9K_VRAM+3
		out		(c),a
		ld		a,8				;reg #7   +8 pour 50Hz
		out		(c),A
		ret		
.Quig_g9k_Fore_Palette_Set
		ld		a,l
		and		%11
		ld		l,a
		ld		a,(Quig_g9k_ForeBack_Palette)
		and		%1100
		or		l
		ld		(Quig_g9k_ForeBack_Palette),a
		jp		Quig_g9k_ForeBack_Palette_Set
.Quig_g9k_Back_Palette_Set
		ld		a,l
		rla
		rla	
		and		%1100
		ld		l,a
		ld		a,(Quig_g9k_ForeBack_Palette)
		and		%11
		or		l
		ld		(Quig_g9k_ForeBack_Palette),a
.Quig_g9k_ForeBack_Palette_Set
		ld		a,g9k_PALETTE_CTRL
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		ld		a,(Quig_g9k_ForeBack_Palette)
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ret
.Quig_g9k_ForeBack_Palette:	db	%0100
.Quig_g9k_VWait
.Quig_g9k_Vwait_1
		ld		bc,CG9K_Status
		in		a,(c)
		and		g9k_STATUS_VR
		jr		nz,Quig_g9k_Vwait_1
.Quig_g9k_Vwait_2
		ld		bc,CG9K_Status
		in		a,(c)
		and		g9k_STATUS_VR
		jr		z,Quig_g9k_Vwait_2		
		ret		
.Quig_G9K_SCROLL_A	
		ld		hl,(Quig_G9K_ScrollA_YPos)
		ld		a,g9k_SCROLL_LOW_Y
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		ld		bc,CG9K_REG_DATA
		out		(c),a		
		ld		a,2
		rrca
		rrca
		or		h
		out		(c),a
		ld		hl,(Quig_G9K_ScrollA_XPos)
		ld		a,g9k_SCROLL_LOW_X
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		and		7
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ld		a,l
		srl		h
		rra
		srl		h
		rra		
		srl		h
		rra
		out		(c),a
		ret
.Quig_g9k_Scroll_A_Set:
		ld		(Quig_G9K_ScrollA_XPos),de
		ld		(Quig_G9K_ScrollA_YPos),hl
		ret
.Quig_g9k_Scroll_AX_Set:
		ld		(Quig_G9K_ScrollA_XPos),hl
		ret
.Quig_g9k_Scroll_AY_Set:
		ld		(Quig_G9K_ScrollA_YPos),hl
		ret			
.Quig_G9k_Scroll_B	
		ld		hl,(Quig_G9K_ScrollB_YPos)
		ld		a,g9k_SCROLL_LOW_Y_B
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		ld		bc,CG9K_REG_DATA
		out		(c),a		
		ld 		a,h
		and		%1
		out		(c),a
		ld		hl,(Quig_G9K_ScrollB_XPos)
		ld		a,g9k_SCROLL_LOW_X_B
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		and		7
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ld		a,l
		srl		h
		rra
		srl		h
		rra		
		srl		h
		rra
		out		(c),a
		ret	
.Quig_g9k_Scroll_B_Set:
		ld		(Quig_G9K_ScrollB_XPos),de
		ld		(Quig_G9K_ScrollB_YPos),hl
		ret	
.Quig_g9k_Scroll_BX_Set:
		ld		(Quig_G9K_ScrollB_XPos),hl
		ret
.Quig_g9k_Scroll_BY_Set:
		ld		(Quig_G9K_ScrollB_YPos),hl
		ret		
.Quig_g9k_MapB_Meta:
		ld		a,112
		ld		(Quig_g9k_MapA_Meta2+1),a
		jr		Quig_g9k_MapA_Meta1
.Quig_g9k_MapA_Meta:
		ld		a,96
		ld		(Quig_g9k_MapA_Meta2+1),a
.Quig_g9k_MapA_Meta1:		
		pop		iy
		ld		a,g9k_READ_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,6
		out		(c),a
		ld		hl,Quig_g9k_MetaTile_Data
		ld		bc,CG9K_VRAM
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ex		de,hl
		pop		de
		ld		a,l
		and		%1111
.Quig_g9k_MapA_Meta2:		
		add		96      		;112 Draw to Map B
		ld		h,a
		ld		a,e
		rla		
		rla
		and		%111100
		ld		l,a
		add		hl,hl			;hl=hl*2 (or 32)
		ld		de,Quig_g9k_MetaTile_Data
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		jp		(iy)
.Quig_g9k_MapA_Meta_Loop
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,7
		out		(c),a
		ld		bc,CG9k_VRAM
		ex		de,hl
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi	
		ex		de,hl
		ld		bc,128
		add		hl,bc
		ret
.Quig_g9k_Meta2MapA_Reg:	dw	0			
.Quig_g9k_MetaTile_Data:
		dw		100,100,100,100,10,15,16,13,10,29,20,21,34,22,22,22,0,0,0,0,0,0,0,0		
.Quig_g9k_MapB_Get:
		ld		de,#1800
		add		hl,de
.Quig_g9k_MapA_Get:
		add		hl,hl
		ld		a,g9k_READ_ADDR
		ld		bc,CG9K_REG_SELECT
		di
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,7
		out		(c),a
		ld		bc,CG9K_VRAM
		in		a,(c)
		ld		l,a
		in		a,(c)
		ld		h,a
		ei
		ret
.Quig_Mul16
		ld		c,l
		ld		a,h
		ld 		b,16
.Quig_INT_Mult16_Loop_DEHL:
		add		hl,hl
		sla 	c
		rla
		jr 		nc,Quig_INT_Mult16_NoAdd_DEHL
		add 	hl,de
.Quig_INT_Mult16_NoAdd_DEHL:
		djnz	Quig_INT_Mult16_Loop_DEHL
		ret	
.Quig_g9k_Ink_Set:
		pop		iy
		ld		a,l
		call	Quig_g9k_Max32
		ld		a,b
		ld		(Quig_g9k_Ink_Set_x9+1),a
		ld		a,e
		call	Quig_g9k_Max32
		ld		a,b		
		ld		(Quig_g9k_Ink_Set_x8+1),a		
		pop		de
		ld		a,e
		call	Quig_g9k_Max32
		ld		a,b
		ld		(Quig_g9k_Ink_Set_x7+1),a	
		pop		hl
		ld		e,l
		ld		d,h
		add		hl,hl
		add		hl,de
		ld		de,Quig_g9k_Ink_Data
		add		hl,de
.Quig_g9k_Ink_Set_x7:			;Red			
		ld		a,0
		ld		(hl),a
		inc		hl
.Quig_g9k_Ink_Set_x8:			;Green				
		ld		a,0
		ld		(hl),a
		inc		hl		
.Quig_g9k_Ink_Set_x9:			;Blue				
		ld		a,0
		ld		(hl),a
		inc		hl
		jp		(iy)
.Quig_g9k_Max32:
		ld		b,a
		and		%11100000
		ret		z
		and		%10000000
		jr		z,Quig_g9k_Max32_1
		ld		b,0
		ret
.Quig_g9k_Max32_1		
		ld		b,31
		ret
.Quig_g9k_Ink_Data
	ds	256*3
.Quig_G9K_Ink_Palette_Set:
		ld		a,e
		and		%11
		rla		;2
		rla		;4
		rla		;8
		rla		;16
		rla		;32
		rla		;64
		ld		e,a	
		ld		c,l
		ld		b,h
		add		hl,hl		;*32
		add		hl,bc		;*48
		ld		bc,Quig_g9k_Ink_Data
		add		hl,bc
		ld		a,g9k_PALETTE_PTR
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		ld		a,e
		ld		bc,CG9K_REG_DATA
		out		(c),a		
		ld		bc,CG9K_palette
		jp		Quig_g9k_48outi
.Quig_g9k_BackColour_Set:
		ld		a,CG9K_BACK_DROP_COLOR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		ret		
.Quig_G9k_Sprite_Set_Palette:
		ex		de,hl
		ld		a,l
		and		%1111111
		ld		l,a
		ld		h,0
		add		hl,hl							;*4
		add		hl,hl							;*4
		ld		bc,Quig_Sprite_Attributes+3
		add		hl,bc							;Sprite Attribute Y
		ld		a,(hl)
		and		%111111
		ld		d,a
		ld		a,e
		rla
		rla
		rla
		rla
		rla
		rla
		and		%11000000
		or		d
		ld		(hl),a
		ret		
.Quig_G9k_Sprite_Set_Position:
		pop		iy								;IY=Return Address
.Quig_G9k_Sprite_Set_Position_X:		
		pop		bc								;BC=Sprite Number
		push	hl								;Store Y
		ld		a,c								;Copy Sprite number too A
		and		%1111111						;Filter 0-127
		ld		l,a								;HL=A
		ld		h,0				
		add		hl,hl							;*2
		add		hl,hl							;*4
		ld		bc,Quig_Sprite_Attributes		
		add		hl,bc							;Sprite Attribute Y
		pop		bc
		ld		(hl),c							;Y
		inc		hl								;Skip Pat no		
		inc		hl
		ld		(hl),e							;X
		inc		hl
		ld		a,d
		and		%11
		ld		d,a
		ld		a,(hl)
		and		%11111100
		or		d
		ld		(hl),a
		jp		(iy)
.Quig_G9k_Sprite_Set_Display:
		ex		de,hl
		add		hl,hl
		add		hl,hl
		ld		bc,Quig_Sprite_Attributes+3
		add		hl,bc							;Point to strite attribute
		ld		a,(hl)
		and		%11000011
		ld		d,a
		ld		a,e
		and		%11
		rla
		rla
		rla
		rla
		or 		d
		ld		(hl),a
		ret
.Quig_g9k_Sprite_Refresh:
		ld		hl,#FE00
		ld		e,3
.Quig_g9k_Sprite_Refresh_999
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		out		(c),e
		ld		hl,Quig_Sprite_Attributes
		ld 		bc,CG9K_VRAM
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi		
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi				
		call	Quig_g9k_48outi
		call	Quig_g9k_48outi		
		call	Quig_g9k_20outi			;Last 20
		ret
.directstr_1: DW 12: DB "flappy4.qpt",0
.Quig_App_Path
		ld		hl,Quig_CodeEnd
		inc		hl
		ld		de,(Quig_String_Buffer_Pos)
		ld		bc,0
.Quig_App_Path_1		
		ld		a,(hl)
		cp		"."
		jr		z,Quig_App_Path_Found
		ld		(de),a
		cp		"\"
		jr		nz,Quig_App_Path_x
		ld		c,b
.Quig_App_Path_x:
		inc		b
		inc		hl
		inc		de
		jr		Quig_App_Path_1
.Quig_App_Path_Found:
		ld		hl,(Quig_String_Buffer_Pos)
		ld		e,l
		ld		d,h
		ld		b,0
		add		hl,bc
		inc		hl
		xor		a
		ld		(hl),a
		inc		hl
		ld		(Quig_String_Buffer_Pos),hl
		ex		de,hl
		ret
.Quig_Str_Add
		push	hl
		ex		de,hl
		ld		de,(Quig_String_Buffer_Pos)
		xor		a
.Quig_Str_Add_p1		
		cp		(hl)
		ldi
		jr		nz,Quig_Str_Add_p1
		dec		de
		pop		hl
.Quig_Str_Add_p2		
		cp		(hl)
		ldi
		jr		nz,Quig_Str_Add_p2
		ld		hl,(Quig_String_Buffer_Pos)
		ld		(Quig_String_Buffer_Pos),de
		ret
.Quig_LoadPal_Offset:	db	0
.Quig_LoadTile_Offset:	dw	0
.Quig_LoadTile_Handle:	db	0
.Quig_LoadTile_Count:	dw	0
.Quig_LoadTile_Buffer:	dw	0
.Quig_G9K_TileALoad:
		pop		iy
		ld		a,l
		ld		(Quig_LoadTile_Offset),de
		jr		Quig_G9K_TileLoadX
.Quig_G9K_TileBLoad:
		pop		iy
		ld		a,l
		ld		hl,8192
		add		hl,de
		ld		(Quig_LoadTile_Offset),hl		
.Quig_G9K_TileLoadX:
		ld		l,a
		ld		h,0
		ld		c,l
		ld		b,h
		add		hl,hl		;*32
		add		hl,bc		;*48
		ld		bc,Quig_g9k_Ink_Data
		add		hl,bc	
		ld		(Quig_g9k_TileStuff),hl
		pop		hl								;Get File address
		push	iy
		ld		a,(appBnkNum)					;Filename Bank
		db		#DD,#67
		call 	SySystem_CallFunction
        db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILOPN					;Open File		
		jp		c,Quig_G9K_TileLoadFail
		ld		(Quig_LoadTile_Handle),a		;Store our File Handle Number	
		ld		a,(appBnkNum)
		ld		e,a
		ld		hl,(Quig_String_Buffer_Pos)
		ld		bc,60							;Header,Tile Cuunt & 16 Palettes
		ld		a,(Quig_LoadTile_Handle)		
		call 	SySystem_CallFunction
		db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILINP	
		ld		hl,(Quig_String_Buffer_Pos)
		ld		a,(hl)		
		cp		178
		jp		nz,Quig_G9K_TileLoadFail_Close
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		(Quig_LoadTile_Count),de
		inc		hl
		ld		de,(Quig_g9k_TileStuff)
		ld		bc,48
		ldir
.Quig_LoadTileLoop_N1:
		ld		a,(appBnkNum)
		ld		e,a
		ld		hl,(Quig_String_Buffer_Pos)
		ld		(Quig_LoadTile_Buffer),hl		
		ld		bc,1024							;1024 Bytes of tile data
		ld		a,(Quig_LoadTile_Handle)		
		call 	SySystem_CallFunction
		db 		MSC_SYS_SYSFIL
       db 		FNC_FIL_FILINP
		ld		b,32
.Quig_LoadTileLoop_N2:		
		push	bc
		ld		hl,(Quig_LoadTile_Offset)
		ld		a,h
		rra		
		rra	
		rra
		and		%111
		ld		e,a
		add		hl,hl							;*2
		add		hl,hl							;*4
		add		hl,hl							;*8
		add		hl,hl							;*16
		add		hl,hl							;*32		
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		out		(c),e
		ld		hl,(Quig_LoadTile_Buffer)
		ld		bc,CG9k_VRAM
		call	Quig_g9k_32outi		
		ld		hl,(Quig_LoadTile_Offset)
		inc		hl
		ld		(Quig_LoadTile_Offset),hl
		ld		hl,(Quig_LoadTile_Buffer)
		ld		de,32
		add		hl,de
		ld		(Quig_LoadTile_Buffer),hl
		pop		bc
		djnz	Quig_LoadTileLoop_N2
		ld		hl,(Quig_LoadTile_Count)		;Tile Count
		ld		de,32
		and		a
		sbc		hl,de
		ld		(Quig_LoadTile_Count),hl
		jp		c,Quig_G9K_TileLoadFail_Close
		jp		nz,Quig_LoadTileLoop_N1
.Quig_G9K_TileLoadFail_Close:		
		ld		a,(Quig_LoadTile_Handle)
		call 	SySystem_CallFunction
        db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILCLO		
.Quig_G9K_TileLoadFail:
		ld		hl,0
		ret		
.Quig_g9k_TileStuff:Dw	0
.Quig_g9k_DrawTileA:
		pop		iy
		ld		bc,#c000
		jr		Quig_g9k_DrawTile
.Quig_g9k_DrawTileB:
		pop		iy
		ld		bc,#e000
.Quig_g9k_DrawTile:
		ld		a,l
		and		%00111111
		ld		l,a
		add		hl,hl	;*2
		add		hl,hl	;*4
		add		hl,hl	;*8
		add		hl,hl	;*16
		add		hl,hl	;*32
		add		hl,hl	;*64
		ld		a,e
		and		%00111111
		ld		e,a
		add		hl,de
		add		hl,hl
		add		hl,bc
		ld		e,7
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		out		(c),e
		pop		de
		ld		bc,CG9K_VRAM
		out		(c),e
		out		(c),d
		jp		(iy)
.Quig_LTE_HL
		ld		a,h
		xor		d
		jp 		m,Quig_cmplte2
		sbc 	hl,de
		jr		nc,Quig_cmplte3
.Quig_cmplte1                 ;false
		ld 		hl,0
		ret
.Quig_cmplte2 
		bit 	7,d
		jr 		z,Quig_cmplte1
.Quig_cmplte3                ;true
        ld 		hl,1
        ret
.Quig_LT_HL
		ld 		a,h
        xor		d
		jp 		m,quig_cmplte2
		sbc 	hl,de
		jr 		z,quig_cmplte1
		jr 		nc,quig_cmplte3
		ld 		hl,0
		ret
.Quig_LTE_HL_Direct
		ld		a,h
		xor		d
		jp 		m,Quig_cmplte2dx
		sbc 	hl,de
		jr		nc,Quig_cmplte3dx
.Quig_cmplte1dx                 ;false
		xor		a
		ret
.Quig_cmplte2dx 
		bit 	7,d
		jr 		z,Quig_cmplte1dx
.Quig_cmplte3dx                ;true
        ld		a,1
		or 		a
        ret
.Quig_LT_HL_Direct
		ld 		a,h
        xor		d
		jp 		m,quig_cmplte2dx
		sbc 	hl,de
		jr 		z,quig_cmplte1dx
		jr 		nc,quig_cmplte3dx
		xor 	a
		ret		
.Quig_GTE_HL
		ld		a,h
        xor		d
        jp 		m,quig_cmpgte2
        ex 		de,hl
        sbc 	hl,de
        jr 		nc,quig_cmpgte3
.quig_cmpgte1               ;false
        ld 		hl,0
        ret
.quig_cmpgte2 
		bit 	7,d
        jr 		nz,quig_cmpgte1
.quig_cmpgte3              ;true
        ld 		hl,1
        ret
.Quig_GT_HL
		ld 		a,h
        xor 	d
        jp 		m,quig_cmpgte2
        sbc 	hl,de
        jr 		c,quig_cmpgte3
        ld 		hl,0
        ret	
.Quig_GTE_HL_Direct
		ld		a,h
        xor		d
        jp 		m,quig_cmpgte2dx
        ex 		de,hl
        sbc 	hl,de
        jr 		nc,quig_cmpgte3dx
.quig_cmpgte1dx               ;false
        xor		a
        ret
.quig_cmpgte2dx 
		bit 	7,d
        jr 		nz,quig_cmpgte1dx
.quig_cmpgte3dx              ;true
        ld 		a,1
		or		a
        ret
.Quig_GT_HL_Direct
		ld 		a,h
        xor 	d
        jp 		m,quig_cmpgte2dx
        sbc 	hl,de
        jr 		c,quig_cmpgte3dx
        xor 	a
        ret			
.Quig_g9k_ink_R_Get:
		ld		e,l
		ld		d,h
		add		hl,hl
		add		hl,de
		ld		de,Quig_g9k_Ink_Data		
		add		hl,de
		ld		l,(hl)
		ld		h,0
		ret
.Quig_g9k_Ink_Fade:
		pop		iy
		ld		a,h
		and		%1111111
		ld		h,a
		ld		(Quig_g9k_Ink_Div_Level),hl
		ld		(Quig_g9k_Ink_Div_Ink2),de
		pop		hl
		ld		(Quig_g9k_Ink_Div_Ink1),hl
.Quig_g9k_Ink_Div:
		ld		(Quig_g9k_Ink_Div_Ink1),hl
		ld		(Quig_g9k_Ink_Div_Ink2),de		
		xor		a
		sbc		hl,de
		jp		c,Quig_g9k_Ink_Div_x2
		ld		de,(Quig_g9k_Ink_Div_Level)
		call	Quig_Mul16
		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		ld		de,(Quig_g9k_Ink_Div_Ink2)
		add		hl,de
		jp		(iy)
.Quig_g9k_Ink_Div_x2:		
		ld		(Quig_g9k_Ink_Div_Ink1),de
		ld		(Quig_g9k_Ink_Div_Ink2),hl		
		xor		a
		sbc		hl,de
		ld		de,(Quig_g9k_Ink_Div_Level)
		call	Quig_Mul16
		ld 		a,h:rl l:rla:ld l,a:ld a,h:rlca:and 1:ld h,a
		ld		de,(Quig_g9k_Ink_Div_Ink1)
		add		hl,de
		jp		(iy)
.Quig_g9k_Ink_Div_Ink1:	dw	0	
.Quig_g9k_Ink_Div_Ink2:	dw	0
.Quig_g9k_Ink_Div_Level:dw	0		
.Quig_g9k_ink_G_Get:
		ld		e,l
		ld		d,h
		add		hl,hl
		add		hl,de
		ld		de,Quig_g9k_Ink_Data+1
		add		hl,de
		ld		l,(hl)
		ld		h,0
		ret	
.Quig_g9k_ink_B_Get:
		ld		e,l
		ld		d,h
		add		hl,hl
		add		hl,de
		ld		de,Quig_g9k_Ink_Data+2
		add		hl,de
		ld		l,(hl)
		ld		h,0
		ret	
.Quig_G9k_Sprite_Set_Pattern:
		ex		de,hl
		ld		a,l
		and		%1111111
		ld		l,a
		ld		h,0
		add		hl,hl							;*4
		add		hl,hl							;*4
		ld		bc,Quig_Sprite_Attributes+1
		add		hl,bc							;Sprite Attribute Y
		ld		(hl),e
		ret
.Quig_G9k_Sprite_Set_Position3:
		ld		a,-16
		ld		(Quig_G9k_Sprite_Set_Pos60+1),a
		jr		Quig_G9k_Sprite_Set_Position4
.Quig_G9k_Sprite_Set_Position2:
		ld		a,16
		ld		(Quig_G9k_Sprite_Set_Pos60+1),a
.Quig_G9k_Sprite_Set_Position4:
		pop		iy								;IY=Return Address
		ld		a,l
		and		%11111
		ld		(Quig_G9k_Sprite_Pos_Set_Height),a		;Store Height to draw
		ld		a,e
		and		%111111
		ld		(Quig_G9k_Sprite_Pos_Set_Width1),a		;Store Static width to draw
		ld		(Quig_G9k_Sprite_Pos_Set_Width2),a		;Store Change width to draw
		pop		hl
		ld		a,l
		ld		(Quig_G9k_Sprite_PosY),a
		pop		hl
		ld		(Quig_G9k_Sprite_PosX1),hl
		ld		(Quig_G9k_Sprite_PosX2),hl				;Store Change Pos X to draw		
		pop		hl										;Get Start sprite
		ld		a,l
		and		%1111111
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		ld		bc,Quig_Sprite_Attributes		
		add		hl,bc									;Get to Start of SpriteY address
		ld		(Quig_G9K_SpriteY_Address),hl
.Quig_G9k_Sprite_Set_Pos33:		
		ld		hl,(Quig_G9K_SpriteY_Address)			;Sprite Address
		ld		a,(Quig_G9k_Sprite_PosY)
		ld		(hl),a									;Y
		inc		hl										;Skip Pat no		
		inc		hl
		ld		de,(Quig_G9k_Sprite_PosX2)
		ld		(hl),e									;X
		inc		hl
		ld		a,d
		and		%11
		ld		d,a
		ld		a,(hl)
		and		%11111100
		or		d
		ld		(hl),a
		inc		hl										;Set to next sprite
		ld		(Quig_G9K_SpriteY_Address),hl			;Sprite Address
		ld		a,(Quig_G9k_Sprite_Pos_Set_Width2)		;Get Width
		dec		a
		jr		nz,Quig_G9k_Sprite_Set_Pos35
		ld		a,(Quig_G9k_Sprite_Pos_Set_Width1)		;Get Original Width
		ld		(Quig_G9k_Sprite_Pos_Set_Width2),a		;Store it
		ld		a,(Quig_G9k_Sprite_Pos_Set_Height)
		dec		a
		jr		nz,Quig_G9k_Sprite_Set_Pos34
		jp		(iy)
.Quig_G9k_Sprite_Set_Pos34:	
		ld		(Quig_G9k_Sprite_Pos_Set_Height),a		;Store new Height
		ld		hl,(Quig_G9k_Sprite_PosX1)				;Get Original X
		ld		(Quig_G9k_Sprite_PosX2),hl				;Store
		ld		a,(Quig_G9k_Sprite_PosY)
.Quig_G9k_Sprite_Set_Pos60:	
		add		16
		ld		(Quig_G9k_Sprite_PosY),a
		jp		Quig_G9k_Sprite_Set_Pos33
.Quig_G9k_Sprite_Set_Pos35:
		ld		(Quig_G9k_Sprite_Pos_Set_Width2),a
		ld		hl,(Quig_G9k_Sprite_PosX2)
		ld		de,16
		add		hl,de
		ld		(Quig_G9k_Sprite_PosX2),hl
		jp		Quig_G9k_Sprite_Set_Pos33
.Quig_G9k_Sprite_Pos_Set_Height:	db 			0
.Quig_G9k_Sprite_Pos_Set_Width1:	db 			0
.Quig_G9k_Sprite_Pos_Set_Width2:	db 			0
.Quig_G9k_Sprite_PosY:				db			0
.Quig_G9k_Sprite_PosX1:				dw			0
.Quig_G9k_Sprite_PosX2:				dw			0
.Quig_G9K_SpriteY_Address:			dw			0
.directstr_2: DW 12: DB "flappy1.qpt",0
.directstr_3: DW 12: DB "flappy3.qpt",0
.directstr_4: DW 12: DB "flappy2.qpt",0
.Quig_Mouse_X:
		rst 	#20
		dw 		#813C
		ex		de,hl				;X results in DE so put in HL
		ret
.Quig_Mouse_Y:
		rst 	#20
		dw 		#813C
		ret
.Quig_Mouse_Key:
		rst 	#20
		dw 		#813F
		ld		l,a
		ld		h,0
		ret		
.Quig_Min_Int:
		ld		(Quig_Max_HL),de
		ld		(Quig_Max_DE),hl
		ex		de,hl
		jr		Quig_Max_Int2
.Quig_Max_Int:
		ld		(Quig_Max_HL),de
		ld		(Quig_Max_DE),hl
.Quig_Max_Int2:		
		ld 		a,h
        xor		d
		jp 		m,quig_Max_te2
		sbc 	hl,de
		jr 		z,quig_Max_te1
		jr 		nc,quig_Max_te3
		ld 		hl,(Quig_Max_HL)
		ret
.Quig_Max_te1                 ;false
		ld 		hl,(Quig_Max_HL)
		ret
.Quig_Max_te2 
		bit 	7,d
		jr 		z,Quig_Max_te1
.Quig_Max_te3                ;true
        ld 		hl,(Quig_Max_DE)
        ret
.Quig_Max_HL:dw 0
.Quig_Max_DE:dw	0		
.Quig_Shl2:
		add		hl,hl
		add		hl,hl
		ret		
.Quig_Shr1:
		srl 	h:rr 	l
		ret
.Quig_Shr4:
		LD A,L:SRL H:RRA:SRL H:RRA:SRL H:RRA:SRL H:RRA:LD L,A
		ret	
.Quig_IRandomize:
		ld		(Quig_RNDSeed),hl
		ret
.Quig_IRnd:
		push	hl
		ld		de,(Quig_RNDSeed)	; Seed is usually 0
		ld		a,d
		ld		h,e
		ld		l,253
		or		a
		sbc		hl,de
		sbc		a,0
		sbc		hl,de
		ld		d,0
		sbc		a,d
		ld		e,a
		sbc		hl,de
		jr		nc,Quig_IRnd2	
		inc		hl
.Quig_IRnd2	
		ld		(Quig_RNDSeed),hl
		ex		de,hl
		pop		hl
		call	Quig_Div16
		ex		de,hl
		ret
.Quig_RNDSeed:dw	100
.Quig_Mod16:
		call	Quig_Div16
		ex		de,hl
		ret
.Quig_Div16:
		ex		de,hl           	; HL = DE \ HL
		ld		a,e             	; Division by zero?
		Or		d
		jr		nz,Quig_N_Div17      ; Continue of not
		ld		hl,0
		ld		de,0
		scf			            	; Set Carry to indicate an error
		ret
.Quig_N_Div17:
		ld		c,l             	; AC = HL
		ld		a,h
		ld		hl,0            	; HL = Modulus
		ld		b,16            	; 16-bit division
		Or		a               	; Start with carry reset
.Quig_N_Div18:
		rl		c               	; AC = AC * 2
		rla  	                	; (set Carry to bit 0)
		rl		l               	; HL = HL * 2
		rl		h               	; (reset Carry again (HL = 0))
		push	hl
		sbc		hl,de
		ccf                     	; Carry set when Ok
		jr		c,Quig_N_Div19       ; Modulus cannot be >= Value
		ex		(sp),hl         	; Restore Modulus
.Quig_N_Div19:
		inc		SP              	; Get Modulus from Stack
		inc		SP
		djnz 	Quig_N_Div18         ; Repeat for all bits
		ex		de,hl           	; DE = Modulus
		rl		c               	; Carry to C
		ld		l,c             	; HL = AC
		rla
		ld		h,a
		Or		a               	; Reset Carry (valid result)
		ret		
.SyDesktop_SendMessage:
        ld 		iy,AppMsgB
        ld 		(iy+0),c
        ld 		(iy+1),a
        ld 		(iy+2),e
        ld 		(iy+3),d
        ld 		(iy+4),l
        ld 		(iy+5),h
        db 		#dd:ld h,2       ;2 is the number of the desktop manager process
        ld 		a,(AppPrzN)
        db 		#dd:ld l,a
        rst 	#10
        ret
.SyDesktop_WaitMessage: 
		ld 		iy,AppMsgB
.SyDWMs1:
		db 		#dd:ld h,2       ;2 is the number of the desktop manager process
        ld 		a,(AppPrzN)
        db 		#dd:ld l,a
        rst 	#08             ;wait for a desktop manager message
        db 		#dd:dec l
        jr 		nz,SyDWMs1
        ld 		a,(iy+0)
        ret
.Quig_g9k_48outi:
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi
.Quig_g9k_20outi:			
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi		
		ret
.Quig_g9k_32outi:
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		ret		
.Quig_CodeEnd:db 0
.AppDatBeg
.AppFormStart:    dw Form1_Begin
.AppFormLists
    dw Form1_ControlWindowData
.Form1_Icon:
        db 2,8,8
     db #0F,#0F,#3F,#CF,#7F,#EF,#6F,#6F,#6F,#67,#7F,#23,#3F,#89,#0F,#0F
.Icon24_Data
.Icon24_Data_WidthByte:     db 12
.Icon24_Data_WidthPixel:    db 24
.Icon24_Data_Height:        db 24
.Icon24_Data_DataAddr:      dw Icon24_Data_Data
.Icon24_Data_EncodeAddr:    dw Icon24_Data_Encode
.Icon24_Data_Size:          dw 288
.Icon24_Data_Encode:        db 5
.Icon24_Data_Data:          
             db 68,68,68,68,68,68,68,68,68,86,119,84
             db 68,68,68,68,68,68,68,68,68,86,119,84
             db 68,72,132,68,68,68,68,68,69,86,119,117
             db 68,136,136,68,68,136,136,68,69,86,119,117
             db 68,68,68,68,68,68,136,68,68,68,68,68
             db 68,68,68,68,68,68,68,68,68,68,136,68
             db 68,68,68,68,68,68,68,68,68,68,68,68
             db 68,68,136,132,68,68,68,68,69,86,119,117
             db 68,68,68,68,68,68,68,68,69,86,119,117
             db 153,153,153,153,153,153,153,153,149,86,119,85
             db 153,153,153,145,17,17,25,153,153,86,119,89
             db 153,153,145,18,34,24,129,153,153,86,119,89
             db 153,153,18,34,33,136,24,25,153,86,119,89
             db 153,145,34,34,33,216,24,129,153,86,119,89
             db 153,18,34,34,34,29,136,129,153,86,119,89
             db 153,17,17,25,34,33,17,17,25,86,119,89
             db 145,136,136,129,34,31,255,255,241,86,119,89
             db 145,216,136,209,33,241,17,17,25,86,119,89
             db 153,17,17,18,34,31,255,255,25,86,119,89
             db 153,145,34,34,34,33,17,17,153,86,119,89
             db 153,153,17,17,17,25,153,153,153,86,119,89
             db 153,153,153,153,153,153,153,153,153,86,119,89
             db 170,170,170,170,170,170,170,170,170,86,119,90
             db 170,170,170,170,170,170,170,170,170,86,119,90
.Sheet_Data4:                   
.Sheet_Data4_WidthByte:     db 2
.Sheet_Data4_WidthPixel:    db 1
.Sheet_Data4_Height:        db 1
.Sheet_Data4_DataAddr:      dw Sheet_Data4_Data
.Sheet_Data4_EncodeAddr:    dw Sheet_Data4_Encode
.Sheet_Data4_Size:          dw 1
.Sheet_Data4_Encode:        db 0
.Sheet_Data4_Data:          dw 0
.File_Select_Text:   dw File_Select_Text_Data+4
.Directory_Select_Text:   dw Directory_Select_Text_Data+4
.var_wrd_GameOn:   dw 0
.var_wrd_PattsLoaded:   dw 0
.var_wrd_SkipFrame:   dw 0
.var_wrd_f:   dw 0
.var_wrd_k:   dw 0
.var_wrd_i:   dw 0
.var_wrd_g:   dw 0
.var_wrd_h:   dw 0
.var_wrd_g1:   dw 0
.var_wrd_h1:   dw 0
.var_wrd_menuOn:   dw 0
.var_wrd_menuX:   dw 64
.var_wrd_menuY:   dw 64
.var_wrd_MouseKey:   dw 0
.var_wrd_mouseX:   dw 100
.var_wrd_mouseY:   dw 100
.var_wrd_Pauze:   dw 0
.var_wrd_PlayButtonAnimation:   dw 0
.var_wrd_getReadyAnimation:   dw 0
.var_wrd_waittostart:   dw 0
.var_wrd_BirdX1:   dw 114
.var_wrd_BirdY1:   dw 60
.var_wrd_JumpIncrement:   dw 0
.var_wrd_Jumping:   dw 0
.var_wrd_DoBirdAnimation:   dw 0
.var_wrd_pipe1X:   dw 1
.var_wrd_pipe1y:   dw 143
.var_wrd_Pipe1SizeGab:   dw 5
.var_wrd_Pipe1GabStart:   dw 3
.var_wrd_Top1:   dw 0
.var_wrd_Bot1:   dw 0
.var_wrd_pipe2X:   dw 100
.var_wrd_pipe2y:   dw 143
.var_wrd_Pipe2SizeGab:   dw 5
.var_wrd_Pipe2GabStart:   dw 3
.var_wrd_hasCollide:   dw 0
.var_wrd_Top2:   dw 0
.var_wrd_Bot2:   dw 0
.var_wrd_pipe3X:   dw 200
.var_wrd_pipe3y:   dw 143
.var_wrd_Pipe3SizeGab:   dw 5
.var_wrd_Pipe3GabStart:   dw 3
.var_wrd_Top3:   dw 0
.var_wrd_Bot3:   dw 0
.var_wrd_pipespeed:   dw 1
.var_wrd_DrawFirstLine:   dw 0
.var_wrd_cx1:   dw 0
.var_wrd_cy1:   dw 0
.var_wrd_cw1:   dw 0
.var_wrd_ch1:   dw 0
.var_wrd_cx2:   dw 0
.var_wrd_cy2:   dw 0
.var_wrd_cw2:   dw 0
.var_wrd_ch2:   dw 0
.var_wrd_Digit0:   dw 0
.var_wrd_Digit1:   dw 0
.var_wrd_Digit2:   dw 0
.var_wrd_Digit0High:   dw 0
.var_wrd_Digit1High:   dw 0
.var_wrd_Digit2High:   dw 0
.var_wrd_Digit0Low:   dw 0
.var_wrd_Digit1Low:   dw 0
.var_wrd_Digit2Low:   dw 0
.var_wrd_TopScore:   dw 0
.var_wrd_Score:   dw 0
.var_wrd_waittimer:   dw 0
.var_wrd_falldown:   dw 0
.var_wrd_loading:   dw 0
.var_wrd_Pal1:   dw 0
.var_wrd_Pal2:   dw 0
.var_wrd_Pal3:   dw 0
.var_wrd_Lev:   dw 0
.var_wrd_Loop:   dw 0
.Quigs_String_Data_Start:
.File_Select_Text_Data:         dw File_Select_Text:dw 1:db 0
.Directory_Select_Text_Data:    dw Directory_Select_Text:dw 1:db 0
.Quig_Dialog_1_Data:            dw Quig_Dialog_1:dw 1:db 0
.Quig_Dialog_2_Data:            dw Quig_Dialog_2:dw 1:db 0
.Quig_Dialog_3_Data:            dw Quig_Dialog_3:dw 1:db 0
.Form1_Text_Data:               dw Form1_Text:dw 7:db "Form 1",0
.Form1_Status_Text_Data:        dw Form1_Status_Text:dw 1:db 0
.Quig_String_Count   Equ 7
.Quig_String_End_Text:   db  0,0,0,0,0
.AppTrnBeg
          ds    256
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;0 Message No 16
.Event_Form_ID       db 0         ;1 Event happned on which Form
.Event_Type          db 0         ;2 Type of Event
.Event_UserInput     db 0         ;3 Key or Mouse Event
.Event_Key_ASCII                  ; Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;4 MouseX when event happens
.Event_MouseY        dw 0         ;6 MouseY when event happens
.Event_Control_ID    dw 0         ;8 Control ID No
.Event_8             db 0         ;10
.Event_9             db 0         ;11
.Event_10            db 0         ;12
.Event_11            db 0         ;13
.Quig_Machine_Type   db 0    ;0=464, 1=664, 2=6128, 3=464Plus, 4=6128Plus 6=Enterprise 64/128 7=MSX1 8=MSX2, 9=MSX2+, 10=MSX TurboR 12=PCW8xxx, 13=PCW9xxx
.Quig_Null_String    db 0
.Quig_Dialog_1:      dw Quig_Dialog_1_Data+4,6
.Quig_Dialog_2:      dw Quig_Dialog_2_Data+4,6
.Quig_Dialog_3:      dw Quig_Dialog_3_Data+4,6
.Quig_Dialog_4:      dw AppIcnLrg
.App_Form_List
       dw  Form1_Begin,0,0,0,0,0,0,Form1
.ControWindowDataList
     dw Form1_ControlWindowData
     dw Form1_ControlToolData
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 92
.Form1_SizeAdjust:              db 20
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 0
.Form1_Top:                     dw 0
.Form1_Width:                   dw 200
.Form1_Height:                  dw 122
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 191
.Form1_ContentHeight:           dw 122
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 1024
.Form1_MaxHeight:               dw 212
.Form1_IconAddr:                dw 0
.Form1_Text:                    dw Form1_Text_Data+4
.Form1_Status_Text:             dw Form1_Status_Text_Data+4
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  0
     ds 140,0                   ;Symbos Reserved
.Form1_Menu_List:               
.Form1_Menu:                    
        dw  0
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 1
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
.Form1_ControlWindowData:       
dw 0,255*256+0,2,  0,0,1000,1000,0
.Form1_ControlTool:             
.Form1_ControlToolCount:        db 1
.Form1_ControlToolOwnerID:      db 0
.Form1_ControlToolDataAddr:     dw Form1_ControlToolData
.Form1_ControlToolCalcAddr:     dw 0; Form1_ControlToolCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlToolFocus:        db 0
     db 0
.Form1_ControlToolData:         
dw 0,255*256+0,2,  0,0,1000,1000,0
.SyStud_TimerRoutines    dw 0
.Quig_File_Select_Ext          ds 4
.Quig_File_Select_File         ds 256
.AppTrnEnd
